/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 19)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  return 0;
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XVECEXP (x8, 0, 2);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern20 (x1); /* [-1, 3] */
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  return 0;
}

int
pattern38 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern40 (x3, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern40 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_V8HImode)
      || GET_MODE (x1) != E_V8HImode
      || !s_register_operand (operands[1], E_V8HImode)
      || !s_register_operand (operands[2], i1)
      || !mve_imm_16 (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      return pattern62 (x3, 
E_V16BImode, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8BImode:
      if (pattern62 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4BImode:
      if (pattern62 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern32 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern68 (x3, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern68 (x3, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !s_register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern115 (x3); /* [-1, 2] */
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !immediate_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !immediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern140 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern41 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_DImode))
        return -1;
      return 6;

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arm_general_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!arm_general_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern202 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern201 (x3, 
E_V8BImode, 
E_V8HFmode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SFmode)
          || !mve_imm_32 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern213 (x1, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern213 (x1, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern213 (x1, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_V4SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!vpr_register_operand (operands[4], E_V4BImode))
    return -1;
  return 0;
}

int
pattern233 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 1);
  if (XVECLEN (x9, 0) != 4)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x11 = XVECEXP (x9, 0, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x12 = XVECEXP (x9, 0, 2);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x13 = XVECEXP (x9, 0, 3);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || pattern237 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
    return -1;
  return 0;
}

int
pattern250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern256 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return 0;
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern262 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern262 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern262 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!mem_noofs_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !s_register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[3], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern271 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x8 = XVECEXP (x3, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || XVECLEN (x5, 0) != 2)
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          return pattern237 (x1, 
E_V2SImode, 
E_V4SImode); /* [-1, 0] */

        case E_V2SFmode:
          if (pattern237 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      if (pattern238 (x1) != 0)
        return -1;
      return 2;

    case 8:
      if (pattern239 (x1) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern287 (rtx x1, rtx_code i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return pattern20 (x1); /* [-1, 3] */
}

int
pattern298 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 14
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!shift_nomul_operator (operands[2], E_SImode)
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  if (!shift_amount_operand (operands[4], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern308 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern307 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode
          || !s_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode
          || !s_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern326 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != FLOAT_TRUNCATE
      || GET_MODE (x5) != E_HFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != FLOAT
      || GET_MODE (x6) != E_SFmode
      || !s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_HFmode))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  return 0;
}

int
pattern340 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[6] = x2;
  if (!dominant_cc_register (operands[6], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  if (!arm_add_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x8, 1);
  operands[3] = x10;
  if (!arm_add_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (GET_MODE (x1) != E_V2SImode)
        return -1;
      return 0;

    case E_V4HImode:
      if (GET_MODE (x1) != E_V4HImode)
        return -1;
      return 1;

    case E_V8QImode:
      if (GET_MODE (x1) != E_V8QImode)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern347 (x1, 
E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern347 (x1, 
E_DFmode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern1 (x1, 
E_V16QImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern1 (x1, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern1 (x1, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2SFmode:
      if (pattern1 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 8;

    case E_V4SFmode:
      if (pattern1 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 9;

    case E_V8HFmode:
      if (pattern1 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern369 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mve_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern375 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  if (!power_of_two_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern384 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!arm_comparison_operator (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (!arm_comparison_operator (x6, E_SImode))
    return -1;
  operands[6] = x6;
  return pattern383 (x1, 
i1); /* [-1, 0] */
}

int
pattern391 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mve_memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern398 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mem_noofs_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern403 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x5) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x5) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern420 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 28
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 104
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 104
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x4, 0);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x4, 1);
  operands[1] = x10;
  if (!const_int_operand (operands[1], E_SImode)
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!s_register_operand (operands[0], i1)
      || !s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  if (!s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern449 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  if (!arm_add_operand (x8, E_SImode))
    return -1;
  return 0;
}

int
pattern461 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x7 = XEXP (x3, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern475 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[5] = x8;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[6] = x10;
  return 0;
}

int
pattern486 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode
      || !register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode
      || !register_operand (operands[1], E_V4SFmode)
      || !register_operand (operands[2], E_V8BFmode)
      || !register_operand (operands[3], E_V4BFmode)
      || !const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern496 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MEM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case REG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern502 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  return pattern501 (x2, 
i1, 
i2); /* [-1, 1] */
}

int
pattern508 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern526 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arm_comparison_operator (operands[3], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (!arm_comparison_operator (x4, E_SImode))
    return -1;
  operands[6] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode
      || pattern290 (x3) != 0)
    return -1;
  return 0;
}

int
pattern536 (rtx x1, machine_mode i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern541 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern550 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!arm_rhs_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern559 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern565 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  operands[5] = x8;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  x9 = XEXP (x2, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x10))
    {
    case PLUS:
      return 0;

    case MINUS:
      return 1;

    case IOR:
      return 2;

    case XOR:
      return 3;

    case AND:
      return 4;

    case NOT:
      return 5;

    default:
      return -1;
    }
}

int
pattern581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern589 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern593 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT
      || XWINT (x2, 0) != 32768L)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT
      || XWINT (x3, 0) != 32768L)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != 32768L)
    return -1;
  return 0;
}

int
pattern601 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8HImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern611 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern611 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern612 (x1) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern628 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  switch (XWINT (x7, 0))
    {
    case -16L:
      x8 = XEXP (x5, 1);
      if (XWINT (x8, 0) != 15L)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 1);
      if (XWINT (x11, 0) != -16L)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      x13 = XEXP (x12, 0);
      if (XINT (x13, 1) != 444)
        return -1;
      return 0;

    case -8L:
      x8 = XEXP (x5, 1);
      if (XWINT (x8, 0) != 7L)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 1);
      if (XWINT (x11, 0) != -8L)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      x13 = XEXP (x12, 0);
      if (XINT (x13, 1) != 445)
        return -1;
      return 1;

    case -4L:
      x8 = XEXP (x5, 1);
      if (XWINT (x8, 0) != 3L)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 1);
      if (XWINT (x11, 0) != -4L)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      x13 = XEXP (x12, 0);
      if (XINT (x13, 1) != 446)
        return -1;
      return 2;

    case -2L:
      x8 = XEXP (x5, 1);
      if (XWINT (x8, 0) != 1L)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 1);
      if (XWINT (x11, 0) != -2L)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      x13 = XEXP (x12, 0);
      if (XINT (x13, 1) != 447)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern651 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x3, 1);
  x17 = XVECEXP (x16, 0, 0);
  switch (XWINT (x17, 0))
    {
    case 1L:
      x18 = XVECEXP (x16, 0, 1);
      if (XWINT (x18, 0) != 3L)
        return -1;
      x19 = XEXP (x8, 1);
      x20 = XVECEXP (x19, 0, 0);
      if (XWINT (x20, 0) != 0L)
        return -1;
      x21 = XVECEXP (x19, 0, 1);
      if (XWINT (x21, 0) != 2L)
        return -1;
      return 0;

    case 0L:
      x18 = XVECEXP (x16, 0, 1);
      if (XWINT (x18, 0) != 2L)
        return -1;
      x19 = XEXP (x8, 1);
      x20 = XVECEXP (x19, 0, 0);
      if (XWINT (x20, 0) != 1L)
        return -1;
      x21 = XVECEXP (x19, 0, 1);
      if (XWINT (x21, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (x6, E_SImode)
          || pattern288 (x2) != 0)
        return -1;
      x7 = XEXP (x4, 1);
      if (!arm_not_operand (x7, E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != AND
              || GET_MODE (x9) != E_SImode)
            return -1;
          operands[1] = x6;
          operands[2] = x7;
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x9, 1);
          if (!rtx_equal_p (x12, operands[2])
              || !
#line 3060 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 91; /* *andsi3_compare0 */

        case CLOBBER:
          operands[0] = x6;
          operands[1] = x7;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 3076 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 92; /* *andsi3_compare0_scratch */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x6) != E_SImode
          || pattern288 (x2) != 0)
        return -1;
      x7 = XEXP (x4, 1);
      if (!s_register_operand (x7, E_SImode))
        return -1;
      x13 = XEXP (x6, 0);
      switch (GET_CODE (x13))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[0] = x13;
          if (!shift_operator (operands[0], E_SImode))
            return -1;
          x14 = XEXP (x13, 0);
          operands[1] = x14;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x13, 1);
          operands[2] = x15;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x7;
          x8 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x8))
            {
            case CLOBBER:
              x10 = XEXP (x8, 0);
              operands[4] = x10;
              if (!scratch_operand (operands[4], E_SImode)
                  || !
#line 3637 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 106; /* andsi_not_shiftsi_si_scc_no_reuse */

            case SET:
              x9 = XEXP (x8, 1);
              if (pattern16 (x9, 
NOT, 
AND, 
E_SImode) != 0)
                return -1;
              x11 = XEXP (x9, 0);
              x16 = XEXP (x11, 0);
              switch (GET_CODE (x16))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x16, operands[0]))
                    return -1;
                  x10 = XEXP (x8, 0);
                  operands[4] = x10;
                  if (!s_register_operand (operands[4], E_SImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[3])
                      || !
#line 3661 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 107; /* andsi_not_shiftsi_si_scc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x13;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          operands[1] = x7;
          x8 = XVECEXP (x1, 0, 1);
          switch (pattern588 (x8, 
NOT, 
AND))
            {
            case 0:
              x9 = XEXP (x8, 1);
              x12 = XEXP (x9, 1);
              if (!rtx_equal_p (x12, operands[1])
                  || !
#line 3678 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 108; /* *andsi_notsi_si_compare0 */

            case 1:
              if (!
#line 3691 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 109; /* *andsi_notsi_si_compare0_scratch */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern384 (x1, 
AND) != 0
          || !
#line 10594 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 347; /* *and_scc_scc_cmp */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == E_SImode)
    {
      res = recog_22 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (XINT (x5, 1))
    {
    case 18:
      x9 = XVECEXP (x5, 0, 0);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern576 (x5, 
E_QImode) != 0
              || !
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3089; /* atomic_exchangeqi */

        case E_HImode:
          if (pattern576 (x5, 
E_HImode) != 0
              || !
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3090; /* atomic_exchangehi */

        case E_DImode:
          if (pattern576 (x5, 
E_DImode) != 0
              || !
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3092; /* atomic_exchangedi */

        default:
          return -1;
        }

    case 19:
      x9 = XVECEXP (x5, 0, 0);
      switch (GET_CODE (x9))
        {
        case PLUS:
          switch (pattern568 (x5))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3117; /* atomic_fetch_addqi */

            case 1:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3122; /* atomic_fetch_addhi */

            case 2:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3132; /* atomic_fetch_adddi */

            default:
              return -1;
            }

        case MINUS:
          switch (pattern568 (x5))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3118; /* atomic_fetch_subqi */

            case 1:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3123; /* atomic_fetch_subhi */

            case 2:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3133; /* atomic_fetch_subdi */

            default:
              return -1;
            }

        case IOR:
          switch (pattern568 (x5))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3119; /* atomic_fetch_orqi */

            case 1:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3124; /* atomic_fetch_orhi */

            case 2:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3134; /* atomic_fetch_ordi */

            default:
              return -1;
            }

        case XOR:
          switch (pattern568 (x5))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3120; /* atomic_fetch_xorqi */

            case 1:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3125; /* atomic_fetch_xorhi */

            case 2:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3135; /* atomic_fetch_xordi */

            default:
              return -1;
            }

        case AND:
          switch (pattern568 (x5))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3121; /* atomic_fetch_andqi */

            case 1:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3126; /* atomic_fetch_andhi */

            case 2:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3136; /* atomic_fetch_anddi */

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != AND)
            return -1;
          x11 = XEXP (x10, 1);
          operands[2] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern598 (x5, 
E_QImode) != 0
                  || !
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3137; /* atomic_fetch_nandqi */

            case E_HImode:
              if (pattern598 (x5, 
E_HImode) != 0
                  || !
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3138; /* atomic_fetch_nandhi */

            case E_DImode:
              if (!s_register_operand (operands[0], E_DImode)
                  || !mem_noofs_operand (operands[1], E_DImode)
                  || GET_MODE (x5) != E_DImode
                  || GET_MODE (x9) != E_DImode
                  || GET_MODE (x10) != E_DImode
                  || !s_register_operand (operands[2], E_DImode)
                  || !
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 3;
              return 3140; /* atomic_fetch_nanddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  if (XWINT (x9, 0) != -1L)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x4, 0);
  operands[2] = x11;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x6, 0);
  operands[4] = x12;
  x13 = XEXP (x7, 0);
  operands[0] = x13;
  if (!thumb_cbrch_target_operand (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x10, 0);
  operands[1] = x14;
  if (!scratch_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x8, 0);
  if (!rtx_equal_p (x15, operands[2])
      || !
#line 1474 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
    return -1;
  return 981; /* *cbranchne_decr1 */
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case EQ:
          x6 = XEXP (x5, 1);
          if (pattern297 (x6) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x11) != CLOBBER
              || pattern577 (x1) != 0)
            return -1;
          return 310; /* *stack_protect_combined_test_insn */

        case LEU:
          x7 = XEXP (x3, 1);
          if (pattern266 (x7) != 0)
            return -1;
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != LABEL_REF
              || GET_MODE (x8) != E_SImode
              || pattern551 (x1) != 0)
            return -1;
          x11 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x11) != USE)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != LABEL_REF
              || GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x5, 0);
          operands[0] = x13;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x5, 1);
          operands[1] = x6;
          if (!arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x8, 0);
          operands[3] = x14;
          x10 = XVECEXP (x1, 0, 2);
          x15 = XEXP (x10, 0);
          operands[4] = x15;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x16 = XEXP (x7, 0);
          x17 = XEXP (x16, 0);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[0]))
            return -1;
          x19 = XEXP (x16, 1);
          switch (GET_CODE (x19))
            {
            case REG:
            case SUBREG:
              operands[5] = x19;
              if (!s_register_operand (operands[5], E_SImode))
                return -1;
              x20 = XEXP (x12, 0);
              operands[2] = x20;
              if (!
#line 9599 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 314; /* *arm_casesi_internal */

            case LABEL_REF:
              if (GET_MODE (x19) != E_SImode)
                return -1;
              x21 = XEXP (x19, 0);
              operands[2] = x21;
              x20 = XEXP (x12, 0);
              if (!rtx_equal_p (x20, operands[2])
                  || !
#line 1161 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !flag_pic))
                return -1;
              return 1047; /* *thumb2_casesi_internal */

            default:
              return -1;
            }

        case GTU:
          x13 = XEXP (x5, 0);
          if (pattern298 (x13) != 0)
            return -1;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (pattern528 (x9) != 0)
            return -1;
          x22 = XEXP (x9, 1);
          x23 = XEXP (x22, 1);
          if (GET_CODE (x23) != CONST_INT
              || pattern603 (x1) != 0)
            return -1;
          x11 = XVECEXP (x1, 0, 3);
          if (pattern589 (x11, 
E_CCmode, 
100) != 0)
            return -1;
          switch (pattern628 (x1))
            {
            case 0:
              if (!
#line 4677 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5067; /* predicated_doloop_end_internal16 */

            case 1:
              if (!
#line 4677 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5068; /* predicated_doloop_end_internal8 */

            case 2:
              if (!
#line 4677 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5069; /* predicated_doloop_end_internal4 */

            case 3:
              if (!
#line 4677 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5070; /* predicated_doloop_end_internal2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XINT (x3, 1) != 17)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 0
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x24 = XEXP (x9, 0);
      if (GET_CODE (x24) != REG
          || GET_MODE (x24) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_CODE (x15) != REG
          || GET_MODE (x15) != E_SImode)
        return -1;
      x11 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x11) != CLOBBER)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 100
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          x25 = XVECEXP (x3, 0, 0);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || REGNO (x24) != 14
              || REGNO (x15) != 12
              || GET_MODE (x12) != E_CCmode
              || !
#line 12326 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_SOFT_TP && !TARGET_FDPIC))
            return -1;
          return 408; /* load_tp_soft */

        case 3:
          x25 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x25) != REG
              || REGNO (x25) != 0
              || GET_MODE (x25) != E_SImode
              || REGNO (x24) != 1
              || REGNO (x15) != 14)
            return -1;
          x26 = XVECEXP (x3, 0, 1);
          operands[0] = x26;
          x27 = XVECEXP (x3, 0, 2);
          operands[1] = x27;
          if (GET_MODE (x12) != E_SImode
              || !
#line 12341 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_GNU2_TLS))
            return -1;
          return 409; /* tlscall */

        default:
          return -1;
        }

    case MEM:
      if (pnum_clobbers != NULL
          && pattern25 (x1) == 0
          && pattern624 (x1) == 0
          && pattern637 (x1) == 0
          && 
#line 1063 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        {
          *pnum_clobbers = 2;
          return 973; /* cpymem8b */
        }
      operands[1] = x3;
      if (pattern258 (x1, 
18, 
2) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x9 = XVECEXP (x1, 0, 1);
      x22 = XEXP (x9, 1);
      x28 = XVECEXP (x22, 0, 0);
      operands[2] = x28;
      x29 = XVECEXP (x22, 0, 1);
      operands[3] = x29;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 3);
      x12 = XEXP (x11, 0);
      operands[4] = x12;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      x24 = XEXP (x9, 0);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern576 (x22, 
E_QImode) != 0
              || !
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3089; /* atomic_exchangeqi */

        case E_HImode:
          if (pattern576 (x22, 
E_HImode) != 0
              || !
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3090; /* atomic_exchangehi */

        case E_DImode:
          if (pattern576 (x22, 
E_DImode) != 0
              || !
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3092; /* atomic_exchangedi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x11 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x11) != CLOBBER)
        return -1;
      switch (pattern265 (x1))
        {
        case 0:
          if (!(
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)))
            return -1;
          return 3081; /* atomic_compare_and_swap32qi_1 */

        case 1:
          if (!(
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)))
            return -1;
          return 3083; /* atomic_compare_and_swap32hi_1 */

        case 2:
          if (!(
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)))
            return -1;
          return 3082; /* atomic_compare_and_swapt1qi_1 */

        case 3:
          if (!(
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)))
            return -1;
          return 3084; /* atomic_compare_and_swapt1hi_1 */

        case 4:
          if (!(
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)))
            return -1;
          return 3085; /* atomic_compare_and_swap32si_1 */

        case 5:
          if (!(
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)))
            return -1;
          return 3087; /* atomic_compare_and_swap32di_1 */

        case 6:
          if (!(
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)))
            return -1;
          return 3086; /* atomic_compare_and_swapt1si_1 */

        case 7:
          if (!(
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)))
            return -1;
          return 3088; /* atomic_compare_and_swapt1di_1 */

        case 8:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3093; /* atomic_addqi */

        case 9:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3098; /* atomic_addhi */

        case 10:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3103; /* atomic_addsi */

        case 11:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3108; /* atomic_adddi */

        case 12:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3094; /* atomic_subqi */

        case 13:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3099; /* atomic_subhi */

        case 14:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3104; /* atomic_subsi */

        case 15:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3109; /* atomic_subdi */

        case 16:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3095; /* atomic_orqi */

        case 17:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3100; /* atomic_orhi */

        case 18:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3105; /* atomic_orsi */

        case 19:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3110; /* atomic_ordi */

        case 20:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3096; /* atomic_xorqi */

        case 21:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3101; /* atomic_xorhi */

        case 22:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3106; /* atomic_xorsi */

        case 23:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3111; /* atomic_xordi */

        case 24:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3097; /* atomic_andqi */

        case 25:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3102; /* atomic_andhi */

        case 26:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3107; /* atomic_andsi */

        case 27:
          if (!
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3112; /* atomic_anddi */

        case 28:
          if (!
#line 366 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3113; /* atomic_nandqi */

        case 29:
          if (!
#line 366 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3114; /* atomic_nandhi */

        case 30:
          if (!
#line 366 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3115; /* atomic_nandsi */

        case 31:
          if (!
#line 366 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3116; /* atomic_nanddi */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern22 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3141; /* atomic_add_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3146; /* atomic_add_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3151; /* atomic_add_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3156; /* atomic_add_fetchdi */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern22 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3142; /* atomic_sub_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3147; /* atomic_sub_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3152; /* atomic_sub_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3157; /* atomic_sub_fetchdi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern22 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3143; /* atomic_or_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3148; /* atomic_or_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3153; /* atomic_or_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3158; /* atomic_or_fetchdi */

        default:
          return -1;
        }

    case XOR:
      switch (pattern22 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3144; /* atomic_xor_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3149; /* atomic_xor_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3154; /* atomic_xor_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3159; /* atomic_xor_fetchdi */

        default:
          return -1;
        }

    case AND:
      switch (pattern22 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3145; /* atomic_and_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3150; /* atomic_and_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3155; /* atomic_and_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3160; /* atomic_and_fetchdi */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND
          || pattern258 (x1, 
19, 
3) != 0)
        return -1;
      switch (pattern531 (x1))
        {
        case 0:
          if (!
#line 483 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3161; /* atomic_nand_fetchqi */

        case 1:
          if (!
#line 483 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3162; /* atomic_nand_fetchhi */

        case 2:
          if (!
#line 483 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3163; /* atomic_nand_fetchsi */

        case 3:
          if (!
#line 483 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3164; /* atomic_nand_fetchdi */

        default:
          return -1;
        }

    case SS_MULT:
      if (pattern23 (x1, 
E_SAmode) != 0
          || !
#line 264 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ))
        return -1;
      return 3235; /* *arm_ssmulsa3 */

    case US_MULT:
      if (pattern23 (x1, 
E_USAmode) != 0
          || !
#line 336 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ))
        return -1;
      return 3236; /* *arm_usmulusa3 */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0
          || !
#line 3880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2176; /* neon_vmul_lanev4hi */

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0
          || !
#line 3880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2177; /* neon_vmul_lanev2si */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 3880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2178; /* neon_vmul_lanev2sf */

    case E_V8HImode:
      if (pattern40 (x3, 
E_V4HImode, 
E_V8HImode) != 0
          || !
#line 3897 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2179; /* neon_vmul_lanev8hi */

    case E_V4SImode:
      if (pattern40 (x3, 
E_V2SImode, 
E_V4SImode) != 0
          || !
#line 3897 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2180; /* neon_vmul_lanev4si */

    case E_V4SFmode:
      if (pattern40 (x3, 
E_V2SFmode, 
E_V4SFmode) != 0
          || !
#line 3897 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2181; /* neon_vmul_lanev4sf */

    case E_V8HFmode:
      if (pattern40 (x3, 
E_V4HFmode, 
E_V8HFmode) != 0
          || !
#line 3914 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2182; /* neon_vmul_lanev8hf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 3914 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2183; /* neon_vmul_lanev4hf */

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern428 (x3, 
E_SImode) != 0
          || !
#line 2214 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 933; /* arm_vcx2si */

    case E_DImode:
      if (pattern428 (x3, 
E_DImode) != 0
          || !
#line 2214 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 934; /* arm_vcx2di */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !const_int_mve_cde2_operand (operands[3], E_SImode)
          || !
#line 4460 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5047; /* arm_vcx2qv16qi */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2433; /* neon_vsras_nv8qi */

    case 1:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2437; /* neon_vsras_nv16qi */

    case 2:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2441; /* neon_vsras_nv4hi */

    case 3:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2445; /* neon_vsras_nv8hi */

    case 4:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2449; /* neon_vsras_nv2si */

    case 5:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2453; /* neon_vsras_nv4si */

    case 6:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2457; /* neon_vsras_ndi */

    case 7:
      if (!
#line 4630 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2461; /* neon_vsras_nv2di */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_ccde2_operand (operands[3], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4550 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 143; /* arm_cx2si */

    case 1:
      if (!
#line 4550 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 144; /* arm_cx2di */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!neon_struct_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2646; /* neon_vst1v8qi */

    case E_V16QImode:
      if (!neon_struct_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2647; /* neon_vst1v16qi */

    case E_V4HImode:
      if (!neon_struct_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2648; /* neon_vst1v4hi */

    case E_V8HImode:
      if (!neon_struct_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2649; /* neon_vst1v8hi */

    case E_V2SImode:
      if (!neon_struct_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2650; /* neon_vst1v2si */

    case E_V4SImode:
      if (!neon_struct_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2651; /* neon_vst1v4si */

    case E_V4HFmode:
      if (!neon_struct_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2652; /* neon_vst1v4hf */

    case E_V8HFmode:
      if (!neon_struct_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2653; /* neon_vst1v8hf */

    case E_V4BFmode:
      if (!neon_struct_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !s_register_operand (operands[1], E_V4BFmode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2654; /* neon_vst1v4bf */

    case E_V8BFmode:
      if (!neon_struct_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !s_register_operand (operands[1], E_V8BFmode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2655; /* neon_vst1v8bf */

    case E_V2SFmode:
      if (!neon_struct_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2656; /* neon_vst1v2sf */

    case E_V4SFmode:
      if (!neon_struct_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2657; /* neon_vst1v4sf */

    case E_DImode:
      if (!neon_struct_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_DImode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2658; /* neon_vst1di */

    case E_V2DImode:
      if (!neon_struct_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 5228 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2659; /* neon_vst1v2di */

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !memory_operand (operands[1], E_DImode)
          || !
#line 5005 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_LDRD))
        return -1;
      return 157; /* unaligned_loaddi */

    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !mem_and_no_t1_wback_op (operands[1], E_SImode)
          || !
#line 5016 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(unaligned_access))
        return -1;
      return 158; /* unaligned_loadsi */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1870; /* neon_vpaddluv8qi */

    case 1:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1872; /* neon_vpaddluv16qi */

    case 2:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1874; /* neon_vpaddluv4hi */

    case 3:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1876; /* neon_vpaddluv8hi */

    case 4:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1878; /* neon_vpaddluv2si */

    case 5:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1880; /* neon_vpaddluv4si */

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern149 (x1))
    {
    case 0:
      if (!(
#line 2880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return -1;
      return 1929; /* neon_vcadd270v4hf */

    case 1:
      if (register_operand (operands[0], E_V8HFmode)
          && register_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && (
#line 2880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return 1931; /* neon_vcadd270v8hf */
      if (!s_register_operand (operands[0], E_V8HFmode)
          || !s_register_operand (operands[1], E_V8HFmode)
          || !s_register_operand (operands[2], E_V8HFmode)
          || !
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3739; /* mve_vcaddq_rot270_fv8hf */

    case 2:
      if (!
#line 2880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return -1;
      return 1933; /* neon_vcadd270v2sf */

    case 3:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 2880 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return 1935; /* neon_vcadd270v4sf */
      if (!s_register_operand (operands[0], E_V4SFmode)
          || !s_register_operand (operands[1], E_V4SFmode)
          || !s_register_operand (operands[2], E_V4SFmode)
          || !
#line 1209 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3745; /* mve_vcaddq_rot270_fv4sf */

    case 4:
      if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3563; /* mve_vcaddq_rot270_v16qi */

    case 5:
      if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3567; /* mve_vcaddq_rot270_v8hi */

    case 6:
      if (!
#line 830 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3571; /* mve_vcaddq_rot270_v4si */

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[2], E_V8QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[1], E_V8QImode)
              || !
#line 4671 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2481; /* neon_vtbl1v8qi */

        case E_TImode:
          if (!s_register_operand (operands[1], E_TImode)
              || !
#line 4681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2482; /* neon_vtbl2v8qi */

        case E_EImode:
          if (!s_register_operand (operands[1], E_EImode)
              || !
#line 4702 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2483; /* neon_vtbl3v8qi */

        case E_OImode:
          if (!s_register_operand (operands[1], E_OImode)
              || !
#line 4724 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2484; /* neon_vtbl4v8qi */

        default:
          return -1;
        }

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (pattern415 ())
        {
        case 0:
          if (!
#line 4748 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2485; /* neon_vtbl1v16qi */

        case 1:
          if (!
#line 4779 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2486; /* neon_vtbl2v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 4072 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x16QImode))))
        return -1;
      return 4992; /* mve_vst2qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HImode, 
E_V2x8HImode) != 0
          || !
#line 4072 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HImode))))
        return -1;
      return 4993; /* mve_vst2qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SImode, 
E_V2x4SImode) != 0
          || !
#line 4072 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SImode))))
        return -1;
      return 4994; /* mve_vst2qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HFmode, 
E_V2x8HFmode) != 0
          || !
#line 4072 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HFmode))))
        return -1;
      return 4995; /* mve_vst2qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SFmode, 
E_V2x4SFmode) != 0
          || !
#line 4072 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SFmode))))
        return -1;
      return 4996; /* mve_vst2qv4sf */

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 3298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4852; /* mve_vldrq_z_extend_v8qis */

        case 1:
          if (!
#line 3298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4854; /* mve_vldrq_z_extend_v4qis */

        case 2:
          if (!
#line 3298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4856; /* mve_vldrq_z_extend_v4his */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 3298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4853; /* mve_vldrq_z_extend_v8qiu */

        case 1:
          if (!
#line 3298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4855; /* mve_vldrq_z_extend_v4qiu */

        case 2:
          if (!
#line 3298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4857; /* mve_vldrq_z_extend_v4hiu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2310; /* neon_vqrshluv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2314; /* neon_vqrshluv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2318; /* neon_vqrshluv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2322; /* neon_vqrshluv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2326; /* neon_vqrshluv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2330; /* neon_vqrshluv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2334; /* neon_vqrshludi */

    case 7:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2338; /* neon_vqrshluv2di */

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 2796 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1909; /* neon_vrecpsv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 2796 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1910; /* neon_vrecpsv4sf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 2807 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1911; /* neon_vrecpsv8hf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 2807 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1912; /* neon_vrecpsv4hf */

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern160 (x1, 
E_OImode))
    {
    case 0:
      if (!
#line 5971 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2896; /* neon_vld4v8qi */

    case 1:
      if (!
#line 5971 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2897; /* neon_vld4v4hi */

    case 2:
      if (!
#line 5971 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2898; /* neon_vld4v4hf */

    case 3:
      if (!(
#line 5971 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2899; /* neon_vld4v4bf */

    case 4:
      if (!
#line 5971 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2900; /* neon_vld4v2si */

    case 5:
      if (!
#line 5971 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2901; /* neon_vld4v2sf */

    case 6:
      if (!
#line 5971 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2902; /* neon_vld4di */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern130 (x1))
    {
    case 0:
      if (!
#line 2095 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 920; /* neon_vminnmhf */

    case 1:
      if (!
#line 2106 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
        return -1;
      return 922; /* fminsf3 */

    case 2:
      if (!(
#line 2106 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
        return -1;
      return 924; /* fmindf3 */

    case 3:
      if (!
#line 2725 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1862; /* neon_vminnmv8hf */

    case 4:
      if (!
#line 2725 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1864; /* neon_vminnmv4hf */

    case 5:
      if (!
#line 2736 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1866; /* neon_vminnmv2sf */

    case 6:
      if (!
#line 2736 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1868; /* neon_vminnmv4sf */

    default:
      return -1;
    }
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1830; /* neon_vminuv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1834; /* neon_vminuv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1838; /* neon_vminuv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1842; /* neon_vminuv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1846; /* neon_vminuv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1850; /* neon_vminuv4si */

    default:
      return -1;
    }
}

 int
recog_219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1484; /* neon_vrhaddsv8qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1488; /* neon_vrhaddsv16qi */

    case 2:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1492; /* neon_vrhaddsv4hi */

    case 3:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1496; /* neon_vrhaddsv8hi */

    case 4:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1500; /* neon_vrhaddsv2si */

    case 5:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1504; /* neon_vrhaddsv4si */

    default:
      return -1;
    }
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1711; /* neon_vclev2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1716; /* neon_vclev4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1731; /* neon_vclev8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1736; /* neon_vclev4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!usat16_imm (operands[2], E_SImode)
      || !
#line 6166 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
    return -1;
  return 252; /* arm_usat16_insn */
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern232 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3622 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4919; /* mve_vldrq_gather_shifted_offset_z_v8hi */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3622 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4920; /* mve_vldrq_gather_shifted_offset_z_v4si */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode) != 0
          || !
#line 3622 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4921; /* mve_vldrq_gather_shifted_offset_z_v8hf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V4BImode, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 3622 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4922; /* mve_vldrq_gather_shifted_offset_z_v4sf */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3622 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4923; /* mve_vldrq_gather_shifted_offset_z_v2di */

    default:
      return -1;
    }
}

 int
recog_257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_ccde3_operand (operands[4], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4574 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 147; /* arm_cx3si */

    case 1:
      if (!
#line 4574 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 148; /* arm_cx3di */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 30:
      if (pattern94 (x2, 
104, 
E_CCmode) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode)
          || !
#line 4419 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM_QBIT))
        return -1;
      return 131; /* arm_get_apsr */

    case 25:
      return recog_123 (x1, insn, pnum_clobbers);

    case 26:
      return recog_113 (x1, insn, pnum_clobbers);

    case 45:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 6056 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 190; /* arm_sxtb16 */

    case 46:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 6056 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 191; /* arm_uxtb16 */

    case 1:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (
#line 6711 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && flag_pic))
        return 259; /* pic_load_addr_32bit */
      if (!
#line 6727 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_THUMB1 && flag_pic))
        return -1;
      return 260; /* pic_load_addr_thumb1 */

    case 38:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_SImode)
          || !
#line 9262 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 306; /* probe_stack */

    case 40:
      return recog_133 (x1, insn, pnum_clobbers);

    case 22:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 12201 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2))
        return -1;
      return 400; /* arm_rbit */

    case 17:
      return recog_116 (x1, insn, pnum_clobbers);

    case 15:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode)
          || !
#line 560 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 577; /* iwmmxt_clrdi */

    case 8:
      switch (pattern95 (x1, 
E_SImode))
        {
        case 0:
          if (!
#line 1579 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 671; /* iwmmxt_tmovmskb */

        case 1:
          if (!
#line 1588 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 672; /* iwmmxt_tmovmskh */

        case 2:
          if (!
#line 1597 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 673; /* iwmmxt_tmovmskw */

        default:
          return -1;
        }

    case 7:
      switch (pattern95 (x1, 
E_DImode))
        {
        case 0:
          if (!
#line 1606 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 674; /* iwmmxt_waccb */

        case 1:
          if (!
#line 1615 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 675; /* iwmmxt_wacch */

        case 2:
          if (!
#line 1624 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 676; /* iwmmxt_waccw */

        default:
          return -1;
        }

    case 16:
      return recog_111 (x1, insn, pnum_clobbers);

    case 109:
      return recog_115 (x1, insn, pnum_clobbers);

    case 108:
      return recog_132 (x1, insn, pnum_clobbers);

    case 363:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 788; /* neon_vrndhf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1329; /* neon_vrndv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1335; /* neon_vrndv4hf */

        default:
          return -1;
        }

    case 364:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 789; /* neon_vrndahf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1330; /* neon_vrndav8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1336; /* neon_vrndav4hf */

        default:
          return -1;
        }

    case 366:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 790; /* neon_vrndmhf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1331; /* neon_vrndmv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1337; /* neon_vrndmv4hf */

        default:
          return -1;
        }

    case 367:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 791; /* neon_vrndnhf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1332; /* neon_vrndnv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1338; /* neon_vrndnv4hf */

        default:
          return -1;
        }

    case 368:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 792; /* neon_vrndphf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1333; /* neon_vrndpv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1339; /* neon_vrndpv4hf */

        default:
          return -1;
        }

    case 369:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 793; /* neon_vrndxhf */

        case 1:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1334; /* neon_vrndxv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1340; /* neon_vrndxv4hf */

        default:
          return -1;
        }

    case 365:
      if (GET_MODE (x2) != E_HFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_HFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_HFmode)
          || !
#line 982 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 794; /* neon_vrndihf */

    case 181:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 1907 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 874; /* neon_vcvthshf */

        case 1:
          if (!
#line 1918 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 876; /* neon_vcvthssi */

        default:
          return -1;
        }

    case 182:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 1907 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 875; /* neon_vcvthuhf */

        case 1:
          if (!
#line 1918 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 877; /* neon_vcvthusi */

        default:
          return -1;
        }

    case 183:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 882; /* neon_vcvtahssi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2142; /* neon_vcvtasv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2150; /* neon_vcvtasv4hf */

        default:
          return -1;
        }

    case 184:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 883; /* neon_vcvtahusi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2143; /* neon_vcvtauv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2151; /* neon_vcvtauv4hf */

        default:
          return -1;
        }

    case 185:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 884; /* neon_vcvtmhssi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2144; /* neon_vcvtmsv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2152; /* neon_vcvtmsv4hf */

        default:
          return -1;
        }

    case 186:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 885; /* neon_vcvtmhusi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2145; /* neon_vcvtmuv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2153; /* neon_vcvtmuv4hf */

        default:
          return -1;
        }

    case 187:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 886; /* neon_vcvtnhssi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2146; /* neon_vcvtnsv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2154; /* neon_vcvtnsv4hf */

        default:
          return -1;
        }

    case 188:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 887; /* neon_vcvtnhusi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2147; /* neon_vcvtnuv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2155; /* neon_vcvtnuv4hf */

        default:
          return -1;
        }

    case 189:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 888; /* neon_vcvtphssi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2148; /* neon_vcvtpsv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2156; /* neon_vcvtpsv4hf */

        default:
          return -1;
        }

    case 190:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 889; /* neon_vcvtphusi */

        case 1:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2149; /* neon_vcvtpuv8hf */

        case 2:
          if (!
#line 3832 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2157; /* neon_vcvtpuv4hf */

        default:
          return -1;
        }

    case 32:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 891; /* btruncsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 897; /* btruncdf2 */

        default:
          return -1;
        }

    case 33:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 892; /* ceilsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 898; /* ceildf2 */

        default:
          return -1;
        }

    case 34:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 893; /* floorsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 899; /* floordf2 */

        default:
          return -1;
        }

    case 35:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 894; /* nearbyintsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 900; /* nearbyintdf2 */

        default:
          return -1;
        }

    case 36:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 895; /* rintsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 901; /* rintdf2 */

        default:
          return -1;
        }

    case 37:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 896; /* roundsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 902; /* rounddf2 */

        default:
          return -1;
        }

    case 106:
      if (pattern100 (x1, 
E_SImode, 
14) != 0
          || !
#line 1832 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      return 1076; /* dls_insn */

    case 352:
      return recog_103 (x1, insn, pnum_clobbers);

    case 356:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1219; /* neon_vrintpv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1225; /* neon_vrintpv4sf */

        default:
          return -1;
        }

    case 355:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1220; /* neon_vrintzv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1226; /* neon_vrintzv4sf */

        default:
          return -1;
        }

    case 357:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1221; /* neon_vrintmv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1227; /* neon_vrintmv4sf */

        default:
          return -1;
        }

    case 358:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1222; /* neon_vrintxv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1228; /* neon_vrintxv4sf */

        default:
          return -1;
        }

    case 359:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1223; /* neon_vrintav2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1229; /* neon_vrintav4sf */

        default:
          return -1;
        }

    case 360:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1224; /* neon_vrintnv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1230; /* neon_vrintnv4sf */

        default:
          return -1;
        }

    case 298:
      return recog_131 (x1, insn, pnum_clobbers);

    case 145:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 968 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1397; /* neon_load_count */

    case 250:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V2DImode)
          || !
#line 1236 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
        return -1;
      return 1434; /* arm_reduc_plus_internal_v2di */

    case 251:
      return recog_129 (x1, insn, pnum_clobbers);

    case 252:
      return recog_130 (x1, insn, pnum_clobbers);

    case 261:
      return recog_128 (x1, insn, pnum_clobbers);

    case 277:
      return recog_127 (x1, insn, pnum_clobbers);

    case 170:
      return recog_126 (x1, insn, pnum_clobbers);

    case 293:
      return recog_125 (x1, insn, pnum_clobbers);

    case 173:
      return recog_122 (x1, insn, pnum_clobbers);

    case 174:
      return recog_121 (x1, insn, pnum_clobbers);

    case 172:
      return recog_120 (x1, insn, pnum_clobbers);

    case 240:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3841 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2158; /* neon_vmovnv8hi */

        case 1:
          if (!
#line 3841 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2159; /* neon_vmovnv4si */

        case 2:
          if (!
#line 3841 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2160; /* neon_vmovnv2di */

        default:
          return -1;
        }

    case 274:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3850 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2161; /* neon_vqmovnsv8hi */

        case 1:
          if (!
#line 3850 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2163; /* neon_vqmovnsv4si */

        case 2:
          if (!
#line 3850 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2165; /* neon_vqmovnsv2di */

        default:
          return -1;
        }

    case 275:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3850 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2162; /* neon_vqmovnuv8hi */

        case 1:
          if (!
#line 3850 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2164; /* neon_vqmovnuv4si */

        case 2:
          if (!
#line 3850 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2166; /* neon_vqmovnuv2di */

        default:
          return -1;
        }

    case 276:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3859 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2167; /* neon_vqmovunv8hi */

        case 1:
          if (!
#line 3859 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2168; /* neon_vqmovunv4si */

        case 2:
          if (!
#line 3859 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2169; /* neon_vqmovunv2di */

        default:
          return -1;
        }

    case 238:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 3868 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2170; /* neon_vmovlsv8qi */

        case 1:
          if (!
#line 3868 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2172; /* neon_vmovlsv4hi */

        case 2:
          if (!
#line 3868 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2174; /* neon_vmovlsv2si */

        default:
          return -1;
        }

    case 239:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 3868 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2171; /* neon_vmovluv8qi */

        case 1:
          if (!
#line 3868 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2173; /* neon_vmovluv4hi */

        case 2:
          if (!
#line 3868 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2175; /* neon_vmovluv2si */

        default:
          return -1;
        }

    case 297:
      return recog_106 (x1, insn, pnum_clobbers);

    case 296:
      return recog_112 (x1, insn, pnum_clobbers);

    case 295:
      return recog_119 (x1, insn, pnum_clobbers);

    case 198:
      return recog_105 (x1, insn, pnum_clobbers);

    case 319:
      return recog_104 (x1, insn, pnum_clobbers);

    case 392:
      return recog_107 (x1, insn, pnum_clobbers);

    case 393:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8BFmode)
          || !
#line 6717 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3035; /* neon_vbfcvt_highv8bf */

    case 132:
      switch (pattern110 (x1, 
130))
        {
        case 0:
          if (!
#line 27 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 3043; /* crypto_aesmc */

        case 1:
          if (!
#line 144 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
            return -1;
          return 3052; /* *aarch32_crypto_aese_fused */

        default:
          return -1;
        }

    case 131:
      switch (pattern110 (x1, 
129))
        {
        case 0:
          if (!
#line 27 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 3044; /* crypto_aesimc */

        case 1:
          if (!
#line 183 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
            return -1;
          return 3054; /* *aarch32_crypto_aesd_fused */

        default:
          return -1;
        }

    case 129:
      if (pattern111 (x1) != 0
          || !
#line 60 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3045; /* *crypto_aesd_insn */

    case 130:
      if (pattern111 (x1) != 0
          || !
#line 60 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3046; /* *crypto_aese_insn */

    case 133:
      return recog_110 (x1, insn, pnum_clobbers);

    case 137:
      return recog_118 (x1, insn, pnum_clobbers);

    case 24:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0])
          || !
#line 49 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_MEMORY_BARRIER))
        return -1;
      return 3067; /* *memory_barrier */

    case 399:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3257; /* mve_vrndq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3263; /* mve_vrndq_fv4sf */

        default:
          return -1;
        }

    case 403:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3258; /* mve_vrndaq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3264; /* mve_vrndaq_fv4sf */

        default:
          return -1;
        }

    case 402:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3259; /* mve_vrndmq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3265; /* mve_vrndmq_fv4sf */

        default:
          return -1;
        }

    case 401:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3260; /* mve_vrndnq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3266; /* mve_vrndnq_fv4sf */

        default:
          return -1;
        }

    case 400:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3261; /* mve_vrndpq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3267; /* mve_vrndpq_fv4sf */

        default:
          return -1;
        }

    case 398:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3262; /* mve_vrndxq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3268; /* mve_vrndxq_fv4sf */

        default:
          return -1;
        }

    case 404:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 174 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3269; /* mve_vrev64q_fv8hf */

        case 1:
          if (!
#line 174 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3270; /* mve_vrev64q_fv4sf */

        default:
          return -1;
        }

    case 406:
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V8HFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 204 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3275; /* mve_vrev32q_fv8hf */

    case 408:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 220 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3276; /* mve_vcvtbq_f32_f16v4sf */

    case 407:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 220 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3277; /* mve_vcvttq_f32_f16v4sf */

    case 409:
      switch (pattern114 (x1))
        {
        case 0:
          if (!
#line 235 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3278; /* mve_vcvtq_to_f_sv8hf */

        case 1:
          if (!
#line 235 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3280; /* mve_vcvtq_to_f_sv4sf */

        default:
          return -1;
        }

    case 411:
      switch (pattern114 (x1))
        {
        case 0:
          if (!
#line 235 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3279; /* mve_vcvtq_to_f_uv8hf */

        case 1:
          if (!
#line 235 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3281; /* mve_vcvtq_to_f_uv4sf */

        default:
          return -1;
        }

    case 419:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 250 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3282; /* mve_vrev64q_sv16qi */

        case 1:
          if (!
#line 250 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3284; /* mve_vrev64q_sv8hi */

        case 2:
          if (!
#line 250 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3286; /* mve_vrev64q_sv4si */

        default:
          return -1;
        }

    case 420:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 250 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3283; /* mve_vrev64q_uv16qi */

        case 1:
          if (!
#line 250 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3285; /* mve_vrev64q_uv8hi */

        case 2:
          if (!
#line 250 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3287; /* mve_vrev64q_uv4si */

        default:
          return -1;
        }

    case 433:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 265 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3288; /* mve_vcvtq_from_f_sv8hi */

        case 1:
          if (!
#line 265 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3290; /* mve_vcvtq_from_f_sv4si */

        default:
          return -1;
        }

    case 434:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 265 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3289; /* mve_vcvtq_from_f_uv8hi */

        case 1:
          if (!
#line 265 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3291; /* mve_vcvtq_from_f_uv4si */

        default:
          return -1;
        }

    case 424:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3304; /* mve_vclsq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3307; /* mve_vclsq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3310; /* mve_vclsq_sv4si */

        default:
          return -1;
        }

    case 421:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3305; /* mve_vqabsq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3308; /* mve_vqabsq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3311; /* mve_vqabsq_sv4si */

        default:
          return -1;
        }

    case 410:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3306; /* mve_vqnegq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3309; /* mve_vqnegq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3312; /* mve_vqnegq_sv4si */

        default:
          return -1;
        }

    case 426:
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 354 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3313; /* mve_vaddvq_uv16qi */

        case 1:
          if (!
#line 354 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3315; /* mve_vaddvq_uv8hi */

        case 2:
          if (!
#line 354 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3317; /* mve_vaddvq_uv4si */

        default:
          return -1;
        }

    case 425:
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 354 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3314; /* mve_vaddvq_sv16qi */

        case 1:
          if (!
#line 354 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3316; /* mve_vaddvq_sv8hi */

        case 2:
          if (!
#line 354 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3318; /* mve_vaddvq_sv4si */

        default:
          return -1;
        }

    case 427:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 370 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3319; /* mve_vrev32q_uv16qi */

        case 1:
          if (!
#line 370 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3321; /* mve_vrev32q_uv8hi */

        default:
          return -1;
        }

    case 428:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 370 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3320; /* mve_vrev32q_sv16qi */

        case 1:
          if (!
#line 370 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3322; /* mve_vrev32q_sv8hi */

        default:
          return -1;
        }

    case 431:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3323; /* mve_vmovlbq_sv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3327; /* mve_vmovlbq_sv8hi */

        default:
          return -1;
        }

    case 432:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3324; /* mve_vmovlbq_uv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3328; /* mve_vmovlbq_uv8hi */

        default:
          return -1;
        }

    case 429:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3325; /* mve_vmovltq_uv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3329; /* mve_vmovltq_uv8hi */

        default:
          return -1;
        }

    case 430:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3326; /* mve_vmovltq_sv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3330; /* mve_vmovltq_sv8hi */

        default:
          return -1;
        }

    case 417:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3331; /* mve_vcvtaq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3339; /* mve_vcvtaq_sv4si */

        default:
          return -1;
        }

    case 418:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3332; /* mve_vcvtaq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3340; /* mve_vcvtaq_uv4si */

        default:
          return -1;
        }

    case 439:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3333; /* mve_vcvtmq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3341; /* mve_vcvtmq_sv4si */

        default:
          return -1;
        }

    case 440:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3334; /* mve_vcvtmq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3342; /* mve_vcvtmq_uv4si */

        default:
          return -1;
        }

    case 437:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3335; /* mve_vcvtnq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3343; /* mve_vcvtnq_sv4si */

        default:
          return -1;
        }

    case 438:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3336; /* mve_vcvtnq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3344; /* mve_vcvtnq_uv4si */

        default:
          return -1;
        }

    case 435:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3337; /* mve_vcvtpq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3345; /* mve_vcvtpq_sv4si */

        default:
          return -1;
        }

    case 436:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3338; /* mve_vcvtpq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3346; /* mve_vcvtpq_uv4si */

        default:
          return -1;
        }

    case 416:
      switch (pattern121 (x1))
        {
        case 0:
          if (!
#line 419 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3347; /* mve_vmvnq_n_uv8hi */

        case 1:
          if (!
#line 419 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3349; /* mve_vmvnq_n_uv4si */

        default:
          return -1;
        }

    case 415:
      switch (pattern121 (x1))
        {
        case 0:
          if (!
#line 419 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3348; /* mve_vmvnq_n_sv8hi */

        case 1:
          if (!
#line 419 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3350; /* mve_vmvnq_n_sv4si */

        default:
          return -1;
        }

    case 413:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V16QImode)
          || !
#line 434 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3351; /* mve_vrev16q_uv16qi */

    case 412:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V16QImode)
          || !
#line 434 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3352; /* mve_vrev16q_sv16qi */

    case 441:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V4SImode)
          || !
#line 449 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3353; /* mve_vaddlvq_uv4si */

    case 414:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V4SImode)
          || !
#line 449 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3354; /* mve_vaddlvq_sv4si */

    case 442:
      return recog_114 (x1, insn, pnum_clobbers);

    case 448:
      if (GET_MODE (x2) != E_V16BImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vpr_register_operand (operands[0], E_V16BImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vpr_register_operand (operands[1], E_V16BImode)
          || !
#line 480 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3359; /* mve_vpnotv16bi */

    case 1019:
      return recog_109 (x1, insn, pnum_clobbers);

    case 1021:
      return recog_124 (x1, insn, pnum_clobbers);

    case 1005:
      return recog_108 (x1, insn, pnum_clobbers);

    case 1007:
      return recog_117 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_DUPLICATE:
      x5 = XEXP (x3, 2);
      if (!immediate_operand (x5, E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case TRUNCATE:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern470 (x3, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 676 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 585; /* iwmmxt_tinsrb */

            case E_V4HImode:
              if (pattern470 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 693 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 586; /* iwmmxt_tinsrh */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (GET_MODE (x3) != E_V2SImode
                  || GET_MODE (x4) != E_V2SImode
                  || !nonimmediate_operand (x6, E_SImode))
                return -1;
              operands[2] = x6;
              if (register_operand (operands[0], E_V2SImode))
                {
                  x8 = XEXP (x3, 1);
                  operands[1] = x8;
                  if (register_operand (operands[1], E_V2SImode))
                    {
                      operands[3] = x5;
                      if (
#line 710 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                        return 587; /* iwmmxt_tinsrw */
                    }
                }
              operands[1] = x6;
              if (!s_register_operand (operands[0], E_V2SImode))
                return -1;
              x8 = XEXP (x3, 1);
              operands[3] = x8;
              if (!s_register_operand (operands[3], E_V2SImode))
                return -1;
              operands[2] = x5;
              if (!
#line 324 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1139; /* vec_setv2si_internal */

            case E_V8QImode:
              if (pattern360 (x3, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 324 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1135; /* vec_setv8qi_internal */

            case E_V4HImode:
              if (pattern360 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 324 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1136; /* vec_setv4hi_internal */

            case E_V4HFmode:
              if (pattern360 (x3, 
E_V4HFmode, 
E_HFmode) != 0
                  || !
#line 324 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1137; /* vec_setv4hf_internal */

            case E_V4BFmode:
              if (pattern360 (x3, 
E_V4BFmode, 
E_BFmode) != 0
                  || !
#line 324 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1138; /* vec_setv4bf_internal */

            case E_V2SFmode:
              if (pattern360 (x3, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 324 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1140; /* vec_setv2sf_internal */

            case E_V16QImode:
              if (pattern360 (x3, 
E_V16QImode, 
E_QImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1141; /* vec_setv16qi_internal */
              if (!
#line 4234 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
                return -1;
              return 5019; /* mve_vec_setv16qi_internal */

            case E_V8HImode:
              if (pattern360 (x3, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1142; /* vec_setv8hi_internal */
              if (!
#line 4234 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
                return -1;
              return 5020; /* mve_vec_setv8hi_internal */

            case E_V8HFmode:
              if (pattern360 (x3, 
E_V8HFmode, 
E_HFmode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1143; /* vec_setv8hf_internal */
              if (!
#line 4234 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
                return -1;
              return 5021; /* mve_vec_setv8hf_internal */

            case E_V4SImode:
              if (pattern360 (x3, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1144; /* vec_setv4si_internal */
              if (!
#line 4234 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 5022; /* mve_vec_setv4si_internal */

            case E_V4SFmode:
              if (pattern360 (x3, 
E_V4SFmode, 
E_SFmode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1145; /* vec_setv4sf_internal */
              if (!
#line 4234 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 5023; /* mve_vec_setv4sf_internal */

            case E_V2DImode:
              if (pattern360 (x3, 
E_V2DImode, 
E_DImode) != 0)
                return -1;
              if (
#line 374 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1146; /* vec_setv2di_internal */
              if (!
#line 4253 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5024; /* mve_vec_setv2di_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL)
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != PARALLEL)
        return -1;
      x5 = XEXP (x3, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x11 = XEXP (x8, 0);
      operands[2] = x11;
      switch (XVECLEN (x9, 0))
        {
        case 8:
          if (pattern471 (x9) != 0)
            return -1;
          x12 = XVECEXP (x9, 0, 4);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x9, 0, 5);
          if (GET_CODE (x13) != CONST_INT)
            return -1;
          x14 = XVECEXP (x9, 0, 6);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x15 = XVECEXP (x9, 0, 7);
          if (GET_CODE (x15) != CONST_INT
              || pattern553 (x10, 
8) != 0)
            return -1;
          x16 = XVECEXP (x10, 0, 4);
          if (GET_CODE (x16) != CONST_INT)
            return -1;
          x17 = XVECEXP (x10, 0, 5);
          if (GET_CODE (x17) != CONST_INT)
            return -1;
          x18 = XVECEXP (x10, 0, 6);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XVECEXP (x10, 0, 7);
          if (GET_CODE (x19) != CONST_INT
              || XWINT (x5, 0) != 85L
              || pattern582 (x3, 
E_V8QImode) != 0)
            return -1;
          x20 = XVECEXP (x9, 0, 0);
          switch (XWINT (x20, 0))
            {
            case 4L:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 0L)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 5L)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 1L
                  || XWINT (x12, 0) != 6L
                  || XWINT (x13, 0) != 2L
                  || XWINT (x14, 0) != 7L
                  || XWINT (x15, 0) != 3L)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 4L)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 1L)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 5L
                  || XWINT (x16, 0) != 2L
                  || XWINT (x17, 0) != 6L
                  || XWINT (x18, 0) != 3L
                  || XWINT (x19, 0) != 7L
                  || !
#line 1029 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 621; /* iwmmxt_wunpckihb */

            case 0L:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 4L)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 1L)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 5L
                  || XWINT (x12, 0) != 2L
                  || XWINT (x13, 0) != 6L
                  || XWINT (x14, 0) != 3L
                  || XWINT (x15, 0) != 7L)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 4L)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 0L)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 5L)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 1L
                  || XWINT (x16, 0) != 6L
                  || XWINT (x17, 0) != 2L
                  || XWINT (x18, 0) != 7L
                  || XWINT (x19, 0) != 3L
                  || !
#line 1093 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 624; /* iwmmxt_wunpckilb */

            default:
              return -1;
            }

        case 4:
          if (pattern471 (x9) != 0
              || pattern553 (x10, 
4) != 0
              || XWINT (x5, 0) != 5L
              || pattern582 (x3, 
E_V4HImode) != 0)
            return -1;
          x20 = XVECEXP (x9, 0, 0);
          switch (XWINT (x20, 0))
            {
            case 2L:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 0L)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 3L)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 1L)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 2L)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 1L)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 3L
                  || !
#line 1049 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 622; /* iwmmxt_wunpckihh */

            case 0L:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 2L)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 1L)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 3L)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 2L)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 0L)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 3L)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 1L
                  || !
#line 1113 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 625; /* iwmmxt_wunpckilh */

            default:
              return -1;
            }

        case 2:
          x20 = XVECEXP (x9, 0, 0);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XVECEXP (x9, 0, 1);
          if (GET_CODE (x21) != CONST_INT
              || XVECLEN (x10, 0) != 2)
            return -1;
          x24 = XVECEXP (x10, 0, 0);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          x25 = XVECEXP (x10, 0, 1);
          if (GET_CODE (x25) != CONST_INT
              || XWINT (x5, 0) != 1L
              || pattern582 (x3, 
E_V2SImode) != 0)
            return -1;
          switch (XWINT (x20, 0))
            {
            case 1L:
              if (XWINT (x21, 0) != 0L
                  || XWINT (x24, 0) != 0L
                  || XWINT (x25, 0) != 1L
                  || !
#line 1065 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 623; /* iwmmxt_wunpckihw */

            case 0L:
              if (XWINT (x21, 0) != 1L
                  || XWINT (x24, 0) != 1L
                  || XWINT (x25, 0) != 0L
                  || !
#line 1129 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 626; /* iwmmxt_wunpckilw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MINUS:
      if (pattern249 (x3, 
SS_PLUS) != 0
          || !
#line 81 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 693; /* iwmmxt_waddsubhx */

    case SS_PLUS:
      if (pattern249 (x3, 
SS_MINUS) != 0
          || !
#line 99 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 694; /* iwmmxt_wsubaddhx */

    default:
      return -1;
    }
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case SMAX:
      res = recog_279 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMIN:
      res = recog_280 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UMAX:
      switch (pattern240 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 4170 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 122; /* *arm_umaxsi3 */
            }
          break;

        case 1:
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 913 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 606; /* *umaxv2si3_iwmmxt */
          if (s_register_operand (operands[0], E_V2SImode)
              && s_register_operand (operands[1], E_V2SImode)
              && s_register_operand (operands[2], E_V2SImode)
              && 
#line 870 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1353; /* *umaxv2si3_neon */
          break;

        case 2:
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 913 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 607; /* *umaxv4hi3_iwmmxt */
          if (s_register_operand (operands[0], E_V4HImode)
              && s_register_operand (operands[1], E_V4HImode)
              && s_register_operand (operands[2], E_V4HImode)
              && 
#line 870 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1351; /* *umaxv4hi3_neon */
          break;

        case 3:
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 913 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 608; /* *umaxv8qi3_iwmmxt */
          if (s_register_operand (operands[0], E_V8QImode)
              && s_register_operand (operands[1], E_V8QImode)
              && s_register_operand (operands[2], E_V8QImode)
              && 
#line 870 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1349; /* *umaxv8qi3_neon */
          break;

        case 4:
          if (
#line 870 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1350; /* *umaxv16qi3_neon */
          if (
#line 916 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3614; /* mve_vmaxq_uv16qi */
          break;

        case 5:
          if (
#line 870 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1352; /* *umaxv8hi3_neon */
          if (
#line 916 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3618; /* mve_vmaxq_uv8hi */
          break;

        case 6:
          if (
#line 870 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1354; /* *umaxv4si3_neon */
          if (
#line 916 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3622; /* mve_vmaxq_uv4si */
          break;

        case 7:
          if (
#line 1129 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1420; /* quad_halves_umaxv4si */
          break;

        case 8:
          if (
#line 1157 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1428; /* quad_halves_umaxv8hi */
          break;

        case 9:
          if (
#line 1176 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1433; /* quad_halves_umaxv16qi */
          break;

        default:
          break;
        }
      break;

    case UMIN:
      switch (pattern240 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 4203 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 123; /* *arm_uminsi3 */
            }
          break;

        case 1:
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 933 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 612; /* *uminv2si3_iwmmxt */
          if (s_register_operand (operands[0], E_V2SImode)
              && s_register_operand (operands[1], E_V2SImode)
              && s_register_operand (operands[2], E_V2SImode)
              && 
#line 861 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1347; /* *uminv2si3_neon */
          break;

        case 2:
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 933 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 613; /* *uminv4hi3_iwmmxt */
          if (s_register_operand (operands[0], E_V4HImode)
              && s_register_operand (operands[1], E_V4HImode)
              && s_register_operand (operands[2], E_V4HImode)
              && 
#line 861 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1345; /* *uminv4hi3_neon */
          break;

        case 3:
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 933 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 614; /* *uminv8qi3_iwmmxt */
          if (s_register_operand (operands[0], E_V8QImode)
              && s_register_operand (operands[1], E_V8QImode)
              && s_register_operand (operands[2], E_V8QImode)
              && 
#line 861 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1343; /* *uminv8qi3_neon */
          break;

        case 4:
          if (
#line 861 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1344; /* *uminv16qi3_neon */
          if (
#line 916 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3616; /* mve_vminq_uv16qi */
          break;

        case 5:
          if (
#line 861 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1346; /* *uminv8hi3_neon */
          if (
#line 916 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3620; /* mve_vminq_uv8hi */
          break;

        case 6:
          if (
#line 861 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1348; /* *uminv4si3_neon */
          if (
#line 916 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3624; /* mve_vminq_uv4si */
          break;

        case 7:
          if (
#line 1129 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1419; /* quad_halves_uminv4si */
          break;

        case 8:
          if (
#line 1157 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1427; /* quad_halves_uminv8hi */
          break;

        case 9:
          if (
#line 1176 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1432; /* quad_halves_uminv16qi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (s_register_operand (operands[2], E_SImode)
      && memory_operand (operands[0], E_SImode))
    {
      operands[3] = x3;
      if (minmax_operator (operands[3], E_SImode)
          && 
#line 4227 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && optimize_function_for_size_p (cfun) && !arm_restrict_it))
        {
          *pnum_clobbers = 1;
          return 124; /* *store_minmaxsi */
        }
    }
  if (!arm_rhs_operand (operands[2], E_SImode)
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case SMAX:
      if (!
#line 34 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1007; /* *thumb2_smaxsi3 */

    case SMIN:
      if (!
#line 55 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1008; /* *thumb2_sminsi3 */

    case UMAX:
      if (!
#line 76 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1009; /* *thumb32_umaxsi3 */

    case UMIN:
      if (!
#line 97 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1010; /* *thumb2_uminsi3 */

    default:
      return -1;
    }
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!
#line 4360 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 127; /* arm_qadd_insn */

    case 1:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 351 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 555; /* ssaddv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1429 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1454; /* *ss_addv8qi_neon */

    case 2:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 556; /* ssaddv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1429 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1455; /* *ss_addv4hi_neon */

    case 3:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 371 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 557; /* ssaddv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1429 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1456; /* *ss_addv2si_neon */

    case 4:
      if (!
#line 1429 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1457; /* *ss_addv2sf_neon */

    case 5:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3200; /* *arm_ssaddv4qq3 */

    case 6:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3201; /* *arm_ssaddv2hq3 */

    case 7:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3202; /* *arm_ssaddqq3 */

    case 8:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3203; /* *arm_ssaddhq3 */

    case 9:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3204; /* *arm_ssaddv2ha3 */

    case 10:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3205; /* *arm_ssaddha3 */

    case 11:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3206; /* *arm_ssaddsq3 */

    case 12:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3207; /* *arm_ssaddsa3 */

    default:
      return -1;
    }
}

 int
recog_320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 451 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 567; /* ussubv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1456 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1466; /* *us_subv8qi_neon */

    case 1:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 461 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 568; /* ussubv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1456 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1467; /* *us_subv4hi_neon */

    case 2:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 471 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 569; /* ussubv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1456 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1468; /* *us_subv2si_neon */

    case 3:
      if (!
#line 1456 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1469; /* *us_subv2sf_neon */

    case 4:
      if (!
#line 115 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3221; /* ussubv4uqq3 */

    case 5:
      if (!
#line 115 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3222; /* ussubv2uhq3 */

    case 6:
      if (!
#line 115 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3223; /* ussubuqq3 */

    case 7:
      if (!
#line 115 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3224; /* ussubuhq3 */

    case 8:
      if (!
#line 115 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3225; /* ussubv2uha3 */

    case 9:
      if (!
#line 115 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3226; /* ussubuha3 */

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (x4))
        {
        case E_SFmode:
          if (!s_register_operand (operands[1], E_SFmode)
              || !
#line 1531 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 845; /* fixuns_truncsfsi2 */

        case E_DFmode:
          if (!s_register_operand (operands[1], E_DFmode)
              || !
#line 1540 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 846; /* fixuns_truncdfsi2 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern252 (x3))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 906; /* lceilusfsi2 */

        case 1:
          if (!(
#line 2053 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 912; /* lceiludfsi2 */

        case 2:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 907; /* lfloorusfsi2 */

        case 3:
          if (!(
#line 2053 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 913; /* lfloorudfsi2 */

        case 4:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 908; /* lroundusfsi2 */

        case 5:
          if (!(
#line 2053 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 914; /* lroundudfsi2 */

        case 6:
          if (!
#line 717 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1234; /* neon_vcvtpuv2sfv2si */

        case 7:
          if (!
#line 717 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1240; /* neon_vcvtpuv4sfv4si */

        case 8:
          if (!
#line 717 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1235; /* neon_vcvtmuv2sfv2si */

        case 9:
          if (!
#line 717 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1241; /* neon_vcvtmuv4sfv4si */

        case 10:
          if (!
#line 717 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1236; /* neon_vcvtauv2sfv2si */

        case 11:
          if (!
#line 717 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1242; /* neon_vcvtauv4sfv4si */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 3709 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2106; /* fixuns_truncv2sfv2si2 */

        case 1:
          if (!
#line 3709 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2107; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  switch (XINT (x5, 1))
    {
    case 47:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6502; /* *p arm_qadd8 */

    case 48:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6503; /* *p arm_qsub8 */

    case 49:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6504; /* *p arm_shadd8 */

    case 50:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6505; /* *p arm_shsub8 */

    case 51:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6506; /* *p arm_uhadd8 */

    case 52:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6507; /* *p arm_uhsub8 */

    case 53:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6508; /* *p arm_uqadd8 */

    case 54:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6509; /* *p arm_uqsub8 */

    case 55:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6510; /* *p arm_qadd16 */

    case 56:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6511; /* *p arm_qasx */

    case 57:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6512; /* *p arm_qsax */

    case 58:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6513; /* *p arm_qsub16 */

    case 59:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6514; /* *p arm_shadd16 */

    case 60:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6515; /* *p arm_shasx */

    case 61:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6516; /* *p arm_shsax */

    case 62:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6517; /* *p arm_shsub16 */

    case 63:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6518; /* *p arm_uhadd16 */

    case 64:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6519; /* *p arm_uhasx */

    case 65:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6520; /* *p arm_uhsax */

    case 66:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6521; /* *p arm_uhsub16 */

    case 67:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6522; /* *p arm_uqadd16 */

    case 68:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6523; /* *p arm_uqasx */

    case 69:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6524; /* *p arm_uqsax */

    case 70:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6525; /* *p arm_uqsub16 */

    case 71:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6526; /* *p arm_smusd */

    case 72:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6527; /* *p arm_smusdx */

    case 43:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6528; /* *p arm_sxtab16 */

    case 44:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6529; /* *p arm_uxtab16 */

    case 73:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6530; /* *p arm_usad8 */

    case 98:
      if (pattern517 (x5) != 0)
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6556; /* *p arm_smuad_insn */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6557; /* *p arm_smuad_setq_insn */

    case 99:
      if (pattern517 (x5) != 0)
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6558; /* *p arm_smuadx_insn */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6559; /* *p arm_smuadx_setq_insn */

    case 100:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || !s_register_operand (operands[1], E_SImode)
          || !ssat16_imm (operands[2], E_SImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6560; /* *p arm_ssat16_insn */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6561; /* *p arm_ssat16_setq_insn */

    case 101:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || !s_register_operand (operands[1], E_SImode)
          || !usat16_imm (operands[2], E_SImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6562; /* *p arm_usat16_insn */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6563; /* *p arm_usat16_setq_insn */

    case 13:
      if (pattern518 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 528 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6712; /* *p iwmmxt_wmacsz */

    case 14:
      if (pattern518 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 549 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6714; /* *p iwmmxt_wmacuz */

    case 6:
      if (GET_MODE (x5) != E_V4HImode
          || !register_operand (operands[0], E_V4HImode)
          || !register_operand (operands[1], E_V4HImode)
          || !immediate_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 780 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6731; /* *p iwmmxt_wshufh */

    case 10:
      if (GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[0], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode)
              || !register_operand (operands[2], E_V8QImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1750 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6823; /* *p iwmmxt_wsadbz */

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1760 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6824; /* *p iwmmxt_wsadhz */

        default:
          return -1;
        }

    case 113:
      if (pattern519 (x5, 
E_V4HImode) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 371 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6848; /* *p iwmmxt_wqmulm */

    case 112:
      if (pattern519 (x5, 
E_V2SImode) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 381 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6849; /* *p iwmmxt_wqmulwm */

    case 111:
      if (pattern519 (x5, 
E_V4HImode) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 391 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6850; /* *p iwmmxt_wqmulmr */

    case 110:
      if (pattern519 (x5, 
E_V2SImode) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 401 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6851; /* *p iwmmxt_wqmulwmr */

    case 1069:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4274 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7059; /* *p mve_uqrshll_sat64_di */

    case 1070:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4274 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7060; /* *p mve_uqrshll_sat48_di */

    case 1071:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4286 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7061; /* *p mve_sqrshrl_sat64_di */

    case 1072:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4286 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7062; /* *p mve_sqrshrl_sat48_di */

    case 1068:
      if (pattern521 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7063; /* *p mve_uqrshl_si */

    case 1067:
      if (pattern521 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4310 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7064; /* *p mve_sqrshr_si */

    case 1066:
      if (pattern522 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4333 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7066; /* *p mve_urshrl_di */

    case 1065:
      if (pattern523 (x5, 
E_SImode) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4356 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7068; /* *p mve_urshr_si */

    case 1064:
      if (pattern523 (x5, 
E_DImode) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4379 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7070; /* *p mve_srshr_si */

    case 1063:
      if (pattern522 (x5) != 0
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4391 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7071; /* *p mve_srshrl_di */

    default:
      return -1;
    }
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case SS_TRUNCATE:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != SS_TRUNCATE)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      switch (pattern492 (x6))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 946 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6753; /* *p iwmmxt_wpackhss */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 957 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6754; /* *p iwmmxt_wpackwss */

        case 2:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 968 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6755; /* *p iwmmxt_wpackdss */

        default:
          return -1;
        }

    case US_TRUNCATE:
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[1] = x9;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != US_TRUNCATE)
            return -1;
          switch (pattern492 (x6))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 979 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6756; /* *p iwmmxt_wpackhus */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 990 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6757; /* *p iwmmxt_wpackwus */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1001 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6758; /* *p iwmmxt_wpackdus */

            default:
              return -1;
            }

        case SS_PLUS:
          if (GET_MODE (x9) != E_V4HImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_V4HImode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != VEC_SELECT
              || GET_MODE (x11) != E_V4QImode)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 4)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XVECEXP (x12, 0, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x15 = XVECEXP (x12, 0, 2);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x16 = XVECEXP (x12, 0, 3);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CONST_VECTOR
              || XVECLEN (x8, 0) != 4
              || GET_MODE (x8) != E_V4QImode)
            return -1;
          x17 = XVECEXP (x8, 0, 0);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x8, 0, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XVECEXP (x8, 0, 2);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x8, 0, 3);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_V8QImode)
              || GET_MODE (x6) != E_V8QImode
              || GET_MODE (x7) != E_V4QImode)
            return -1;
          x21 = XEXP (x9, 0);
          operands[1] = x21;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          x22 = XEXP (x11, 0);
          operands[2] = x22;
          if (!register_operand (operands[2], E_V8QImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 433 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6853; /* *p iwmmxt_waddbhusl */

        default:
          return -1;
        }

    case CONST_VECTOR:
      if (XVECLEN (x7, 0) != 4
          || GET_MODE (x7) != E_V4QImode)
        return -1;
      x23 = XVECEXP (x7, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x7, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x25 = XVECEXP (x7, 0, 2);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x26 = XVECEXP (x7, 0, 3);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != US_TRUNCATE
          || GET_MODE (x8) != E_V4QImode)
        return -1;
      x27 = XEXP (x8, 0);
      if (GET_CODE (x27) != SS_PLUS
          || GET_MODE (x27) != E_V4HImode)
        return -1;
      x28 = XEXP (x27, 1);
      if (pattern600 (x28, 
E_V4QImode, 
E_V4HImode, 
ZERO_EXTEND) != 0)
        return -1;
      x29 = XEXP (x28, 0);
      x30 = XEXP (x29, 1);
      if (GET_CODE (x30) != PARALLEL
          || XVECLEN (x30, 0) != 4)
        return -1;
      x31 = XVECEXP (x30, 0, 0);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x30, 0, 1);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x33 = XVECEXP (x30, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x34 = XVECEXP (x30, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x6) != E_V8QImode)
        return -1;
      x35 = XEXP (x27, 0);
      operands[1] = x35;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x36 = XEXP (x29, 0);
      operands[2] = x36;
      if (!register_operand (operands[2], E_V8QImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 417 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6852; /* *p iwmmxt_waddbhusm */

    default:
      return -1;
    }
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 25
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      operands[1] = x8;
      if (!mem_and_no_t1_wback_op (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5046 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(unaligned_access)))
        return -1;
      return 6476; /* *p unaligned_loadhiu */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5688 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
            return 6487; /* *p *arm_zero_extendhisi2 */
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5699 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return 6488; /* *p *arm_zero_extendhisi2_v6 */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1107 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6984; /* *p *thumb2_zero_extendhisi2_v6 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5757 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6)))
            return 6490; /* *p *arm_zero_extendqisi2 */
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5769 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return 6491; /* *p *arm_zero_extendqisi2_v6 */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1120 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6985; /* *p thumb2_zero_extendqisi2_v6 */

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern543 (x5))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 725 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6726; /* *p iwmmxt_textrmub */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 747 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6728; /* *p iwmmxt_textrmuh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != FIX)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (x4))
        {
        case E_SFmode:
          if (!s_register_operand (operands[1], E_SFmode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1512 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6949; /* *p *truncsisf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[1], E_DFmode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1521 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6950; /* *p *truncsidf2_vfp */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x6) != E_SFmode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SFmode))
        return -1;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      if (!const_double_vcvt_power_of_two (operands[2], E_VOIDmode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1895 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math)))
        return -1;
      return 6971; /* *p *combine_vcvtf2i */

    default:
      return -1;
    }
}

 int
recog_367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (s_register_operand (x4, E_SImode))
    {
      res = recog_366 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 15
      || GET_MODE (x8) != E_SImode)
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x9 = XVECEXP (x5, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      switch (XINT (x5, 1))
        {
        case 116:
          if (XINT (x7, 1) != 116)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6879; /* *p iwmmxt_tandcv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6880; /* *p iwmmxt_tandcv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6881; /* *p iwmmxt_tandcv8qi3 */

            default:
              return -1;
            }

        case 117:
          if (XINT (x7, 1) != 117)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6882; /* *p iwmmxt_torcv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6883; /* *p iwmmxt_torcv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6884; /* *p iwmmxt_torcv8qi3 */

            default:
              return -1;
            }

        case 118:
          if (XINT (x7, 1) != 118)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6885; /* *p iwmmxt_torvscv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6886; /* *p iwmmxt_torvscv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6887; /* *p iwmmxt_torvscv8qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x5, 1) != 119)
        return -1;
      x9 = XVECEXP (x5, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XINT (x7, 1) != 119)
        return -1;
      x10 = XEXP (x1, 0);
      operands[1] = x10;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 1);
      operands[0] = x12;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_V2SImode:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6888; /* *p iwmmxt_textrcv2si3 */

        case E_V4HImode:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6889; /* *p iwmmxt_textrcv4hi3 */

        case E_V8QImode:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc-15.1.0/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6890; /* *p iwmmxt_textrcv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_37 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_38 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_39 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_40 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_41 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          res = recog_42 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 2)
        {
          res = recog_43 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 4)
        {
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 5)
        {
          res = recog_45 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 3)
        {
          res = recog_46 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 2)
        {
          res = recog_47 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 1
          && load_multiple_operation (operands[0], E_VOIDmode))
        {
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == SET)
            {
              x3 = XEXP (x2, 1);
              if (GET_CODE (x3) == MEM
                  && GET_MODE (x3) == E_SImode)
                {
                  x4 = XEXP (x2, 0);
                  operands[2] = x4;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x5 = XEXP (x3, 0);
                      operands[1] = x5;
                      if (s_register_operand (operands[1], E_SImode)
                          && 
#line 12828 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                        return 494; /* *load_multiple */
                    }
                }
            }
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != PLUS
              || GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 0);
          if (pattern453 (x10) != 0)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x3, 1);
          operands[2] = x11;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x6, 1);
          operands[3] = x12;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          x14 = XEXP (x13, 1);
          operands[5] = x14;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x15 = XEXP (x9, 1);
          operands[4] = x15;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x16 = XEXP (x8, 0);
          if (!rtx_equal_p (x16, operands[0]))
            return -1;
          x17 = XEXP (x8, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x13, 0);
          if (!rtx_equal_p (x18, operands[0])
              || !
#line 316 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && INTVAL (operands[5]) == INTVAL (operands[2]) + 4))
            return -1;
          return 1017; /* *thumb2_storewb_pairsi */

        case 4:
          if (pattern0 (x1, 
18) != 0
              || pattern257 (x1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x6, 1);
          x19 = XVECEXP (x12, 0, 0);
          operands[2] = x19;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x21 = XVECEXP (x1, 0, 3);
          x22 = XEXP (x21, 0);
          operands[4] = x22;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1])
              || !
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3091; /* atomic_exchangesi */

        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x12 = XEXP (x6, 1);
          if (GET_CODE (x12) != UNSPEC_VOLATILE
              || XVECLEN (x12, 0) != 2)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x12) != E_SImode)
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          switch (XINT (x12, 1))
            {
            case 18:
              x19 = XVECEXP (x12, 0, 0);
              operands[2] = x19;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3091; /* atomic_exchangesi */

            case 19:
              x19 = XVECEXP (x12, 0, 0);
              if (GET_MODE (x19) != E_SImode)
                return -1;
              switch (pattern579 (x19))
                {
                case 0:
                  if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3127; /* atomic_fetch_addsi */

                case 1:
                  if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3128; /* atomic_fetch_subsi */

                case 2:
                  if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3129; /* atomic_fetch_orsi */

                case 3:
                  if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3130; /* atomic_fetch_xorsi */

                case 4:
                  if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3131; /* atomic_fetch_andsi */

                case 5:
                  if (!
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3139; /* atomic_fetch_nandsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 5:
          if (pattern0 (x1, 
19) != 0)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          if (pattern318 (x9, 
E_CCmode, 
100) != 0)
            return -1;
          x21 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x21) != CLOBBER)
            return -1;
          x23 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x23) != CLOBBER)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x6, 1);
          x19 = XVECEXP (x12, 0, 0);
          if (GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x22 = XEXP (x21, 0);
          operands[4] = x22;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x24 = XEXP (x23, 0);
          operands[5] = x24;
          if (!scratch_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          switch (pattern579 (x19))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3127; /* atomic_fetch_addsi */

            case 1:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3128; /* atomic_fetch_subsi */

            case 2:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3129; /* atomic_fetch_orsi */

            case 3:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3130; /* atomic_fetch_xorsi */

            case 4:
              if (!
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3131; /* atomic_fetch_andsi */

            case 5:
              if (!
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3139; /* atomic_fetch_nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      return recog_376 (x1, insn, pnum_clobbers);

    case RETURN:
      if (!
#line 9022 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && USE_RETURN_INSN (FALSE)))
        return -1;
      return 298; /* *arm_return */

    case SIMPLE_RETURN:
      if (
#line 9083 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
        return 303; /* *arm_simple_return */
      if (
#line 1210 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !IS_CMSE_ENTRY (arm_current_func_type ())))
        return 1049; /* *thumb2_return */
      if (!
#line 1218 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && IS_CMSE_ENTRY (arm_current_func_type ())))
        return -1;
      return 1050; /* *thumb2_cmse_entry_return */

    case UNSPEC_VOLATILE:
      return recog_377 (x1, insn, pnum_clobbers);

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 317; /* nop */

    case TRAP_IF:
      x25 = XEXP (x1, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XEXP (x1, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 318; /* trap */

    case PREFETCH:
      x25 = XEXP (x1, 0);
      operands[0] = x25;
      if (!address_operand (operands[0], E_SImode))
        return -1;
      x26 = XEXP (x1, 1);
      operands[1] = x26;
      x27 = XEXP (x1, 2);
      operands[2] = x27;
      if (!
#line 12229 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch5te))
        return -1;
      return 402; /* prefetch */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 4
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 403; /* force_register_use */

    case COND_EXEC:
      x25 = XEXP (x1, 0);
      if (!arm_comparison_operator (x25, E_VOIDmode))
        return -1;
      x28 = XEXP (x25, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x29 = XEXP (x25, 0);
      if (!cc_register (x29, E_VOIDmode))
        return -1;
      x26 = XEXP (x1, 1);
      switch (GET_CODE (x26))
        {
        case SET:
          return recog_375 (x1, insn, pnum_clobbers);

        case PARALLEL:
          if (XVECLEN (x26, 0) == 2)
            {
              res = recog_369 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x26;
          if (XVECLEN (operands[0], 0) >= 2)
            {
              res = recog_370 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 4)
            {
              res = recog_371 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 5)
            {
              res = recog_372 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 3)
            {
              res = recog_373 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 2)
            {
              res = recog_374 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) < 1)
            return -1;
          x30 = XVECEXP (x26, 0, 0);
          switch (GET_CODE (x30))
            {
            case SET:
              x31 = XEXP (x30, 1);
              switch (GET_CODE (x31))
                {
                case MEM:
                  if (GET_MODE (x31) != E_SImode)
                    return -1;
                  operands[3] = x25;
                  operands[4] = x29;
                  if (!load_multiple_operation (operands[0], E_VOIDmode))
                    return -1;
                  x32 = XEXP (x30, 0);
                  operands[2] = x32;
                  if (!s_register_operand (operands[2], E_SImode))
                    return -1;
                  x33 = XEXP (x31, 0);
                  operands[1] = x33;
                  if (!s_register_operand (operands[1], E_SImode)
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12828 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed)))
                    return -1;
                  return 6670; /* *p *load_multiple */

                case CONST_INT:
                  if (XWINT (x31, 0) != 0L)
                    return -1;
                  operands[2] = x25;
                  operands[3] = x29;
                  if (!clear_multiple_operation (operands[0], E_VOIDmode))
                    return -1;
                  x32 = XEXP (x30, 0);
                  operands[1] = x32;
                  if (!register_operand (operands[1], E_SImode)
                      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1711 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed)))
                    return -1;
                  return 6999; /* *p *clear_multiple */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x30, 0) != 1
                  || XINT (x30, 1) != 55)
                return -1;
              x34 = XVECEXP (x30, 0, 0);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              operands[1] = x25;
              operands[2] = x29;
              if (!clear_vfp_multiple_operation (operands[0], E_VOIDmode)
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1688 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed)))
                return -1;
              return 6961; /* *p *clear_vfp_multiple */

            default:
              return -1;
            }

        case RETURN:
          operands[0] = x25;
          operands[1] = x29;
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9022 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && USE_RETURN_INSN (FALSE))))
            return -1;
          return 6578; /* *p *arm_return */

        case SIMPLE_RETURN:
          operands[0] = x25;
          operands[1] = x29;
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9083 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM)))
            return -1;
          return 6579; /* *p *arm_simple_return */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x26, 0) != 1
              || XINT (x26, 1) != 56)
            return -1;
          x30 = XVECEXP (x26, 0, 0);
          if (GET_CODE (x30) != MEM
              || GET_MODE (x30) != E_BLKmode)
            return -1;
          operands[1] = x25;
          operands[2] = x29;
          x32 = XEXP (x30, 0);
          operands[0] = x32;
          if (!s_register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1725 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(use_cmse && reload_completed)))
            return -1;
          return 6962; /* *p lazy_store_multiple_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
