/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern19 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern19 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern19 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != E_DImode
          || !mem_noofs_operand (operands[1], E_DImode)
          || !s_register_operand (operands[2], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern72 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8BImode:
      return pattern62 (x3, 
E_V8BImode, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4BImode:
      if (pattern62 (x3, 
E_V4BImode, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern72 (x3, 
E_V8BImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !imm_lshift_or_reg_neon (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != FIX
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != FIX
      || GET_MODE (x4) != E_SFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != FLOAT_EXTEND
      || GET_MODE (x5) != E_SFmode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_HFmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  operands[2] = x8;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !reg_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern40 (x3, 
E_V8QImode, 
E_V4HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern40 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern40 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_DImode:
      if (pattern40 (x3, 
E_V2SImode, 
E_DImode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern40 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_OImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern164 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !vpr_register_operand (operands[2], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !vpr_register_operand (operands[2], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !vpr_register_operand (operands[2], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x16QImode:
      return 0;

    case E_V2x8HImode:
      return 1;

    case E_V2x4SImode:
      return 2;

    case E_V2x8HFmode:
      return 3;

    case E_V2x4SFmode:
      return 4;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !mve_imm_7 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_15 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_31 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern226 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern226 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          return pattern233 (x1, 
E_V16QImode, 
E_V16BImode); /* [-1, 0] */

        case E_V8BImode:
          if (pattern233 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 1;

        case E_V4BImode:
          if (pattern233 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          if (pattern234 (x1, 
E_QImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 3;

        case E_V8BImode:
          if (pattern234 (x1, 
E_HImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 4;

        case E_V4BImode:
          if (pattern234 (x1, 
E_SImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!cc_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!s_register_operand (operands[1], E_SImode)
          || !mem_noofs_operand (operands[2], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !arm_add_operand (operands[3], E_SImode)
          || !s_register_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[1], E_DImode)
          || !mem_noofs_operand (operands[2], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_DImode
          || !cmpdi_operand (operands[3], E_DImode)
          || !s_register_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  if (!arm_comparison_operator (operands[5], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  if (!arm_add_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!arm_rhs_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x2, 2);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 40
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CC_NZmode)
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  return pattern291 (x1); /* [-1, 3] */
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 41
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern303 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_V2SImode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 2)
    return -1;
  return 0;
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern308 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern308 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern308 (x1, 
E_DImode, 
E_SImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern318 (x4, 
E_CCmode, 
100); /* [-1, 0] */
}

int
pattern324 (rtx x1, int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != i4
      || GET_MODE (x6) != i3
      || pattern323 (x1, 
i2, 
i3, 
i4) != 0)
    return -1;
  return 0;
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  return 0;
}

int
pattern339 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_32 (operands[4], E_SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x14, operands[4]))
    return -1;
  x15 = XVECEXP (x3, 0, 3);
  if (!rtx_equal_p (x15, operands[5]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern338 (x6, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern338 (x6, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern338 (x6, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[2] = x5;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_memory_operand (operands[1], i2)
      || !vpr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern376 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode)
      || !reg_or_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern386 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern398 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern398 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern398 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!mem_noofs_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !s_register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  switch (XWINT (x8, 0))
    {
    case 8L:
      x9 = XEXP (x6, 2);
      switch (XWINT (x9, 0))
        {
        case 8L:
          return 0;

        case 16L:
          return 1;

        default:
          return -1;
        }

    case 16L:
      x9 = XEXP (x6, 2);
      if (XWINT (x9, 0) != 8L)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern432 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!arm_rhs_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!register_operand (operands[0], E_DImode)
      || !register_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  return 0;
}

int
pattern450 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern460 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_struct_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern477 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !register_operand (operands[2], E_V16QImode)
      || !register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern495 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XEXP (x3, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER
      || pattern450 (x1) != 0)
    return -1;
  return 0;
}

int
pattern501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!s_register_operand (operands[1], E_TImode)
          || GET_MODE (x1) != i1)
        return -1;
      return 0;

    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode)
          || GET_MODE (x1) != i2)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern511 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !arm_low_register_operand (operands[0], E_DImode)
      || !arm_low_register_operand (operands[1], E_DImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern527 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern537 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !s_register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern515 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern546 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern553 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern562 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern571 (x1) != 0)
    return -1;
  return 0;
}

int
pattern580 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern587 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !s_register_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 28
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 104
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x1, 0);
  operands[4] = x7;
  x8 = XEXP (x7, 0);
  operands[5] = x8;
  x9 = XVECEXP (x2, 0, 0);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_DImode)
      || !mem_noofs_operand (operands[1], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode
      || !s_register_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

int
pattern649 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode)
      || pattern417 (x1, 
E_CCmode, 
MINUS) != 0)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2])
      || !
#line 1654 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  return 26; /* subsi3_compare1 */
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern288 (x2) != 0)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (pattern548 (x8, 
IOR))
        {
        case 0:
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[2])
              || !
#line 3782 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 111; /* *iorsi3_compare0 */

        case 1:
          if (!
#line 3797 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 112; /* *iorsi3_compare0_scratch */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern384 (x1, 
IOR) != 0
          || !
#line 10530 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 345; /* *ior_scc_scc_cmp */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_SImode)
          && pattern495 (x1) == 0)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (s_register_operand (operands[1], E_SImode))
            {
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              if (const_int_operand (operands[2], E_SImode))
                {
                  x9 = XEXP (x3, 1);
                  operands[4] = x9;
                  if (arm_not_operand (operands[4], E_SImode)
                      && 
#line 3182 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
                    return 96; /* *ite_ne_zeroextractsi */
                }
            }
        }
      if (XWINT (x6, 0) != 0L
          || pattern495 (x1) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!arm_not_operand (operands[3], E_SImode)
          || !
#line 3221 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
        return -1;
      return 97; /* *ite_ne_zeroextractsi_shifted */

    case REG:
    case SUBREG:
      operands[0] = x5;
      if (s_register_operand (operands[0], E_SImode)
          && pattern387 (x1) == 0)
        {
          x9 = XEXP (x3, 1);
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          if (
#line 1491 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return 1065; /* *thumb2_cbnz */
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x5) != REG
          || REGNO (x5) != 14
          || GET_MODE (x5) != E_SImode)
        return -1;
      x11 = XEXP (x4, 1);
      if (XWINT (x11, 0) != 1L)
        return -1;
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != LABEL_REF)
        return -1;
      x12 = XEXP (x3, 2);
      if (GET_CODE (x12) != PC)
        return -1;
      x13 = XEXP (x2, 0);
      if (GET_CODE (x13) != PC)
        return -1;
      x14 = XVECEXP (x1, 0, 1);
      if (pattern528 (x14) != 0)
        return -1;
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 14
          || GET_MODE (x17) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!
#line 1771 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      *pnum_clobbers = 1;
      return 1075; /* *doloop_end_internal */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[2] = x9;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x2, 1);
  operands[4] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[0])
      || !
#line 12765 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[1]) + 4) == INTVAL (operands[3]))
     && (operands_ok_ldrd_strd (operands[2], operands[4],
                                  operands[0], INTVAL (operands[1]),
                                  false, false))))
    return -1;
  return 426; /* *thumb2_strd */
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC)
        return -1;
      switch (XINT (x3, 1))
        {
        case 79:
          if (pattern364 (x1) != 0
              || !
#line 2792 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
            return -1;
          return 87; /* arm_smlawb_setq_insn */

        case 80:
          if (pattern364 (x1) != 0
              || !
#line 2792 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
            return -1;
          return 89; /* arm_smlawt_setq_insn */

        case 94:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 239; /* arm_smlad_setq_insn */

        case 95:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 241; /* arm_smladx_setq_insn */

        case 96:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 243; /* arm_smlsd_setq_insn */

        case 97:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 245; /* arm_smlsdx_setq_insn */

        case 622:
          switch (pattern365 (x1, 
622))
            {
            case 0:
              if (!
#line 1679 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3954; /* mve_vshlcq_sv16qi */

            case 1:
              if (!
#line 1679 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3956; /* mve_vshlcq_sv8hi */

            case 2:
              if (!
#line 1679 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3958; /* mve_vshlcq_sv4si */

            default:
              return -1;
            }

        case 623:
          switch (pattern365 (x1, 
623))
            {
            case 0:
              if (!
#line 1679 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3955; /* mve_vshlcq_uv16qi */

            case 1:
              if (!
#line 1679 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3957; /* mve_vshlcq_uv8hi */

            case 2:
              if (!
#line 1679 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3959; /* mve_vshlcq_uv4si */

            default:
              return -1;
            }

        case 1035:
          switch (pattern366 (x1, 
1035))
            {
            case 0:
              if (!
#line 3769 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4950; /* mve_viwdupq_wb_uv16qi_insn */

            case 1:
              if (!
#line 3769 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4952; /* mve_viwdupq_wb_uv8hi_insn */

            case 2:
              if (!
#line 3769 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4954; /* mve_viwdupq_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1031:
          switch (pattern366 (x1, 
1031))
            {
            case 0:
              if (!
#line 3769 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4951; /* mve_vdwdupq_wb_uv16qi_insn */

            case 1:
              if (!
#line 3769 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4953; /* mve_vdwdupq_wb_uv8hi_insn */

            case 2:
              if (!
#line 3769 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4955; /* mve_vdwdupq_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1037:
          if (pattern334 (x2) != 0
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1037)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!mve_vldrd_immediate (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          switch (pattern586 (x4))
            {
            case 0:
              switch (pattern616 (x5))
                {
                case 0:
                  if (!
#line 3891 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                    return -1;
                  return 4962; /* mve_vstrq_scatter_base_wb_v4si */

                case 1:
                  if (!
#line 3891 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                    return -1;
                  return 4963; /* mve_vstrq_scatter_base_wb_v4sf */

                default:
                  return -1;
                }

            case 1:
              if (!s_register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x5) != E_V2DImode
                  || !
#line 3891 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4964; /* mve_vstrq_scatter_base_wb_v2di */

            default:
              return -1;
            }

        case 1039:
          x8 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SCRATCH
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1039)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!mve_vldrd_immediate (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          x12 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x5, 0, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern602 (x1, 
E_V4SImode) != 0
                  || !
#line 3937 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 4968; /* mve_vldrq_gather_base_wb_v4si */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !s_register_operand (operands[2], E_V4SImode)
                  || !s_register_operand (operands[1], E_V4SImode)
                  || GET_MODE (x5) != E_V4SImode
                  || !
#line 3937 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 4969; /* mve_vldrq_gather_base_wb_v4sf */

            case E_V2DImode:
              if (pattern602 (x1, 
E_V2DImode) != 0
                  || !
#line 3937 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4970; /* mve_vldrq_gather_base_wb_v2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    case 1:
      if (XINT (x3, 1) != 40
          || GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x6) == MEM
          && GET_MODE (x6) == E_SImode)
        {
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) == CLOBBER)
            {
              x14 = XEXP (x6, 0);
              operands[1] = x14;
              if (register_operand (operands[1], E_SImode))
                {
                  x11 = XEXP (x4, 0);
                  if (rtx_equal_p (x11, operands[1]))
                    return 309; /* *stack_protect_set_insn */
                }
            }
        }
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 312; /* stack_protect_set_tls */

    case 4:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      switch (XINT (x3, 1))
        {
        case 1034:
          switch (pattern333 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 3750 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4944; /* mve_vidupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3750 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4946; /* mve_vidupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3750 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4948; /* mve_vidupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1030:
          switch (pattern333 (x1, 
MINUS))
            {
            case 0:
              if (!
#line 3750 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4945; /* mve_vddupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3750 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4947; /* mve_vddupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3750 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4949; /* mve_vddupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1038:
          if (pattern334 (x2) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1038)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!mve_vldrd_immediate (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          x15 = XVECEXP (x3, 0, 3);
          operands[4] = x15;
          switch (pattern586 (x4))
            {
            case 0:
              if (!vpr_register_operand (operands[4], E_V4BImode))
                return -1;
              switch (pattern616 (x5))
                {
                case 0:
                  if (!
#line 3915 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                    return -1;
                  return 4965; /* mve_vstrq_scatter_base_wb_p_v4si */

                case 1:
                  if (!
#line 3915 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                    return -1;
                  return 4966; /* mve_vstrq_scatter_base_wb_p_v4sf */

                default:
                  return -1;
                }

            case 1:
              if (!vpr_register_operand (operands[4], E_V2QImode)
                  || !s_register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x5) != E_V2DImode
                  || !
#line 3915 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4967; /* mve_vstrq_scatter_base_wb_p_v2di */

            default:
              return -1;
            }

        case 1040:
          x15 = XVECEXP (x3, 0, 3);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_BLKmode)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != SCRATCH)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1040)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!mve_vldrd_immediate (operands[3], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[4] = x8;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          x12 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x5, 0, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern609 (x1, 
E_V4SImode, 
E_V4BImode) != 0
                  || !
#line 3960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 4971; /* mve_vldrq_gather_base_wb_z_v4si */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || pattern608 (x5, 
E_V4SImode, 
E_V4BImode) != 0
                  || !
#line 3960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 4972; /* mve_vldrq_gather_base_wb_z_v4sf */

            case E_V2DImode:
              if (pattern609 (x1, 
E_V2DImode, 
E_V2QImode) != 0
                  || !
#line 3960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4973; /* mve_vldrq_gather_base_wb_z_v2di */

            default:
              return -1;
            }

        case 1054:
          if (pattern336 (x1, 
1054) != 0
              || !
#line 4015 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4980; /* mve_vadciq_m_uv4si */

        case 1056:
          if (pattern336 (x1, 
1056) != 0
              || !
#line 4015 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4981; /* mve_vadciq_m_sv4si */

        case 1047:
          if (pattern336 (x1, 
1047) != 0
              || !
#line 4015 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4982; /* mve_vsbciq_m_uv4si */

        case 1048:
          if (pattern336 (x1, 
1048) != 0
              || !
#line 4015 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4983; /* mve_vsbciq_m_sv4si */

        case 1042:
          if (pattern337 (x1, 
1042) != 0
              || !
#line 4056 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4988; /* mve_vadcq_m_uv4si */

        case 1044:
          if (pattern337 (x1, 
1044) != 0
              || !
#line 4056 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4989; /* mve_vadcq_m_sv4si */

        case 1051:
          if (pattern337 (x1, 
1051) != 0
              || !
#line 4056 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4990; /* mve_vsbcq_m_uv4si */

        case 1052:
          if (pattern337 (x1, 
1052) != 0
              || !
#line 4056 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4991; /* mve_vsbcq_m_sv4si */

        case 1061:
          switch (pattern339 (x1, 
1061))
            {
            case 0:
              if (!
#line 4423 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5039; /* mve_vshlcq_m_sv16qi */

            case 1:
              if (!
#line 4423 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5041; /* mve_vshlcq_m_sv8hi */

            case 2:
              if (!
#line 4423 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5043; /* mve_vshlcq_m_sv4si */

            default:
              return -1;
            }

        case 1060:
          switch (pattern339 (x1, 
1060))
            {
            case 0:
              if (!
#line 4423 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5040; /* mve_vshlcq_m_uv16qi */

            case 1:
              if (!
#line 4423 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5042; /* mve_vshlcq_m_uv8hi */

            case 2:
              if (!
#line 4423 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5044; /* mve_vshlcq_m_uv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      x8 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x8) != SUBREG
          || maybe_ne (SUBREG_BYTE (x8), 4)
          || GET_MODE (x8) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 5
          || GET_MODE (x5) != E_SImode)
        return -1;
      x17 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x17) != SUBREG
          || maybe_ne (SUBREG_BYTE (x17), 4)
          || GET_MODE (x17) != E_SImode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[3] = x7;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      if (!s_register_operand (operands[4], E_DImode))
        return -1;
      x15 = XVECEXP (x3, 0, 3);
      operands[5] = x15;
      if (!mve_imm_selective_upto_8 (operands[5], E_SImode))
        return -1;
      x18 = XVECEXP (x3, 0, 4);
      operands[6] = x18;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x12 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x13, operands[3]))
        return -1;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[4]))
        return -1;
      x20 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x20, operands[5]))
        return -1;
      x21 = XVECEXP (x5, 0, 4);
      if (!rtx_equal_p (x21, operands[6]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 1036:
          switch (pattern632 (x1, 
1036))
            {
            case 0:
              if (!
#line 3793 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4956; /* mve_viwdupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3793 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4958; /* mve_viwdupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3793 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4960; /* mve_viwdupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1032:
          switch (pattern632 (x1, 
1032))
            {
            case 0:
              if (!
#line 3793 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4957; /* mve_vdwdupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3793 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4959; /* mve_vdwdupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3793 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4961; /* mve_vdwdupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x5;
      if (!s_register_operand (operands[0], E_SImode)
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!arm_not_operand (operands[1], E_SImode)
          || !
#line 3076 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 92; /* *andsi3_compare0_scratch */

    case NOT:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_SImode
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      if (!s_register_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[0] = x7;
          if (!shift_operator (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[2] = x9;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x6;
          if (!
#line 3637 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 106; /* andsi_not_shiftsi_si_scc_no_reuse */

        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          operands[1] = x6;
          if (!
#line 3691 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 109; /* *andsi_notsi_si_compare0_scratch */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern341 (x1) != 0
          || !
#line 10330 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 342; /* *cmp_and */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1340 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 648; /* ashlv4hi3_iwmmxt */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1424 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 660; /* ashlv4hi3_di */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1340 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 649; /* ashlv2si3_iwmmxt */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1424 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 661; /* ashlv2si3_di */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      if (register_operand (operands[0], E_DImode))
        {
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (register_operand (operands[1], E_DImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (imm_or_reg_operand (operands[2], E_SImode)
                  && 
#line 1340 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 650; /* ashldi3_iwmmxt */
              if (imm_or_reg_operand (operands[2], E_DImode)
                  && 
#line 1424 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 662; /* ashldi3_di */
            }
        }
      if (!arm_general_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!arm_reg_or_long_shift_imm (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0])
          || !
#line 1749 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE))
        return -1;
      return 1073; /* thumb2_lsll */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], E_BLKmode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_EImode:
      if (!s_register_operand (operands[1], E_EImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5910 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2885; /* neon_vst3_lanev8qi */

        case E_V4HImode:
          if (!
#line 5910 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2886; /* neon_vst3_lanev4hi */

        case E_V4HFmode:
          if (!
#line 5910 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2887; /* neon_vst3_lanev4hf */

        case E_V4BFmode:
          if (!
#line 5910 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2888; /* neon_vst3_lanev4bf */

        case E_V2SImode:
          if (!
#line 5910 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2889; /* neon_vst3_lanev2si */

        case E_V2SFmode:
          if (!
#line 5910 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2890; /* neon_vst3_lanev2sf */

        default:
          return -1;
        }

    case E_CImode:
      if (!s_register_operand (operands[1], E_CImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!
#line 5936 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2891; /* neon_vst3_lanev8hi */

        case E_V8HFmode:
          if (!
#line 5936 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2892; /* neon_vst3_lanev8hf */

        case E_V4SImode:
          if (!
#line 5936 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2893; /* neon_vst3_lanev4si */

        case E_V4SFmode:
          if (!
#line 5936 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2894; /* neon_vst3_lanev4sf */

        case E_V8BFmode:
          if (!(
#line 5936 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2895; /* neon_vst3_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3558 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4909; /* mve_vldrq_gather_base_z_v4si */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode)
          || !
#line 3558 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4910; /* mve_vldrq_gather_base_z_v4sf */

    case E_V2DImode:
      if (pattern72 (x3, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3558 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4911; /* mve_vldrq_gather_base_z_v2di */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern430 (x2, 
E_V8QImode, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3203 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4833; /* mve_vstrq_p_truncate_v8qi */

    case E_V4QImode:
      if (pattern430 (x2, 
E_V4QImode, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3203 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4834; /* mve_vstrq_p_truncate_v4qi */

    case E_V4HImode:
      if (pattern430 (x2, 
E_V4HImode, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3203 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4835; /* mve_vstrq_p_truncate_v4hi */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern90 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (pattern509 (x3))
    {
    case 0:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !
#line 3374 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 4870; /* mve_vstrq_truncate_scatter_offset_v8qi */

    case 1:
      if (!s_register_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4QImode:
          if (!
#line 3374 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4871; /* mve_vstrq_truncate_scatter_offset_v4qi */

        case E_V4HImode:
          if (!
#line 3374 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4872; /* mve_vstrq_truncate_scatter_offset_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (pattern94 (x2, 
0, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[1] = x5;
  if (!
#line 12341 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_GNU2_TLS))
    return -1;
  *pnum_clobbers = 3;
  return 409; /* tlscall */
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern36 (x1))
    {
    case 0:
      if (!
#line 2192 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1596; /* neon_vqrdmlahv4hi */

    case 1:
      if (!
#line 2192 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1598; /* neon_vqrdmlahv2si */

    case 2:
      if (!
#line 2192 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1600; /* neon_vqrdmlahv8hi */

    case 3:
      if (!
#line 2192 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1602; /* neon_vqrdmlahv4si */

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_V16QImode)
          || !register_operand (operands[0], E_V16QImode)
          || !
#line 75 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098))
        return -1;
      return 3047; /* aes_op_protect */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      switch (XINT (x4, 1))
        {
        case 352:
          if (!s_register_operand (operands[0], E_V16QImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!neon_permissive_struct_operand (operands[1], E_V16QImode)
              || !
#line 100 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098))
            return -1;
          return 3048; /* *aes_op_protect_misalign_load */

        case 198:
          if (!s_register_operand (operands[0], E_V16QImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!neon_struct_operand (operands[1], E_V16QImode)
              || !
#line 112 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_NEON))
            return -1;
          return 3049; /* aes_op_protect_neon_vld1v16qi */

        case 132:
          x5 = XVECEXP (x4, 0, 0);
          switch (pattern431 (x5, 
130))
            {
            case 0:
              if (!
#line 126 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098))
                return -1;
              return 3050; /* *crypto_aesmc_protected */

            case 1:
              if (!
#line 163 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
                return -1;
              return 3053; /* *aarch32_crypto_aese_fused_protected */

            default:
              return -1;
            }

        case 131:
          x5 = XVECEXP (x4, 0, 0);
          switch (pattern431 (x5, 
129))
            {
            case 0:
              if (!
#line 126 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098))
                return -1;
              return 3051; /* *crypto_aesimc_protected */

            case 1:
              if (!
#line 200 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && fix_aes_erratum_1742098
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
                return -1;
              return 3055; /* *aarch32_crypto_aesd_fused_protected */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern301 (x3))
        {
        case 0:
          if (!
#line 3275 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4846; /* mve_vldrq_extend_v8qis */

        case 1:
          if (!
#line 3275 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4848; /* mve_vldrq_extend_v4qis */

        case 2:
          if (!
#line 3275 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4850; /* mve_vldrq_extend_v4his */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern301 (x3))
        {
        case 0:
          if (!
#line 3275 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4847; /* mve_vldrq_extend_v8qiu */

        case 1:
          if (!
#line 3275 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4849; /* mve_vldrq_extend_v4qiu */

        case 2:
          if (!
#line 3275 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4851; /* mve_vldrq_extend_v4hiu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1869; /* neon_vpaddlsv8qi */

    case 1:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1871; /* neon_vpaddlsv16qi */

    case 2:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1873; /* neon_vpaddlsv4hi */

    case 3:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1875; /* neon_vpaddlsv8hi */

    case 4:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1877; /* neon_vpaddlsv2si */

    case 5:
      if (!
#line 2756 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1879; /* neon_vpaddlsv4si */

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      if (!neon_struct_operand (operands[0], E_TImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_TImode
          || !s_register_operand (operands[1], E_TImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5544 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2804; /* neon_vst2v8qi */

        case E_V4HImode:
          if (!
#line 5544 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2805; /* neon_vst2v4hi */

        case E_V4HFmode:
          if (!
#line 5544 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2806; /* neon_vst2v4hf */

        case E_V4BFmode:
          if (!(
#line 5544 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2807; /* neon_vst2v4bf */

        case E_V2SImode:
          if (!
#line 5544 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2808; /* neon_vst2v2si */

        case E_V2SFmode:
          if (!
#line 5544 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2809; /* neon_vst2v2sf */

        case E_DImode:
          if (!
#line 5544 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2810; /* neon_vst2di */

        default:
          return -1;
        }

    case 1:
      if (!neon_struct_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !s_register_operand (operands[1], E_OImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V16QImode:
          if (!
#line 5562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2811; /* neon_vst2v16qi */

        case E_V8HImode:
          if (!
#line 5562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2812; /* neon_vst2v8hi */

        case E_V8HFmode:
          if (!
#line 5562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2813; /* neon_vst2v8hf */

        case E_V8BFmode:
          if (!(
#line 5562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2814; /* neon_vst2v8bf */

        case E_V4SImode:
          if (!
#line 5562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2815; /* neon_vst2v4si */

        case E_V4SFmode:
          if (!
#line 5562 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2816; /* neon_vst2v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3539 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4906; /* mve_vldrq_gather_base_v4si */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3539 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4907; /* mve_vldrq_gather_base_v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 3539 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4908; /* mve_vldrq_gather_base_v2di */

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern370 (x3, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3252 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4841; /* mve_vldrq_z_v16qi */

    case E_V8HImode:
      if (pattern370 (x3, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3252 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4842; /* mve_vldrq_z_v8hi */

    case E_V4SImode:
      if (pattern370 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3252 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4843; /* mve_vldrq_z_v4si */

    case E_V8HFmode:
      if (pattern370 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3252 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4844; /* mve_vldrq_z_v8hf */

    case E_V4SFmode:
      if (pattern370 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3252 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4845; /* mve_vldrq_z_v4sf */

    default:
      return -1;
    }
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2404; /* neon_vqshl_u_nv8qi */

    case 1:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2406; /* neon_vqshl_u_nv16qi */

    case 2:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2408; /* neon_vqshl_u_nv4hi */

    case 3:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2410; /* neon_vqshl_u_nv8hi */

    case 4:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2412; /* neon_vqshl_u_nv2si */

    case 5:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2414; /* neon_vqshl_u_nv4si */

    case 6:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2416; /* neon_vqshl_u_ndi */

    case 7:
      if (!
#line 4588 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2418; /* neon_vqshl_u_nv2di */

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2308; /* neon_vqshluv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2312; /* neon_vqshluv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2316; /* neon_vqshluv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2320; /* neon_vqshluv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2324; /* neon_vqshluv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2328; /* neon_vqshluv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2332; /* neon_vqshludi */

    case 7:
      if (!
#line 4509 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2336; /* neon_vqshluv2di */

    default:
      return -1;
    }
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1634; /* neon_vqsubuv8qi */

    case 1:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1636; /* neon_vqsubuv16qi */

    case 2:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1638; /* neon_vqsubuv4hi */

    case 3:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1640; /* neon_vqsubuv8hi */

    case 4:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1642; /* neon_vqsubuv2si */

    case 5:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1644; /* neon_vqsubuv4si */

    case 6:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1646; /* neon_vqsubudi */

    case 7:
      if (!
#line 2293 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1648; /* neon_vqsubuv2di */

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern158 (x1))
    {
    case 0:
      if (!
#line 5327 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2744; /* neon_vst1x4qav16qi */

    case 1:
      if (!
#line 5327 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2745; /* neon_vst1x4qav8hi */

    case 2:
      if (!
#line 5327 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2746; /* neon_vst1x4qav8hf */

    case 3:
      if (!(
#line 5327 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2747; /* neon_vst1x4qav8bf */

    case 4:
      if (!
#line 5327 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2748; /* neon_vst1x4qav4si */

    case 5:
      if (!
#line 5327 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2749; /* neon_vst1x4qav4sf */

    case 6:
      if (!
#line 5327 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2750; /* neon_vst1x4qav2di */

    default:
      return -1;
    }
}

 int
recog_202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern161 (x1, 
E_OImode, 
E_XImode))
    {
    case 0:
      if (!
#line 6004 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2903; /* neon_vld4qav16qi */

    case 1:
      if (!
#line 6004 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2904; /* neon_vld4qav8hi */

    case 2:
      if (!
#line 6004 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2905; /* neon_vld4qav8hf */

    case 3:
      if (!(
#line 6004 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2906; /* neon_vld4qav8bf */

    case 4:
      if (!
#line 6004 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2907; /* neon_vld4qav4si */

    case 5:
      if (!
#line 6004 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2908; /* neon_vld4qav4sf */

    default:
      return -1;
    }
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1788; /* neon_vabduv8qi */

    case 1:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1790; /* neon_vabduv16qi */

    case 2:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1792; /* neon_vabduv4hi */

    case 3:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1794; /* neon_vabduv8hi */

    case 4:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1796; /* neon_vabduv2si */

    case 5:
      if (!
#line 2593 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1798; /* neon_vabduv4si */

    default:
      return -1;
    }
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern126 (x1))
    {
    case 0:
      if (!
#line 376 "../../gcc-15.1.0/gcc/config/arm/vec-common.md"
(ARM_HAVE_V8QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 518; /* mve_vshlq_sv8qi */

    case 1:
      if (!
#line 376 "../../gcc-15.1.0/gcc/config/arm/vec-common.md"
(ARM_HAVE_V16QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 520; /* mve_vshlq_sv16qi */

    case 2:
      if (!
#line 376 "../../gcc-15.1.0/gcc/config/arm/vec-common.md"
(ARM_HAVE_V4HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 522; /* mve_vshlq_sv4hi */

    case 3:
      if (!
#line 376 "../../gcc-15.1.0/gcc/config/arm/vec-common.md"
(ARM_HAVE_V8HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 524; /* mve_vshlq_sv8hi */

    case 4:
      if (!
#line 376 "../../gcc-15.1.0/gcc/config/arm/vec-common.md"
(ARM_HAVE_V2SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 526; /* mve_vshlq_sv2si */

    case 5:
      if (!
#line 376 "../../gcc-15.1.0/gcc/config/arm/vec-common.md"
(ARM_HAVE_V4SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 528; /* mve_vshlq_sv4si */

    default:
      return -1;
    }
}

 int
recog_236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 2180 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1589; /* neon_vqrdmulhv4hi */

    case 1:
      if (!
#line 2180 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1591; /* neon_vqrdmulhv2si */

    case 2:
      if (!
#line 2180 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1593; /* neon_vqrdmulhv8hi */

    case 3:
      if (!
#line 2180 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1595; /* neon_vqrdmulhv4si */

    default:
      return -1;
    }
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], E_BLKmode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_EImode:
      if (!s_register_operand (operands[0], E_EImode)
          || GET_MODE (x2) != E_EImode
          || !s_register_operand (operands[2], E_EImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5719 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2847; /* neon_vld3_lanev8qi */

        case E_V4HImode:
          if (!
#line 5719 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2848; /* neon_vld3_lanev4hi */

        case E_V4HFmode:
          if (!
#line 5719 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2849; /* neon_vld3_lanev4hf */

        case E_V4BFmode:
          if (!
#line 5719 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2850; /* neon_vld3_lanev4bf */

        case E_V2SImode:
          if (!
#line 5719 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2851; /* neon_vld3_lanev2si */

        case E_V2SFmode:
          if (!
#line 5719 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2852; /* neon_vld3_lanev2sf */

        default:
          return -1;
        }

    case E_CImode:
      if (!s_register_operand (operands[0], E_CImode)
          || GET_MODE (x2) != E_CImode
          || !s_register_operand (operands[2], E_CImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!
#line 5745 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2853; /* neon_vld3_lanev8hi */

        case E_V8HFmode:
          if (!
#line 5745 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2854; /* neon_vld3_lanev8hf */

        case E_V4SImode:
          if (!
#line 5745 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2855; /* neon_vld3_lanev4si */

        case E_V4SFmode:
          if (!
#line 5745 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2856; /* neon_vld3_lanev4sf */

        case E_V8BFmode:
          if (!(
#line 5745 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2857; /* neon_vld3_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 103:
      return recog_259 (x1, insn, pnum_clobbers);

    case 102:
      return recog_257 (x1, insn, pnum_clobbers);

    case 105:
      return recog_254 (x1, insn, pnum_clobbers);

    case 104:
      return recog_253 (x1, insn, pnum_clobbers);

    case 361:
      return recog_261 (x1, insn, pnum_clobbers);

    case 362:
      return recog_260 (x1, insn, pnum_clobbers);

    case 224:
      return recog_256 (x1, insn, pnum_clobbers);

    case 227:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4052 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2212; /* neon_vmlals_lanev4hi */

        case 1:
          if (!
#line 4052 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2214; /* neon_vmlals_lanev2si */

        default:
          return -1;
        }

    case 228:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4052 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2213; /* neon_vmlalu_lanev4hi */

        case 1:
          if (!
#line 4052 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2215; /* neon_vmlalu_lanev2si */

        default:
          return -1;
        }

    case 265:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4067 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2216; /* neon_vqdmlal_lanev4hi */

        case 1:
          if (!
#line 4067 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2217; /* neon_vqdmlal_lanev2si */

        default:
          return -1;
        }

    case 230:
      return recog_255 (x1, insn, pnum_clobbers);

    case 233:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4118 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2224; /* neon_vmlsls_lanev4hi */

        case 1:
          if (!
#line 4118 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2226; /* neon_vmlsls_lanev2si */

        default:
          return -1;
        }

    case 234:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4118 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2225; /* neon_vmlslu_lanev4hi */

        case 1:
          if (!
#line 4118 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2227; /* neon_vmlslu_lanev2si */

        default:
          return -1;
        }

    case 267:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4133 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2228; /* neon_vqdmlsl_lanev4hi */

        case 1:
          if (!
#line 4133 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2229; /* neon_vqdmlsl_lanev2si */

        default:
          return -1;
        }

    case 206:
      return recog_245 (x1, insn, pnum_clobbers);

    case 211:
      return recog_246 (x1, insn, pnum_clobbers);

    case 216:
      return recog_244 (x1, insn, pnum_clobbers);

    case 809:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 2462 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4349; /* mve_vcvtq_m_n_from_f_sv8hi */

        case 1:
          if (!
#line 2462 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4351; /* mve_vcvtq_m_n_from_f_sv4si */

        default:
          return -1;
        }

    case 818:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 2462 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4350; /* mve_vcvtq_m_n_from_f_uv8hi */

        case 1:
          if (!
#line 2462 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4352; /* mve_vcvtq_m_n_from_f_uv4si */

        default:
          return -1;
        }

    case 820:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4359; /* mve_vabavq_p_sv16qi */

        case 1:
          if (!
#line 2514 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4361; /* mve_vabavq_p_sv8hi */

        case 2:
          if (!
#line 2514 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4363; /* mve_vabavq_p_sv4si */

        default:
          return -1;
        }

    case 821:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4360; /* mve_vabavq_p_uv16qi */

        case 1:
          if (!
#line 2514 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4362; /* mve_vabavq_p_uv8hi */

        case 2:
          if (!
#line 2514 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4364; /* mve_vabavq_p_uv4si */

        default:
          return -1;
        }

    case 819:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2532 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4365; /* mve_vqshluq_m_n_sv16qi */

        case 1:
          if (!
#line 2532 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4366; /* mve_vqshluq_m_n_sv8hi */

        case 2:
          if (!
#line 2532 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4367; /* mve_vqshluq_m_n_sv4si */

        default:
          return -1;
        }

    case 824:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2550 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4368; /* mve_vsriq_m_n_sv16qi */

        case 1:
          if (!
#line 2550 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4370; /* mve_vsriq_m_n_sv8hi */

        case 2:
          if (!
#line 2550 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4372; /* mve_vsriq_m_n_sv4si */

        default:
          return -1;
        }

    case 825:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2550 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4369; /* mve_vsriq_m_n_uv16qi */

        case 1:
          if (!
#line 2550 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4371; /* mve_vsriq_m_n_uv8hi */

        case 2:
          if (!
#line 2550 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4373; /* mve_vsriq_m_n_uv4si */

        default:
          return -1;
        }

    case 828:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 2568 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4374; /* mve_vcvtq_m_n_to_f_uv8hf */

        case 1:
          if (!
#line 2568 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4376; /* mve_vcvtq_m_n_to_f_uv4sf */

        default:
          return -1;
        }

    case 829:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 2568 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4375; /* mve_vcvtq_m_n_to_f_sv8hf */

        case 1:
          if (!
#line 2568 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4377; /* mve_vcvtq_m_n_to_f_sv4sf */

        default:
          return -1;
        }

    case 552:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4378; /* mve_vabdq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4416; /* mve_vabdq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4454; /* mve_vabdq_m_sv4si */

        default:
          return -1;
        }

    case 553:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4379; /* mve_vabdq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4417; /* mve_vabdq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4455; /* mve_vabdq_m_uv4si */

        default:
          return -1;
        }

    case 842:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4380; /* mve_vhaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4418; /* mve_vhaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4456; /* mve_vhaddq_m_sv4si */

        default:
          return -1;
        }

    case 838:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4381; /* mve_vhaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4419; /* mve_vhaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4457; /* mve_vhaddq_m_uv4si */

        default:
          return -1;
        }

    case 924:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4382; /* mve_vhsubq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4420; /* mve_vhsubq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4458; /* mve_vhsubq_m_sv4si */

        default:
          return -1;
        }

    case 925:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4383; /* mve_vhsubq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4421; /* mve_vhsubq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4459; /* mve_vhsubq_m_uv4si */

        default:
          return -1;
        }

    case 876:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4384; /* mve_vmaxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4422; /* mve_vmaxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4460; /* mve_vmaxq_m_sv4si */

        default:
          return -1;
        }

    case 856:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4385; /* mve_vmaxq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4423; /* mve_vmaxq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4461; /* mve_vmaxq_m_uv4si */

        default:
          return -1;
        }

    case 884:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4386; /* mve_vminq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4424; /* mve_vminq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4462; /* mve_vminq_m_sv4si */

        default:
          return -1;
        }

    case 885:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4387; /* mve_vminq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4425; /* mve_vminq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4463; /* mve_vminq_m_uv4si */

        default:
          return -1;
        }

    case 891:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4388; /* mve_vmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4426; /* mve_vmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4464; /* mve_vmulhq_m_sv4si */

        default:
          return -1;
        }

    case 892:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4389; /* mve_vmulhq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4427; /* mve_vmulhq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4465; /* mve_vmulhq_m_uv4si */

        default:
          return -1;
        }

    case 831:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4390; /* mve_vqaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4428; /* mve_vqaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4466; /* mve_vqaddq_m_sv4si */

        default:
          return -1;
        }

    case 830:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4391; /* mve_vqaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4429; /* mve_vqaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4467; /* mve_vqaddq_m_uv4si */

        default:
          return -1;
        }

    case 942:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4392; /* mve_vqdmladhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4430; /* mve_vqdmladhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4468; /* mve_vqdmladhq_m_sv4si */

        default:
          return -1;
        }

    case 933:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4393; /* mve_vqdmladhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4431; /* mve_vqdmladhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4469; /* mve_vqdmladhxq_m_sv4si */

        default:
          return -1;
        }

    case 938:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4394; /* mve_vqdmlsdhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4432; /* mve_vqdmlsdhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4470; /* mve_vqdmlsdhq_m_sv4si */

        default:
          return -1;
        }

    case 939:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4395; /* mve_vqdmlsdhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4433; /* mve_vqdmlsdhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4471; /* mve_vqdmlsdhxq_m_sv4si */

        default:
          return -1;
        }

    case 931:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4396; /* mve_vqdmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4434; /* mve_vqdmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4472; /* mve_vqdmulhq_m_sv4si */

        default:
          return -1;
        }

    case 941:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4397; /* mve_vqrdmladhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4435; /* mve_vqrdmladhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4473; /* mve_vqrdmladhq_m_sv4si */

        default:
          return -1;
        }

    case 930:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4398; /* mve_vqrdmladhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4436; /* mve_vqrdmladhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4474; /* mve_vqrdmladhxq_m_sv4si */

        default:
          return -1;
        }

    case 928:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4399; /* mve_vqrdmlsdhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4437; /* mve_vqrdmlsdhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4475; /* mve_vqrdmlsdhq_m_sv4si */

        default:
          return -1;
        }

    case 929:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4400; /* mve_vqrdmlsdhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4438; /* mve_vqrdmlsdhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4476; /* mve_vqrdmlsdhxq_m_sv4si */

        default:
          return -1;
        }

    case 934:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4401; /* mve_vqrdmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4439; /* mve_vqrdmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4477; /* mve_vqrdmulhq_m_sv4si */

        default:
          return -1;
        }

    case 860:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4402; /* mve_vqrshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4440; /* mve_vqrshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4478; /* mve_vqrshlq_m_sv4si */

        default:
          return -1;
        }

    case 881:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4403; /* mve_vqrshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4441; /* mve_vqrshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4479; /* mve_vqrshlq_m_uv4si */

        default:
          return -1;
        }

    case 912:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4404; /* mve_vqshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4442; /* mve_vqshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4480; /* mve_vqshlq_m_sv4si */

        default:
          return -1;
        }

    case 911:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4405; /* mve_vqshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4443; /* mve_vqshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4481; /* mve_vqshlq_m_uv4si */

        default:
          return -1;
        }

    case 846:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4406; /* mve_vqsubq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4444; /* mve_vqsubq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4482; /* mve_vqsubq_m_sv4si */

        default:
          return -1;
        }

    case 845:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4407; /* mve_vqsubq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4445; /* mve_vqsubq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4483; /* mve_vqsubq_m_uv4si */

        default:
          return -1;
        }

    case 864:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4408; /* mve_vrhaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4446; /* mve_vrhaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4484; /* mve_vrhaddq_m_sv4si */

        default:
          return -1;
        }

    case 862:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4409; /* mve_vrhaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4447; /* mve_vrhaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4485; /* mve_vrhaddq_m_uv4si */

        default:
          return -1;
        }

    case 883:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4410; /* mve_vrmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4448; /* mve_vrmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4486; /* mve_vrmulhq_m_sv4si */

        default:
          return -1;
        }

    case 882:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4411; /* mve_vrmulhq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4449; /* mve_vrmulhq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4487; /* mve_vrmulhq_m_uv4si */

        default:
          return -1;
        }

    case 869:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4412; /* mve_vrshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4450; /* mve_vrshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4488; /* mve_vrshlq_m_sv4si */

        default:
          return -1;
        }

    case 870:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4413; /* mve_vrshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4451; /* mve_vrshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4489; /* mve_vrshlq_m_uv4si */

        default:
          return -1;
        }

    case 822:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4414; /* mve_vshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4452; /* mve_vshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4490; /* mve_vshlq_m_sv4si */

        default:
          return -1;
        }

    case 823:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4415; /* mve_vshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4453; /* mve_vshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4491; /* mve_vshlq_m_uv4si */

        default:
          return -1;
        }

    case 873:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4492; /* mve_vaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4498; /* mve_vaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4504; /* mve_vaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 874:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4493; /* mve_vaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4499; /* mve_vaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4505; /* mve_vaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 852:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4494; /* mve_vmulq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4500; /* mve_vmulq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4506; /* mve_vmulq_m_n_sv4si */

        default:
          return -1;
        }

    case 841:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4495; /* mve_vmulq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4501; /* mve_vmulq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4507; /* mve_vmulq_m_n_uv4si */

        default:
          return -1;
        }

    case 833:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4496; /* mve_vsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4502; /* mve_vsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4508; /* mve_vsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 834:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4497; /* mve_vsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4503; /* mve_vsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4509; /* mve_vsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 918:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4510; /* mve_vaddq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4516; /* mve_vaddq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4522; /* mve_vaddq_m_sv4si */

        default:
          return -1;
        }

    case 897:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4511; /* mve_vaddq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4517; /* mve_vaddq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4523; /* mve_vaddq_m_uv4si */

        default:
          return -1;
        }

    case 865:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4512; /* mve_vmulq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4518; /* mve_vmulq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4524; /* mve_vmulq_m_sv4si */

        default:
          return -1;
        }

    case 866:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4513; /* mve_vmulq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4519; /* mve_vmulq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4525; /* mve_vmulq_m_uv4si */

        default:
          return -1;
        }

    case 827:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4514; /* mve_vsubq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4520; /* mve_vsubq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4526; /* mve_vsubq_m_sv4si */

        default:
          return -1;
        }

    case 826:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4515; /* mve_vsubq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4521; /* mve_vsubq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4527; /* mve_vsubq_m_uv4si */

        default:
          return -1;
        }

    case 888:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4528; /* mve_vandq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4538; /* mve_vandq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4548; /* mve_vandq_m_sv4si */

        default:
          return -1;
        }

    case 887:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4529; /* mve_vandq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4539; /* mve_vandq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4549; /* mve_vandq_m_uv4si */

        default:
          return -1;
        }

    case 840:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4530; /* mve_vbicq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4540; /* mve_vbicq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4550; /* mve_vbicq_m_sv4si */

        default:
          return -1;
        }

    case 839:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4531; /* mve_vbicq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4541; /* mve_vbicq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4551; /* mve_vbicq_m_uv4si */

        default:
          return -1;
        }

    case 922:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4532; /* mve_veorq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4542; /* mve_veorq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4552; /* mve_veorq_m_sv4si */

        default:
          return -1;
        }

    case 923:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4533; /* mve_veorq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4543; /* mve_veorq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4553; /* mve_veorq_m_uv4si */

        default:
          return -1;
        }

    case 915:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4534; /* mve_vornq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4544; /* mve_vornq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4554; /* mve_vornq_m_sv4si */

        default:
          return -1;
        }

    case 914:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4535; /* mve_vornq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4545; /* mve_vornq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4555; /* mve_vornq_m_uv4si */

        default:
          return -1;
        }

    case 878:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4536; /* mve_vorrq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4546; /* mve_vorrq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4556; /* mve_vorrq_m_sv4si */

        default:
          return -1;
        }

    case 879:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4537; /* mve_vorrq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4547; /* mve_vorrq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4557; /* mve_vorrq_m_uv4si */

        default:
          return -1;
        }

    case 902:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 2689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4558; /* mve_vbrsrq_m_n_uv16qi */

        case 1:
          if (!
#line 2689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4560; /* mve_vbrsrq_m_n_uv8hi */

        case 2:
          if (!
#line 2689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4562; /* mve_vbrsrq_m_n_uv4si */

        default:
          return -1;
        }

    case 835:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 2689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4559; /* mve_vbrsrq_m_n_sv16qi */

        case 1:
          if (!
#line 2689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4561; /* mve_vbrsrq_m_n_sv8hi */

        case 2:
          if (!
#line 2689 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4563; /* mve_vbrsrq_m_n_sv4si */

        default:
          return -1;
        }

    case 927:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4564; /* mve_vhcaddq_rot90_m_sv16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4568; /* mve_vhcaddq_rot90_m_sv8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4572; /* mve_vhcaddq_rot90_m_sv4si */

        default:
          return -1;
        }

    case 937:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4565; /* mve_vhcaddq_rot270_m_sv16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4569; /* mve_vhcaddq_rot270_m_sv8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4573; /* mve_vhcaddq_rot270_m_sv4si */

        default:
          return -1;
        }

    case 913:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4566; /* mve_vcaddq_rot90_m_v16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4570; /* mve_vcaddq_rot90_m_v8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4574; /* mve_vcaddq_rot90_m_v4si */

        default:
          return -1;
        }

    case 859:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4567; /* mve_vcaddq_rot270_m_v16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4571; /* mve_vcaddq_rot270_m_v8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4575; /* mve_vcaddq_rot270_m_v4si */

        default:
          return -1;
        }

    case 919:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4576; /* mve_vhaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4594; /* mve_vhaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4612; /* mve_vhaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 926:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4577; /* mve_vhaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4595; /* mve_vhaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4613; /* mve_vhaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 889:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4578; /* mve_vhsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4596; /* mve_vhsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4614; /* mve_vhsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 890:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4579; /* mve_vhsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4597; /* mve_vhsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4615; /* mve_vhsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 844:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4580; /* mve_vmlaq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4598; /* mve_vmlaq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4616; /* mve_vmlaq_m_n_sv4si */

        default:
          return -1;
        }

    case 847:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4581; /* mve_vmlaq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4599; /* mve_vmlaq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4617; /* mve_vmlaq_m_n_uv4si */

        default:
          return -1;
        }

    case 855:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4582; /* mve_vmlasq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4600; /* mve_vmlasq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4618; /* mve_vmlasq_m_n_sv4si */

        default:
          return -1;
        }

    case 854:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4583; /* mve_vmlasq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4601; /* mve_vmlasq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4619; /* mve_vmlasq_m_n_uv4si */

        default:
          return -1;
        }

    case 906:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4584; /* mve_vqdmlahq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4602; /* mve_vqdmlahq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4620; /* mve_vqdmlahq_m_n_sv4si */

        default:
          return -1;
        }

    case 867:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4585; /* mve_vqdmlashq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4603; /* mve_vqdmlashq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4621; /* mve_vqdmlashq_m_n_sv4si */

        default:
          return -1;
        }

    case 877:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4586; /* mve_vqrdmlahq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4604; /* mve_vqrdmlahq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4622; /* mve_vqrdmlahq_m_n_sv4si */

        default:
          return -1;
        }

    case 868:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4587; /* mve_vqrdmlashq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4605; /* mve_vqrdmlashq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4623; /* mve_vqrdmlashq_m_n_sv4si */

        default:
          return -1;
        }

    case 899:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4588; /* mve_vqaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4606; /* mve_vqaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4624; /* mve_vqaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 921:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4589; /* mve_vqaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4607; /* mve_vqaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4625; /* mve_vqaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 849:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4590; /* mve_vqsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4608; /* mve_vqsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4626; /* mve_vqsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 848:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4591; /* mve_vqsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4609; /* mve_vqsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4627; /* mve_vqsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 936:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4592; /* mve_vqdmulhq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4610; /* mve_vqdmulhq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4628; /* mve_vqdmulhq_m_n_sv4si */

        default:
          return -1;
        }

    case 966:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4593; /* mve_vqrdmulhq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4611; /* mve_vqrdmulhq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4629; /* mve_vqrdmulhq_m_n_sv4si */

        default:
          return -1;
        }

    case 909:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4630; /* mve_vmladavaq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4635; /* mve_vmladavaq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4640; /* mve_vmladavaq_p_sv4si */

        default:
          return -1;
        }

    case 908:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4631; /* mve_vmladavaq_p_uv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4636; /* mve_vmladavaq_p_uv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4641; /* mve_vmladavaq_p_uv4si */

        default:
          return -1;
        }

    case 935:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4632; /* mve_vmlsdavaxq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4637; /* mve_vmlsdavaxq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4642; /* mve_vmlsdavaxq_p_sv4si */

        default:
          return -1;
        }

    case 940:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4633; /* mve_vmlsdavaq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4638; /* mve_vmlsdavaq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4643; /* mve_vmlsdavaq_p_sv4si */

        default:
          return -1;
        }

    case 932:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4634; /* mve_vmladavaxq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4639; /* mve_vmladavaxq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4644; /* mve_vmladavaxq_p_sv4si */

        default:
          return -1;
        }

    case 893:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4645; /* mve_vmullbq_int_m_uv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4649; /* mve_vmullbq_int_m_uv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4653; /* mve_vmullbq_int_m_uv4si */

        default:
          return -1;
        }

    case 894:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4646; /* mve_vmullbq_int_m_sv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4650; /* mve_vmullbq_int_m_sv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4654; /* mve_vmullbq_int_m_sv4si */

        default:
          return -1;
        }

    case 851:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4647; /* mve_vmulltq_int_m_uv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4651; /* mve_vmulltq_int_m_uv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4655; /* mve_vmulltq_int_m_uv4si */

        default:
          return -1;
        }

    case 850:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4648; /* mve_vmulltq_int_m_sv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4652; /* mve_vmulltq_int_m_sv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4656; /* mve_vmulltq_int_m_sv4si */

        default:
          return -1;
        }

    case 916:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4657; /* mve_vqshlq_m_n_sv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4661; /* mve_vqshlq_m_n_sv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4665; /* mve_vqshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 917:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4658; /* mve_vqshlq_m_n_uv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4662; /* mve_vqshlq_m_n_uv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4666; /* mve_vqshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 904:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4659; /* mve_vshlq_m_n_sv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4663; /* mve_vshlq_m_n_sv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4667; /* mve_vshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 907:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4660; /* mve_vshlq_m_n_uv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4664; /* mve_vshlq_m_n_uv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4668; /* mve_vshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 832:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4669; /* mve_vrshrq_m_n_sv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4673; /* mve_vrshrq_m_n_sv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4677; /* mve_vrshrq_m_n_sv4si */

        default:
          return -1;
        }

    case 871:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4670; /* mve_vrshrq_m_n_uv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4674; /* mve_vrshrq_m_n_uv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4678; /* mve_vrshrq_m_n_uv4si */

        default:
          return -1;
        }

    case 896:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4671; /* mve_vshrq_m_n_sv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4675; /* mve_vshrq_m_n_sv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4679; /* mve_vshrq_m_n_sv4si */

        default:
          return -1;
        }

    case 863:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4672; /* mve_vshrq_m_n_uv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4676; /* mve_vshrq_m_n_uv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4680; /* mve_vshrq_m_n_uv4si */

        default:
          return -1;
        }

    case 898:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4681; /* mve_vsliq_m_n_uv16qi */

        case 1:
          if (!
#line 2836 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4683; /* mve_vsliq_m_n_uv8hi */

        case 2:
          if (!
#line 2836 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4685; /* mve_vsliq_m_n_uv4si */

        default:
          return -1;
        }

    case 910:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4682; /* mve_vsliq_m_n_sv16qi */

        case 1:
          if (!
#line 2836 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4684; /* mve_vsliq_m_n_sv8hi */

        case 2:
          if (!
#line 2836 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4686; /* mve_vsliq_m_n_sv4si */

        default:
          return -1;
        }

    case 944:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4687; /* mve_vmlaldavaq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4692; /* mve_vmlaldavaq_p_sv4si */

        default:
          return -1;
        }

    case 943:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4688; /* mve_vmlaldavaq_p_uv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4693; /* mve_vmlaldavaq_p_uv4si */

        default:
          return -1;
        }

    case 962:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4689; /* mve_vmlaldavaxq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4694; /* mve_vmlaldavaxq_p_sv4si */

        default:
          return -1;
        }

    case 968:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4690; /* mve_vmlsldavaq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4695; /* mve_vmlsldavaq_p_sv4si */

        default:
          return -1;
        }

    case 969:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4691; /* mve_vmlsldavaxq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4696; /* mve_vmlsldavaxq_p_sv4si */

        default:
          return -1;
        }

    case 946:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4697; /* mve_vqrshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4717; /* mve_vqrshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 945:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4698; /* mve_vqrshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4718; /* mve_vqrshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 947:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4699; /* mve_vqrshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4719; /* mve_vqrshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 963:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4700; /* mve_vqrshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4720; /* mve_vqrshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 976:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4701; /* mve_vqrshrunbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4721; /* mve_vqrshrunbq_m_n_sv4si */

        default:
          return -1;
        }

    case 983:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4702; /* mve_vqrshruntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4722; /* mve_vqrshruntq_m_n_sv4si */

        default:
          return -1;
        }

    case 949:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4703; /* mve_vqshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4723; /* mve_vqshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 948:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4704; /* mve_vqshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4724; /* mve_vqshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 950:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4705; /* mve_vqshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4725; /* mve_vqshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 964:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4706; /* mve_vqshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4726; /* mve_vqshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 977:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4707; /* mve_vqshrunbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4727; /* mve_vqshrunbq_m_n_sv4si */

        default:
          return -1;
        }

    case 978:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4708; /* mve_vqshruntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4728; /* mve_vqshruntq_m_n_sv4si */

        default:
          return -1;
        }

    case 952:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4709; /* mve_vrshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4729; /* mve_vrshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 951:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4710; /* mve_vrshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4730; /* mve_vrshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 965:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4711; /* mve_vrshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4731; /* mve_vrshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 953:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4712; /* mve_vrshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4732; /* mve_vrshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 958:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4713; /* mve_vshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4733; /* mve_vshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 959:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4714; /* mve_vshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4734; /* mve_vshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 960:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4715; /* mve_vshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4735; /* mve_vshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 961:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4716; /* mve_vshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4736; /* mve_vshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 967:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4737; /* mve_vrmlaldavhaq_p_sv4si */

    case 979:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4738; /* mve_vrmlaldavhaq_p_uv4si */

    case 980:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4739; /* mve_vrmlaldavhaxq_p_sv4si */

    case 981:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4740; /* mve_vrmlsldavhaq_p_sv4si */

    case 982:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4741; /* mve_vrmlsldavhaxq_p_sv4si */

    case 954:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4742; /* mve_vshllbq_m_n_uv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4746; /* mve_vshllbq_m_n_uv8hi */

        default:
          return -1;
        }

    case 955:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4743; /* mve_vshllbq_m_n_sv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4747; /* mve_vshllbq_m_n_sv8hi */

        default:
          return -1;
        }

    case 956:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4744; /* mve_vshlltq_m_n_uv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4748; /* mve_vshlltq_m_n_uv8hi */

        default:
          return -1;
        }

    case 957:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4745; /* mve_vshlltq_m_n_sv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4749; /* mve_vshlltq_m_n_sv8hi */

        default:
          return -1;
        }

    case 970:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2945 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4750; /* mve_vmullbq_poly_m_pv16qi */

        case 1:
          if (!
#line 2945 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4752; /* mve_vmullbq_poly_m_pv8hi */

        default:
          return -1;
        }

    case 971:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2945 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4751; /* mve_vmulltq_poly_m_pv16qi */

        case 1:
          if (!
#line 2945 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4753; /* mve_vmulltq_poly_m_pv8hi */

        default:
          return -1;
        }

    case 972:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 2964 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4754; /* mve_vqdmullbq_m_n_sv8hi */

        case 1:
          if (!
#line 2964 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4756; /* mve_vqdmullbq_m_n_sv4si */

        default:
          return -1;
        }

    case 974:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 2964 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4755; /* mve_vqdmulltq_m_n_sv8hi */

        case 1:
          if (!
#line 2964 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4757; /* mve_vqdmulltq_m_n_sv4si */

        default:
          return -1;
        }

    case 973:
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 2983 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4758; /* mve_vqdmullbq_m_sv8hi */

        case 1:
          if (!
#line 2983 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4760; /* mve_vqdmullbq_m_sv4si */

        default:
          return -1;
        }

    case 975:
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 2983 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4759; /* mve_vqdmulltq_m_sv8hi */

        case 1:
          if (!
#line 2983 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4761; /* mve_vqdmulltq_m_sv4si */

        default:
          return -1;
        }

    case 901:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4762; /* mve_vabdq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4770; /* mve_vabdq_m_fv4sf */

        default:
          return -1;
        }

    case 920:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4763; /* mve_vaddq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4771; /* mve_vaddq_m_fv4sf */

        default:
          return -1;
        }

    case 992:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4764; /* mve_vfmaq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4772; /* mve_vfmaq_m_fv4sf */

        default:
          return -1;
        }

    case 995:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4765; /* mve_vfmsq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4773; /* mve_vfmsq_m_fv4sf */

        default:
          return -1;
        }

    case 996:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4766; /* mve_vmaxnmq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4774; /* mve_vmaxnmq_m_fv4sf */

        default:
          return -1;
        }

    case 997:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4767; /* mve_vminnmq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4775; /* mve_vminnmq_m_fv4sf */

        default:
          return -1;
        }

    case 861:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4768; /* mve_vmulq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4776; /* mve_vmulq_m_fv4sf */

        default:
          return -1;
        }

    case 998:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4769; /* mve_vsubq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4777; /* mve_vsubq_m_fv4sf */

        default:
          return -1;
        }

    case 872:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4778; /* mve_vaddq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4783; /* mve_vaddq_m_n_fv4sf */

        default:
          return -1;
        }

    case 993:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4779; /* mve_vfmaq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4784; /* mve_vfmaq_m_n_fv4sf */

        default:
          return -1;
        }

    case 994:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4780; /* mve_vfmasq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4785; /* mve_vfmasq_m_n_fv4sf */

        default:
          return -1;
        }

    case 853:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4781; /* mve_vmulq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4786; /* mve_vmulq_m_n_fv4sf */

        default:
          return -1;
        }

    case 836:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4782; /* mve_vsubq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4787; /* mve_vsubq_m_n_fv4sf */

        default:
          return -1;
        }

    case 886:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4788; /* mve_vandq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4793; /* mve_vandq_m_fv4sf */

        default:
          return -1;
        }

    case 837:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4789; /* mve_vbicq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4794; /* mve_vbicq_m_fv4sf */

        default:
          return -1;
        }

    case 903:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4790; /* mve_veorq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4795; /* mve_veorq_m_fv4sf */

        default:
          return -1;
        }

    case 843:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4791; /* mve_vornq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4796; /* mve_vornq_m_fv4sf */

        default:
          return -1;
        }

    case 880:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4792; /* mve_vorrq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4797; /* mve_vorrq_m_fv4sf */

        default:
          return -1;
        }

    case 900:
      return recog_258 (x1, insn, pnum_clobbers);

    case 895:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4800; /* mve_vcaddq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4806; /* mve_vcaddq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 858:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4801; /* mve_vcaddq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4807; /* mve_vcaddq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 988:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4802; /* mve_vcmulq_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4808; /* mve_vcmulq_m_fv4sf */

        default:
          return -1;
        }

    case 991:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4803; /* mve_vcmulq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4809; /* mve_vcmulq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 989:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4804; /* mve_vcmulq_rot180_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4810; /* mve_vcmulq_rot180_m_fv4sf */

        default:
          return -1;
        }

    case 990:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4805; /* mve_vcmulq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4811; /* mve_vcmulq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 984:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4812; /* mve_vcmlaq_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4816; /* mve_vcmlaq_m_fv4sf */

        default:
          return -1;
        }

    case 987:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4813; /* mve_vcmlaq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4817; /* mve_vcmlaq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 985:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4814; /* mve_vcmlaq_rot180_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4818; /* mve_vcmlaq_rot180_m_fv4sf */

        default:
          return -1;
        }

    case 986:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4815; /* mve_vcmlaq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4819; /* mve_vcmlaq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 1002:
      return recog_247 (x1, insn, pnum_clobbers);

    case 1004:
      return recog_252 (x1, insn, pnum_clobbers);

    case 1010:
      return recog_248 (x1, insn, pnum_clobbers);

    case 1000:
      return recog_251 (x1, insn, pnum_clobbers);

    case 1016:
      return recog_250 (x1, insn, pnum_clobbers);

    case 1026:
      return recog_249 (x1, insn, pnum_clobbers);

    case 1028:
      if (pattern93 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 3);
      operands[3] = x3;
      if (!vpr_register_operand (operands[3], E_V8BImode)
          || !
#line 3717 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4937; /* mve_vstrq_truncate_scatter_shifted_offset_p_v4si */

    default:
      return -1;
    }
}

 int
recog_344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case MULT:
      res = recog_335 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATERT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6777; /* *p rorv4hi3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6789; /* *p rorv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6778; /* *p rorv2si3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6790; /* *p rorv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6779; /* *p rordi3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6791; /* *p rordi3_di */
          break;

        default:
          break;
        }
      break;

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6780; /* *p ashrv4hi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6792; /* *p ashrv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6781; /* *p ashrv2si3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6793; /* *p ashrv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6782; /* *p ashrdi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6794; /* *p ashrdi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (arm_reg_or_long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1741 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 7000; /* *p thumb2_asrl */
                }
            }
        }
      break;

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6783; /* *p lshrv4hi3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6795; /* *p lshrv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6784; /* *p lshrv2si3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6796; /* *p lshrv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6785; /* *p lshrdi3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6797; /* *p lshrdi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1757 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 7002; /* *p thumb2_lsrl */
                }
            }
        }
      break;

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6786; /* *p ashlv4hi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6798; /* *p ashlv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6787; /* *p ashlv2si3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6799; /* *p ashlv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6788; /* *p ashldi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6800; /* *p ashldi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (arm_reg_or_long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1749 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 7001; /* *p thumb2_lsll */
                }
            }
        }
      break;

    default:
      break;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  operands[3] = x4;
  if (!shift_operator (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!reg_or_int_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4753 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
    return -1;
  return 6472; /* *p *arm_shiftsi3 */
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          if (XWINT (x6, 0) != 0L)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4127 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6459; /* *p *smin_0 */

        case REG:
        case SUBREG:
          switch (pattern441 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6747; /* *p *sminv2si3_iwmmxt */

            case 1:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6748; /* *p *sminv4hi3_iwmmxt */

            case 2:
              if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6749; /* *p *sminv8qi3_iwmmxt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern379 (x1))
        {
        case 0:
          if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return 6466; /* *p satsi_smin */
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return -1;
          return 6467; /* *p satsi_smin_setq */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4503 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return -1;
          return 6470; /* *p *satsi_smin_shift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_363 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[5] = x6;
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  x8 = XVECEXP (x2, 0, 0);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x3, 0);
  operands[3] = x12;
  x13 = XEXP (x5, 1);
  operands[4] = x13;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x14 = XEXP (x5, 0);
  if (!rtx_equal_p (x14, operands[1])
      || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12723 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[2]) + 4) == INTVAL (operands[4]))
     && (operands_ok_ldrd_strd (operands[0], operands[3],
                                  operands[1], INTVAL (operands[2]),
                                  false, true)))))
    return -1;
  return 6614; /* *p *thumb2_ldrd */
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11940 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6595; /* *p *load_multiple_with_writeback */

        case MEM:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x12 = XEXP (x7, 0);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != E_SImode)
            return -1;
          x14 = XEXP (x12, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x12, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[2] = x11;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[3])
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 993 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6662; /* *p *ldm2_da */

        case REG:
          operands[1] = x7;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          if (GET_CODE (x9) != MEM
              || GET_MODE (x9) != E_SImode)
            return -1;
          x16 = XEXP (x9, 0);
          if (GET_CODE (x16) != PLUS
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_SImode
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x18 = XEXP (x16, 0);
          operands[3] = x18;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x19 = XEXP (x11, 0);
          if (!rtx_equal_p (x19, operands[3])
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1018 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6664; /* *p *stm2_da */

        default:
          return -1;
        }

    case RETURN:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      if (!pop_multiple_return (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (GET_CODE (x8))
        {
        case PLUS:
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x20 = XEXP (x8, 1);
          operands[2] = x20;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11971 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6596; /* *p *pop_multiple_with_writeback_and_return */

        case MEM:
          x11 = XEXP (x3, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11994 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6597; /* *p *pop_multiple_with_return */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      if (XWINT (x2, 0) == 0L)
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == ZERO_EXTRACT
              && pattern247 (x3) == 0)
            return gen_split_13 (insn, operands);
        }
      operands[1] = x2;
      if (const_int_operand (operands[1], E_SImode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (arm_general_register_operand (operands[0], E_SImode)
              && 
#line 6577 "../../gcc-15.1.0/gcc/config/arm/arm.md"
((TARGET_32BIT || TARGET_HAVE_MOVT)
  && (!(const_ok_for_arm (INTVAL (operands[1]))
        || const_ok_for_arm (~INTVAL (operands[1]))))))
            return gen_split_63 (insn, operands);
        }
      break;

    case CONST:
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) == PLUS
              && GET_MODE (x4) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (arm_general_register_operand (operands[0], E_SImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (general_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x4, 1);
                      operands[2] = x6;
                      if (const_int_operand (operands[2], E_SImode)
                          && 
#line 6606 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_THUMB
   && TARGET_HAVE_MOVT
   && arm_disable_literal_pool
   && reload_completed
   && GET_CODE (operands[1]) == SYMBOL_REF))
                        return gen_split_64 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!arm_general_register_operand (operands[0], E_DImode))
        return NULL;
      if (immediate_operand (operands[1], E_DImode)
          && 
#line 6378 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_40 (insn, operands);
      if (const_double_operand (operands[1], E_DImode)
          && 
#line 6408 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_47 (insn, operands);
      if (!immediate_operand (operands[1], E_DImode)
          || !
#line 752 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_119 (insn, operands);

    case E_DFmode:
      if (arm_general_register_operand (operands[0], E_DFmode))
        {
          if (immediate_operand (operands[1], E_DFmode)
              && 
#line 6378 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
            return gen_split_41 (insn, operands);
          if (const_double_operand (operands[1], E_DFmode)
              && 
#line 6408 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
            return gen_split_48 (insn, operands);
        }
      if (s_register_operand (operands[0], E_DFmode)
          && const_double_operand (operands[1], E_DFmode)
          && 
#line 7658 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_disable_literal_pool && TARGET_SOFT_FLOAT))
        return gen_split_70 (insn, operands);
      if (!arm_general_register_operand (operands[0], E_DFmode)
          || !immediate_operand (operands[1], E_DFmode)
          || !
#line 752 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_120 (insn, operands);

    case E_V8QImode:
      if (!arm_general_register_operand (operands[0], E_V8QImode))
        return NULL;
      if (immediate_operand (operands[1], E_V8QImode)
          && 
#line 6378 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_42 (insn, operands);
      if (const_double_operand (operands[1], E_V8QImode)
          && 
#line 6408 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_49 (insn, operands);
      if (!immediate_operand (operands[1], E_V8QImode)
          || !
#line 752 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_121 (insn, operands);

    case E_V4HImode:
      if (!arm_general_register_operand (operands[0], E_V4HImode))
        return NULL;
      if (immediate_operand (operands[1], E_V4HImode)
          && 
#line 6378 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_43 (insn, operands);
      if (const_double_operand (operands[1], E_V4HImode)
          && 
#line 6408 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_50 (insn, operands);
      if (!immediate_operand (operands[1], E_V4HImode)
          || !
#line 752 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_122 (insn, operands);

    case E_V4HFmode:
      if (!arm_general_register_operand (operands[0], E_V4HFmode))
        return NULL;
      if (immediate_operand (operands[1], E_V4HFmode)
          && 
#line 6378 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_44 (insn, operands);
      if (const_double_operand (operands[1], E_V4HFmode)
          && 
#line 6408 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_51 (insn, operands);
      if (!immediate_operand (operands[1], E_V4HFmode)
          || !
#line 752 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_123 (insn, operands);

    case E_V2SImode:
      if (!arm_general_register_operand (operands[0], E_V2SImode))
        return NULL;
      if (immediate_operand (operands[1], E_V2SImode)
          && 
#line 6378 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_45 (insn, operands);
      if (const_double_operand (operands[1], E_V2SImode)
          && 
#line 6408 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_52 (insn, operands);
      if (!immediate_operand (operands[1], E_V2SImode)
          || !
#line 752 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_124 (insn, operands);

    case E_V2SFmode:
      if (!arm_general_register_operand (operands[0], E_V2SFmode))
        return NULL;
      if (immediate_operand (operands[1], E_V2SFmode)
          && 
#line 6378 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_46 (insn, operands);
      if (const_double_operand (operands[1], E_V2SFmode)
          && 
#line 6408 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_53 (insn, operands);
      if (!immediate_operand (operands[1], E_V2SFmode)
          || !
#line 752 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_125 (insn, operands);

    case E_SFmode:
      if (arm_general_register_operand (operands[0], E_SFmode)
          && immediate_operand (operands[1], E_SFmode)
          && 
#line 7487 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER
   && reload_completed
   && CONST_DOUBLE_P (operands[1])))
        return gen_split_68 (insn, operands);
      if (!s_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 7531 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_disable_literal_pool && TARGET_SOFT_FLOAT))
        return NULL;
      return gen_split_69 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      res = split_4 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case AND:
    case IOR:
    case XOR:
      res = split_6 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (!shiftable_operator_strict_it (x3, E_SImode))
    return NULL;
  operands[5] = x3;
  x4 = XEXP (x3, 0);
  if (!arm_comparison_operator (x4, E_SImode))
    return NULL;
  operands[4] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return NULL;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  if (!arm_rhs_operand (operands[3], E_SImode))
    return NULL;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode)
      || !(
#line 798 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 800 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed)))
    return NULL;
  return gen_split_149 (insn, operands);
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NE:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x5 = XEXP (x4, 2);
          if (GET_CODE (x5) != CONST_INT)
            return NULL;
          operands[3] = x5;
          if (const_int_operand (operands[3], E_SImode))
            {
              x6 = XEXP (x3, 1);
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x7 = XEXP (x4, 0);
                  operands[1] = x7;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x8 = XEXP (x4, 1);
                      operands[2] = x8;
                      if (const_int_operand (operands[2], E_SImode)
                          && 
#line 3122 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)))
                        return gen_split_7 (insn, operands);
                    }
                }
            }
          if (XWINT (x5, 0) != 0L)
            return NULL;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 3156 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return NULL;
          return gen_split_8 (insn, operands);

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 9921 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return gen_split_84 (insn, operands);
          if (!arm_add_operand (operands[2], E_SImode)
              || !
#line 9937 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return NULL;
          return gen_split_85 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 9880 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_80 (insn, operands);

    case GE:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 9888 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_81 (insn, operands);

    case EQ:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      if (
#line 9897 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_arch5t && TARGET_32BIT))
        return gen_split_82 (insn, operands);
      if (!
#line 9907 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_83 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x8 = XEXP (x4, 1);
  operands[5] = x8;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x9 = XEXP (x5, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x10 = XEXP (x5, 1);
  operands[6] = x10;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x11 = XEXP (x6, 0);
  operands[3] = x11;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  x12 = XEXP (x6, 1);
  operands[7] = x12;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_20 (insn, operands);
}

 rtx_insn *
peephole2_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!memory_operand (x2, E_SImode))
    return NULL;
  operands[2] = x2;
  if (arm_general_register_operand (operands[0], E_SImode))
    {
      res = peephole2_7 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 4)
    return NULL;
  operands[4] = x2;
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x5 = XEXP (x3, 1);
  operands[5] = x5;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XEXP (x6, 1);
  operands[6] = x8;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x9 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  x11 = XEXP (x9, 1);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_19 (insn, operands);
}

 rtx_insn *
peephole2_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  switch (pattern494 (x3))
    {
    case 0:
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (2));
      x5 = XEXP (x4, 1);
      operands[5] = x5;
      if (!const_int_operand (operands[5], E_SImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (3));
      x7 = XEXP (x6, 1);
      if (!rtx_equal_p (x7, operands[1])
          || !
#line 67 "../../gcc-15.1.0/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_15 (insn, operands);

    case 1:
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (2));
      x9 = XEXP (x4, 0);
      operands[2] = x9;
      if (!memory_operand (operands[2], E_SImode))
        return NULL;
      x5 = XEXP (x4, 1);
      if (!rtx_equal_p (x5, operands[0]))
        return NULL;
      x6 = PATTERN (peep2_next_insn (3));
      x7 = XEXP (x6, 1);
      if (!rtx_equal_p (x7, operands[1])
          || !
#line 86 "../../gcc-15.1.0/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_16 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != CONST_INT)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (arm_general_register_operand (operands[0], E_SImode))
        {
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          if (arm_general_register_operand (operands[1], E_SImode))
            {
              operands[2] = x3;
              if (const_int_operand (operands[2], E_SImode)
                  && 
#line 928 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT &&
   !(const_ok_for_arm (INTVAL (operands[2]))
     || const_ok_for_arm (-INTVAL (operands[2])))
    && const_ok_for_arm (~INTVAL (operands[2]))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_1 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (register_operand (operands[2], E_SImode)
          && register_operand (operands[0], E_SImode))
        {
          res = peephole2_1 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (!cc_register (operands[2], E_VOIDmode)
          || XWINT (x3, 0) != -1L
          || !arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != COMPARE)
        return NULL;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != IF_THEN_ELSE)
        return NULL;
      x13 = XEXP (x12, 0);
      if (!equality_operator (x13, E_VOIDmode))
        return NULL;
      operands[3] = x13;
      x14 = XEXP (x13, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x15 = XEXP (x11, 0);
      if (GET_CODE (x15) != PC)
        return NULL;
      x16 = XEXP (x12, 1);
      operands[4] = x16;
      x17 = XEXP (x12, 2);
      operands[5] = x17;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[2])
          || !
#line 1216 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && peep2_reg_dead_p (3, operands[2])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_4 (insn, operands);

    case COMPARE:
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (GET_MODE (x5) != E_DImode)
            return NULL;
          x19 = XEXP (x5, 0);
          if (GET_CODE (x19) != SIGN_EXTEND
              || GET_MODE (x19) != E_DImode)
            return NULL;
          x3 = XEXP (x2, 1);
          if (pattern321 (x3, 
E_SImode, 
PLUS, 
E_DImode, 
SIGN_EXTEND) != 0
              || pattern26 (x1, 
E_CC_Vmode) != 0)
            return NULL;
          x20 = XEXP (x19, 0);
          operands[0] = x20;
          if (!low_register_operand (operands[0], E_SImode))
            return NULL;
          x21 = XEXP (x5, 1);
          operands[1] = x21;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return NULL;
          x22 = XEXP (x3, 0);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[0]))
            return NULL;
          x24 = XEXP (x22, 1);
          if (!rtx_equal_p (x24, operands[1]))
            return NULL;
          if (
#line 1088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_THUMB2
   && satisfies_constraint_Pd (operands[1])))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 1107 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_THUMB2
   && dead_or_set_p (peep2_next_insn (0), operands[0])
   && satisfies_constraint_Py (operands[1])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_3 (insn, operands);

        case REG:
        case SUBREG:
          if (peep2_current_count >= 2)
            {
              res = peephole2_2 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return NULL;
          if (peep2_current_count >= 2)
            {
              res = peephole2_3 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[0] = x4;
          if (!cc_register (operands[0], E_CCmode)
              || GET_MODE (x2) != E_CCmode
              || !low_register_operand (operands[1], E_SImode))
            return NULL;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          if (
#line 1341 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && peep2_reg_dead_p (1, operands[1])
   && satisfies_constraint_Pw (operands[2])))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_41 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 1355 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && satisfies_constraint_Px (operands[2])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_42 (insn, operands);

        case ZERO_EXTRACT:
          if (peep2_current_count < 2
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != CONST_INT)
            return NULL;
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!cc_register (operands[0], E_CC_NZmode)
              || GET_MODE (x2) != E_CC_NZmode)
            return NULL;
          x19 = XEXP (x5, 0);
          operands[1] = x19;
          if (!low_register_operand (operands[1], E_SImode))
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != SET)
            return NULL;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != IF_THEN_ELSE)
            return NULL;
          x10 = XEXP (x8, 0);
          if (!equality_operator (x10, E_CC_NZmode))
            return NULL;
          operands[4] = x10;
          x25 = XEXP (x10, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != PC)
            return NULL;
          x9 = XEXP (x8, 1);
          operands[5] = x9;
          x26 = XEXP (x8, 2);
          operands[6] = x26;
          x27 = XEXP (x10, 0);
          if (!rtx_equal_p (x27, operands[0]))
            return NULL;
          if (XWINT (x21, 0) == 1L)
            {
              x28 = XEXP (x5, 2);
              operands[2] = x28;
              if (const_int_operand (operands[2], E_SImode)
                  && 
#line 1566 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && (INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) < 32)
   && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_43 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x28 = XEXP (x5, 2);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          operands[2] = x21;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 1595 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && (INTVAL (operands[2]) > 0 && INTVAL (operands[2]) < 32)
   && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_44 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 2051 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !const_ok_for_arm (INTVAL (operands[1]))
   && const_ok_for_arm (~INTVAL (operands[1]))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_5 (insn, operands);

    case IOR:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 3766 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM
   && !const_ok_for_arm (INTVAL (operands[2]))
   && const_ok_for_arm (~INTVAL (operands[2]))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_6 (insn, operands);

    case UNSPEC:
      if (peep2_current_count < 2
          || XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 2
          || GET_MODE (x2) != E_SImode)
        return NULL;
      x29 = XVECEXP (x2, 0, 1);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x30 = XVECEXP (x2, 0, 0);
      operands[3] = x30;
      if (!register_operand (operands[3], E_SImode))
        return NULL;
      x31 = XVECEXP (x2, 0, 2);
      operands[1] = x31;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!arm_general_register_operand (operands[2], E_SImode))
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 6793 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_7 (insn, operands);

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (peep2_current_count < 2)
            return NULL;
          operands[0] = x4;
          res = peephole2_6 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != SET)
            return NULL;
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              operands[0] = x2;
              if (arm_general_register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x6, 0);
                  operands[3] = x7;
                  if (memory_operand (operands[3], E_SImode))
                    {
                      x8 = XEXP (x6, 1);
                      operands[1] = x8;
                      if (arm_general_register_operand (operands[1], E_SImode)
                          && 
#line 49 "../../gcc-15.1.0/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_14 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (peep2_current_count >= 3)
            {
              res = peephole2_10 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[0] = x4;
          if (pattern322 (x2) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_29 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              operands[0] = x2;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x6, 0);
                  operands[3] = x7;
                  if (memory_operand (operands[3], E_SImode))
                    {
                      x8 = XEXP (x6, 1);
                      operands[1] = x8;
                      if (s_register_operand (operands[1], E_SImode))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_32 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (peep2_current_count < 3)
            return NULL;
          operands[0] = x4;
          if (pattern322 (x2) != 0)
            return NULL;
          x11 = PATTERN (peep2_next_insn (2));
          switch (GET_CODE (x11))
            {
            case PARALLEL:
              if (pattern566 (x11) != 0
                  || !s_register_operand (operands[4], E_SImode))
                return NULL;
              x32 = XVECEXP (x11, 0, 0);
              x33 = XEXP (x32, 1);
              x34 = XEXP (x33, 0);
              operands[6] = x34;
              if (!s_register_operand (operands[6], E_SImode))
                return NULL;
              x35 = XEXP (x33, 1);
              operands[7] = x35;
              if (!s_register_operand (operands[7], E_SImode)
                  || !
#line 1163 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(((((REGNO (operands[6]) == REGNO (operands[0]))
         && (REGNO (operands[7]) == REGNO (operands[1])))
      || ((REGNO (operands[7]) == REGNO (operands[0]))
         && (REGNO (operands[6]) == REGNO (operands[1]))))
    && (peep2_regno_dead_p (3, REGNO (operands[0]))
      || (REGNO (operands[0]) == REGNO (operands[4])))
    && (peep2_regno_dead_p (3, REGNO (operands[1]))
      || (REGNO (operands[1]) == REGNO (operands[4]))))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_33 (insn, operands);

            case SET:
              x12 = XEXP (x11, 1);
              if (!commutative_binary_operator (x12, E_SImode))
                return NULL;
              operands[5] = x12;
              x15 = XEXP (x11, 0);
              operands[4] = x15;
              if (!s_register_operand (operands[4], E_SImode))
                return NULL;
              x13 = XEXP (x12, 0);
              operands[6] = x13;
              if (!s_register_operand (operands[6], E_SImode))
                return NULL;
              x16 = XEXP (x12, 1);
              operands[7] = x16;
              if (!s_register_operand (operands[7], E_SImode)
                  || !
#line 1188 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(((((REGNO (operands[6]) == REGNO (operands[0]))
         && (REGNO (operands[7]) == REGNO (operands[1])))
      || ((REGNO (operands[7]) == REGNO (operands[0]))
         && (REGNO (operands[6]) == REGNO (operands[1]))))
    && (peep2_regno_dead_p (3, REGNO (operands[0]))
      || (REGNO (operands[0]) == REGNO (operands[4])))
    && (peep2_regno_dead_p (3, REGNO (operands[1]))
      || (REGNO (operands[1]) == REGNO (operands[4]))))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_34 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          operands[0] = x4;
          operands[1] = x2;
          if (memory_operand (operands[1], E_DImode)
              && low_register_operand (operands[0], E_DImode)
              && 
#line 663 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[1], 0), SImode)
   && !reg_overlap_mentioned_p (XEXP (operands[1], 0), operands[0])
   && peep2_reg_dead_p (1, XEXP (operands[1], 0))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_37 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!low_register_operand (operands[1], E_DImode)
              || !memory_operand (operands[0], E_DImode)
              || !
#line 679 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[0], 0), SImode)
   && peep2_reg_dead_p (1, XEXP (operands[0], 0))
   /* The low register in the transfer list may overlap the address,
      but the second cannot.  */
   && REGNO (XEXP (operands[0], 0)) != (REGNO (operands[1]) + 1)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_39 (insn, operands);

        case E_DFmode:
          operands[0] = x4;
          operands[1] = x2;
          if (memory_operand (operands[1], E_DFmode)
              && low_register_operand (operands[0], E_DFmode)
              && 
#line 663 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[1], 0), SImode)
   && !reg_overlap_mentioned_p (XEXP (operands[1], 0), operands[0])
   && peep2_reg_dead_p (1, XEXP (operands[1], 0))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_38 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!low_register_operand (operands[1], E_DFmode)
              || !memory_operand (operands[0], E_DFmode)
              || !
#line 679 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[0], 0), SImode)
   && peep2_reg_dead_p (1, XEXP (operands[0], 0))
   /* The low register in the transfer list may overlap the address,
      but the second cannot.  */
   && REGNO (XEXP (operands[0], 0)) != (REGNO (operands[1]) + 1)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_40 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (peep2_current_count < 2
          || !const_int_operand (x2, E_SImode))
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (peep2_current_count >= 3)
        {
          res = peephole2_14 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (!low_register_operand (operands[0], E_SImode))
        return NULL;
      operands[1] = x2;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != PLUS
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 13
          || GET_MODE (x9) != E_SImode)
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 120 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && UINTVAL (operands[1]) < 1024
   && (UINTVAL (operands[1]) & 3) == 0))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_35 (insn, operands);

    default:
      return NULL;
    }
}
