/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case PLUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!arm_borrow_operation (operands[3], E_DImode))
        return -1;
      return 0;

    case GEU:
    case LTU:
      operands[2] = x6;
      if (!arm_borrow_operation (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!immediate_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern32 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !s_register_operand (operands[1], E_V16QImode)
      || !s_register_operand (operands[2], i1)
      || !mve_imm_8 (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern59 (x3, 
E_V2QImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern51 (x3, 
E_V8BImode, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern51 (x3, 
E_V4BImode, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[1] = x7;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !s_register_operand (operands[1], i1))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], i2))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern125 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern125 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern125 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern125 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern125 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern125 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V8QImode:
      return 0;

    case E_V4HImode:
      return 1;

    case E_V4HFmode:
      return 2;

    case E_V4BFmode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V2SFmode:
      return 5;

    case E_DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 2;

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern186 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern34 (x3, 
E_V4HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern34 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern209 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern209 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern209 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern205 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern201 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern206 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 3);
  operands[3] = x8;
  return 0;
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      if (XINT (x2, 1) != 25
          || GET_MODE (x2) != E_HImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      return 0;

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SCRATCH)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      switch (XINT (x2, 1))
        {
        case 1011:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x1) != E_V8HImode
                  || GET_MODE (x2) != E_V8QImode
                  || !s_register_operand (operands[2], E_V8HImode))
                return -1;
              return 1;

            case E_V4SImode:
              if (!s_register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x1) != E_V4SImode
                  || !s_register_operand (operands[2], E_V4SImode))
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4QImode:
                  return 2;

                case E_V4HImode:
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1017:
          if (GET_MODE (x2) != E_V4HImode
              || !s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !s_register_operand (operands[2], E_V4SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x4 = XVECEXP (x2, 0, 2);
      operands[3] = x4;
      switch (XINT (x2, 1))
        {
        case 1012:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x1) != E_V8HImode
                  || GET_MODE (x2) != E_V8QImode
                  || !s_register_operand (operands[2], E_V8HImode)
                  || !vpr_register_operand (operands[3], E_V8BImode))
                return -1;
              return 5;

            case E_V4SImode:
              if (!s_register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x1) != E_V4SImode
                  || !s_register_operand (operands[2], E_V4SImode)
                  || !vpr_register_operand (operands[3], E_V4BImode))
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4QImode:
                  return 6;

                case E_V4HImode:
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1018:
          if (GET_MODE (x2) != E_V4HImode
              || !s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !s_register_operand (operands[2], E_V4SImode)
              || !vpr_register_operand (operands[3], E_V4BImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern282 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern281 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern281 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern281 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern281 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern281 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern281 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arm_add_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  if (!s_register_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[5] = x7;
  if (!arm_add_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode
          || !mve_memory_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4QImode:
          if (!mve_memory_operand (operands[1], E_V4QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!mve_memory_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern310 (x6, 
E_SImode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern311 (x6, 
E_V8QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern311 (x6, 
E_V2SImode) != 0)
        return -1;
      return 3;

    case E_V4QQmode:
      if (pattern310 (x6, 
E_V4QQmode) != 0)
        return -1;
      return 4;

    case E_V2HQmode:
      if (pattern310 (x6, 
E_V2HQmode) != 0)
        return -1;
      return 5;

    case E_QQmode:
      if (pattern310 (x6, 
E_QQmode) != 0)
        return -1;
      return 6;

    case E_HQmode:
      if (pattern310 (x6, 
E_HQmode) != 0)
        return -1;
      return 7;

    case E_V2HAmode:
      if (pattern310 (x6, 
E_V2HAmode) != 0)
        return -1;
      return 8;

    case E_HAmode:
      if (pattern310 (x6, 
E_HAmode) != 0)
        return -1;
      return 9;

    case E_SQmode:
      if (pattern310 (x6, 
E_SQmode) != 0)
        return -1;
      return 10;

    case E_SAmode:
      if (pattern310 (x6, 
E_SAmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 101
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_V4SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[4] = x10;
  if (!vpr_register_operand (operands[4], E_V4BImode))
    return -1;
  return 0;
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode
          || !mve_memory_operand (operands[1], E_V8QImode)
          || !vpr_register_operand (operands[2], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode
          || !vpr_register_operand (operands[2], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4QImode:
          if (!mve_memory_operand (operands[1], E_V4QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!mve_memory_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || !vfp_compare_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || !vfp_compare_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern372 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !neon_logic_op2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern378 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return pattern377 (x3); /* [-1, 4] */
}

int
pattern383 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (!rtx_equal_p (x4, operands[3]))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!rtx_equal_p (x5, operands[6]))
            return -1;
          x6 = XVECEXP (x1, 0, 0);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if (!dominant_cc_register (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 1);
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          if (!arm_add_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x9, 1);
          x14 = XEXP (x13, 0);
          operands[4] = x14;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x15 = XEXP (x13, 1);
          operands[5] = x15;
          if (!arm_add_operand (operands[5], E_SImode))
            return -1;
          x16 = XEXP (x2, 0);
          operands[7] = x16;
          if (!s_register_operand (operands[7], E_SImode))
            return -1;
          return 0;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  return 0;
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern421 (x1) != 0)
    return -1;
  return 0;
}

int
pattern429 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !neon_struct_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !s_register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern443 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != MEM)
        return -1;
      return 0;

    case REG:
      operands[1] = x3;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      return 0;

    case E_V16QImode:
      return 1;

    case E_V4HImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V4HFmode:
      return 6;

    case E_V8HFmode:
      return 7;

    case E_V4BFmode:
      return 8;

    case E_V8BFmode:
      return 9;

    case E_V2SFmode:
      return 10;

    case E_V4SFmode:
      return 11;

    case E_DImode:
      return 12;

    case E_V2DImode:
      return 13;

    default:
      return -1;
    }
}

int
pattern474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern479 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern490 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!s_register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case ASHIFTRT:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern503 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  return pattern501 (x2, 
i1, 
i2); /* [-1, 1] */
}

int
pattern509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || GET_MODE (x1) != E_V8QImode)
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern518 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || !register_operand (operands[1], E_V4HImode)
      || !register_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern535 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern543 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern554 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || !vfp_compare_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || !vfp_compare_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern564 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  if (!arm_add_operand (operands[4], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[1] = x6;
  if (!arm_rhs_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x1, 2);
  operands[2] = x7;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern586 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern598 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern605 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern613 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern611 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern611 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern611 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern612 (x1) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern625 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case ASHIFTRT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern634 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!load_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_hard_general_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern643 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x3, 1);
  x17 = XVECEXP (x16, 0, 0);
  switch (XWINT (x17, 0))
    {
    case 1L:
      x18 = XVECEXP (x16, 0, 1);
      if (XWINT (x18, 0) != 3L)
        return -1;
      x19 = XEXP (x8, 1);
      x20 = XVECEXP (x19, 0, 0);
      if (XWINT (x20, 0) != 0L)
        return -1;
      x21 = XVECEXP (x19, 0, 1);
      if (XWINT (x21, 0) != 2L)
        return -1;
      return 0;

    case 0L:
      x18 = XVECEXP (x16, 0, 1);
      if (XWINT (x18, 0) != 2L)
        return -1;
      x19 = XEXP (x8, 1);
      x20 = XVECEXP (x19, 0, 0);
      if (XWINT (x20, 0) != 1L)
        return -1;
      x21 = XVECEXP (x19, 0, 1);
      if (XWINT (x21, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case PLUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (pattern418 (x7, 
PLUS) != 0
          || GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      if (!arm_carry_operation (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          x11 = XEXP (x4, 1);
          if (pattern477 (x11, 
PLUS) != 0
              || GET_MODE (x3) != E_CC_Vmode
              || GET_MODE (x4) != E_CC_Vmode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x11, 0);
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 0);
          operands[4] = x15;
          if (!arm_carry_operation (operands[4], E_SImode))
            return -1;
          x16 = XEXP (x14, 1);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[4]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x5, 1);
          switch (GET_CODE (x21))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x21, 0);
              operands[2] = x22;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x23 = XEXP (x13, 1);
              if (!rtx_equal_p (x23, operands[2]))
                return -1;
              x24 = XEXP (x17, 1);
              if (!rtx_equal_p (x24, operands[2])
                  || !
#line 643 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 1; /* *addsi3_cin_vout_reg_insn */

            case CONST_INT:
              operands[2] = x21;
              if (!arm_adcimm_operand (operands[2], E_VOIDmode))
                return -1;
              x23 = XEXP (x13, 1);
              if (!rtx_equal_p (x23, operands[2]))
                return -1;
              x24 = XEXP (x17, 1);
              if (!rtx_equal_p (x24, operands[2])
                  || !
#line 689 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 2; /* *addsi3_cin_vout_imm_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != CONST_INT
              || XWINT (x11, 0) != 4294967296L
              || GET_MODE (x3) != E_CC_ADCmode
              || GET_MODE (x4) != E_CC_ADCmode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          operands[4] = x19;
          if (!arm_carry_operation (operands[4], E_SImode))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x5, 1);
          switch (GET_CODE (x21))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x21, 0);
              operands[2] = x22;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x24 = XEXP (x17, 1);
              if (!rtx_equal_p (x24, operands[2])
                  || !
#line 821 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 4; /* *addsi3_cin_cout_reg_insn */

            case CONST_INT:
              operands[5] = x21;
              if (!const_int_operand (operands[5], E_DImode))
                return -1;
              x24 = XEXP (x17, 1);
              operands[2] = x24;
              if (!arm_adcimm_operand (operands[2], E_SImode)
                  || !
#line 865 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[2]) & 0xffffffff) == UINTVAL (operands[5])))
                return -1;
              return 5; /* *addsi3_cin_cout_imm_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x6;
      if (!arm_carry_operation (operands[2], E_DImode)
          || pattern445 (x1, 
E_DImode) != 0)
        return -1;
      x21 = XEXP (x5, 1);
      if (GET_MODE (x21) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_CODE (x21))
        {
        case SIGN_EXTEND:
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_DImode)
            return -1;
          x13 = XEXP (x11, 0);
          if (GET_CODE (x13) != PLUS
              || GET_MODE (x13) != E_SImode
              || GET_MODE (x3) != E_CC_Vmode
              || GET_MODE (x4) != E_CC_Vmode)
            return -1;
          x22 = XEXP (x21, 0);
          operands[1] = x22;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x23 = XEXP (x13, 1);
          if (!rtx_equal_p (x23, operands[1]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          x24 = XEXP (x17, 1);
          if (!rtx_equal_p (x24, operands[1])
              || !
#line 725 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 3; /* *addsi3_cin_vout_0_insn */

        case ZERO_EXTEND:
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != CONST_INT
              || XWINT (x11, 0) != 4294967296L
              || GET_MODE (x3) != E_CC_ADCmode
              || GET_MODE (x4) != E_CC_ADCmode)
            return -1;
          x22 = XEXP (x21, 0);
          operands[1] = x22;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          operands[3] = x18;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x24 = XEXP (x17, 1);
          if (!rtx_equal_p (x24, operands[1])
              || !
#line 900 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 6; /* *addsi3_cin_cout_0_insn */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_DImode
          || GET_MODE (x5) != E_DImode)
        return -1;
      x21 = XEXP (x5, 1);
      switch (GET_CODE (x21))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x21) != E_DImode
              || pattern476 (x1) != 0)
            return -1;
          x22 = XEXP (x21, 0);
          operands[2] = x22;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode)
              || pattern614 (x1) != 0
              || !
#line 992 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 8; /* addsi3_compareV_reg */

        case CONST_INT:
          if (pattern476 (x1) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x4, 1);
          x13 = XEXP (x11, 0);
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          if (XWINT (x21, 0) == 2147483648L)
            {
              x23 = XEXP (x13, 1);
              if (GET_CODE (x23) == CONST_INT
                  && XWINT (x23, 0) == -2147483648L)
                {
                  x24 = XEXP (x17, 1);
                  if (GET_CODE (x24) == CONST_INT
                      && XWINT (x24, 0) == -2147483648L
                      && 
#line 1025 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return 10; /* subvsi3_intmin */
                }
            }
          operands[2] = x21;
          if (!arm_addimm_operand (operands[2], E_VOIDmode))
            return -1;
          x23 = XEXP (x13, 1);
          if (!rtx_equal_p (x23, operands[2]))
            return -1;
          x24 = XEXP (x17, 1);
          if (!rtx_equal_p (x24, operands[2])
              || !
#line 1041 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && INTVAL (operands[2]) == ARM_SIGN_EXTEND (INTVAL (operands[2]))))
            return -1;
          return 11; /* addsi3_compareV_imm */

        case GEU:
        case LTU:
          operands[3] = x21;
          if (!arm_borrow_operation (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || GET_MODE (x3) != E_CC_SWPmode
              || GET_MODE (x4) != E_CC_SWPmode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x4, 1);
          operands[1] = x11;
          if (!arm_immediate_operand (operands[1], E_VOIDmode))
            return -1;
          x10 = XEXP (x7, 0);
          operands[0] = x10;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 2128 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 50; /* rscsi3_CC_NVout_scratch */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern445 (x1, 
E_SImode) != 0)
        return -1;
      x21 = XEXP (x5, 1);
      operands[2] = x21;
      if (!arm_add_operand (operands[2], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x17 = XEXP (x7, 1);
      x18 = XEXP (x17, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x24 = XEXP (x17, 1);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      x11 = XEXP (x4, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) == 0L
              && GET_MODE (x3) == E_CC_NZmode
              && GET_MODE (x4) == E_CC_NZmode)
            {
              if (
#line 1127 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 13; /* addsi3_compare0 */
              if (
#line 1371 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1059; /* thumb2_addsi3_compare0 */
            }
          break;

        case REG:
        case SUBREG:
          if (rtx_equal_p (x11, operands[1])
              && GET_MODE (x3) == E_CC_Cmode
              && GET_MODE (x4) == E_CC_Cmode
              && 
#line 1245 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 17; /* addsi3_compare_op1 */
          break;

        default:
          break;
        }
      if (GET_MODE (x3) != E_CC_Cmode
          || GET_MODE (x4) != E_CC_Cmode
          || !rtx_equal_p (x11, operands[2])
          || !
#line 1270 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 18; /* *addsi3_compare_op2 */

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern446 (x2, 
E_DImode, 
E_CC_SWPmode) != 0)
        return -1;
      x21 = XEXP (x5, 1);
      operands[3] = x21;
      if (!arm_borrow_operation (operands[3], E_DImode))
        return -1;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      if (!arm_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 2128 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 51; /* rscsi3_CC_Bout_scratch */

    case MULT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x4, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern446 (x2, 
E_SImode, 
E_CC_NZmode) != 0)
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x21 = XEXP (x5, 1);
      operands[3] = x21;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (pattern588 (x7, 
MULT, 
PLUS))
        {
        case 0:
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x24 = XEXP (x17, 1);
          if (!rtx_equal_p (x24, operands[3]))
            return -1;
          if (
#line 2363 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
            return 63; /* *mulsi3addsi_compare0 */
          if (!
#line 2380 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
            return -1;
          return 64; /* *mulsi3addsi_compare0_v6 */

        case 1:
          if (
#line 2395 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
            return 65; /* *mulsi3addsi_compare0_scratch */
          if (!
#line 2410 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
            return -1;
          return 66; /* *mulsi3addsi_compare0_scratch_v6 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      operands[3] = x4;
      if (equality_operator (operands[3], E_VOIDmode))
        {
          res = recog_35 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x4) != NE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 14
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (XWINT (x6, 0) != 1L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 14
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x9, 1);
      if (XWINT (x11, 0) != -1L
          || pattern478 (x1, 
E_CCmode, 
100, 
14) != 0)
        return -1;
      x12 = XEXP (x7, 0);
      operands[0] = x12;
      if (!
#line 1771 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      return 1075; /* *doloop_end_internal */

    case GTU:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      if (pattern298 (x5) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 14
          || GET_MODE (x10) != E_SImode
          || pattern603 (x1) != 0)
        return -1;
      switch (pattern628 (x1))
        {
        case 0:
          if (!
#line 4677 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5067; /* predicated_doloop_end_internal16 */

        case 1:
          if (!
#line 4677 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5068; /* predicated_doloop_end_internal8 */

        case 2:
          if (!
#line 4677 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5069; /* predicated_doloop_end_internal4 */

        case 3:
          if (!
#line 4677 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          *pnum_clobbers = 1;
          return 5070; /* predicated_doloop_end_internal2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || pattern25 (x1) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CLOBBER
      || pattern624 (x1) != 0)
    return -1;
  x6 = XEXP (x4, 0);
  operands[4] = x6;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[5] = x7;
  if (!scratch_operand (operands[5], E_SImode)
      || pattern637 (x1) != 0
      || !
#line 1063 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
    return -1;
  return 973; /* cpymem8b */
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != MEM)
            return -1;
          if (GET_MODE (x5) == E_SImode
              && load_multiple_operation (operands[0], E_VOIDmode))
            {
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (s_register_operand (operands[1], E_SImode))
                {
                  x7 = XEXP (x4, 1);
                  operands[2] = x7;
                  if (const_int_I_operand (operands[2], E_SImode))
                    {
                      x8 = XEXP (x2, 0);
                      operands[3] = x8;
                      if (s_register_operand (operands[3], E_SImode))
                        {
                          x9 = XEXP (x4, 0);
                          if (rtx_equal_p (x9, operands[1]))
                            {
                              x10 = XEXP (x5, 0);
                              if (rtx_equal_p (x10, operands[1])
                                  && 
#line 11940 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
                                return 386; /* *load_multiple_with_writeback */
                            }
                        }
                    }
                }
            }
          if (GET_MODE (x5) != E_DFmode
              || !pop_multiple_fp (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          if (!vfp_hard_register_operand (operands[3], E_DFmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 12029 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_VFP_BASE))
            return -1;
          return 390; /* *vfp_pop_multiple_with_writeback */

        case MEM:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x9 = XEXP (x4, 0);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x11 = XEXP (x9, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x9, 0);
          operands[3] = x12;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[3])
              || !
#line 993 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 486; /* *ldm2_da */

        case REG:
          operands[1] = x4;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_SImode)
            return -1;
          x13 = XEXP (x6, 0);
          if (GET_CODE (x13) != PLUS
              || GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x13, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x13, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x8, 0);
          if (!rtx_equal_p (x16, operands[3])
              || !
#line 1018 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 488; /* *stm2_da */

        default:
          return -1;
        }

    case RETURN:
      if (!pop_multiple_return (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case PLUS:
          x8 = XEXP (x2, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x5, 1);
          operands[2] = x17;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 11971 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
            return -1;
          return 387; /* *pop_multiple_with_writeback_and_return */

        case MEM:
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 11994 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
            return -1;
          return 388; /* *pop_multiple_with_return */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case MEM:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != MEM
          || pattern367 (x5) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          x10 = XEXP (x9, 1);
          if (XWINT (x10, 0) != 4L)
            return -1;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && 
#line 855 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
            return 475; /* *ldm2_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !
#line 867 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 476; /* *thumb_ldm2_ia */

        case PLUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x12 = XEXP (x8, 1);
          if (GET_CODE (x12) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          switch (XWINT (x12, 0))
            {
            case 4L:
              x10 = XEXP (x9, 1);
              if (XWINT (x10, 0) != 8L
                  || !
#line 942 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 482; /* *ldm2_ib */

            case -8L:
              x10 = XEXP (x9, 1);
              if (XWINT (x10, 0) != -4L
                  || !
#line 1044 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 490; /* *ldm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      operands[1] = x4;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (pattern423 (x7) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x14 = XEXP (x6, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[3] = x14;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          x16 = XEXP (x15, 1);
          if (XWINT (x16, 0) != 4L)
            return -1;
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[3])
              || !
#line 904 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
            return -1;
          return 479; /* *stm2_ */

        case PLUS:
          if (GET_MODE (x14) != E_SImode)
            return -1;
          x18 = XEXP (x14, 1);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XEXP (x14, 0);
          operands[3] = x19;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[3]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4L:
              x16 = XEXP (x15, 1);
              if (XWINT (x16, 0) != 8L
                  || !
#line 968 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 484; /* *stm2_ib */

            case -8L:
              x16 = XEXP (x15, 1);
              if (XWINT (x16, 0) != -4L
                  || !
#line 1070 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2))
                return -1;
              return 492; /* *stm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (!shift_operator (x4, E_SImode))
    return -1;
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CC_NZmode
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[4] = x9;
  if (!shift_amount_operand (operands[4], E_SImode)
      || !
#line 9802 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  *pnum_clobbers = 1;
  return 333; /* *sub_shiftsi_compare0_scratch */
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1277 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 639; /* rorv4hi3 */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 651; /* rorv4hi3_di */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1277 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 640; /* rorv2si3 */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 652; /* rorv2si3_di */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1277 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 641; /* rordi3 */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 653; /* rordi3_di */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2230; /* neon_vextv8qi */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2231; /* neon_vextv16qi */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2232; /* neon_vextv4hi */

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2233; /* neon_vextv8hi */

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2234; /* neon_vextv2si */

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2235; /* neon_vextv4si */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2236; /* neon_vextv4hf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2237; /* neon_vextv8hf */

    case E_V4BFmode:
      if (pattern41 (x3, 
E_V4BFmode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2238; /* neon_vextv4bf */

    case E_V8BFmode:
      if (pattern41 (x3, 
E_V8BFmode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2239; /* neon_vextv8bf */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2240; /* neon_vextv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2241; /* neon_vextv4sf */

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2242; /* neon_vextdi */

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0
          || !
#line 4423 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2243; /* neon_vextv2di */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern45 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern500 (x2, 
E_OImode, 
E_SImode) != 0
          || !
#line 6239 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2953; /* neon_vst4_lanev8qi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4HImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2954; /* neon_vst4_lanev4hi */

        case 1:
          if (!
#line 6266 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2959; /* neon_vst4_lanev8hi */

        default:
          return -1;
        }

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4HFmode, 
E_V8HFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2955; /* neon_vst4_lanev4hf */

        case 1:
          if (!
#line 6266 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2960; /* neon_vst4_lanev8hf */

        default:
          return -1;
        }

    case E_V4BFmode:
      x2 = XEXP (x1, 1);
      switch (pattern505 (x2, 
E_V4BFmode, 
E_V8BFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2956; /* neon_vst4_lanev4bf */

        case 1:
          if (!(
#line 6266 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2963; /* neon_vst4_lanev8bf */

        default:
          return -1;
        }

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern506 (x2, 
E_V2SImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2957; /* neon_vst4_lanev2si */

        case 1:
          if (!
#line 6266 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2961; /* neon_vst4_lanev4si */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern506 (x2, 
E_V2SFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 6239 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2958; /* neon_vst4_lanev2sf */

        case 1:
          if (!
#line 6266 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2962; /* neon_vst4_lanev4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern427 (x3, 
E_SImode) != 0
          || !
#line 2203 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 931; /* arm_vcx1asi */

    case E_DImode:
      if (pattern427 (x3, 
E_DImode) != 0
          || !
#line 2203 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 932; /* arm_vcx1adi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !const_int_mve_cde1_operand (operands[3], E_SImode)
          || !
#line 4448 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5046; /* arm_vcx1qav16qi */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1560; /* neon_vmlav8qi_unspec */

    case 1:
      if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1561; /* neon_vmlav16qi_unspec */

    case 2:
      if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1562; /* neon_vmlav4hi_unspec */

    case 3:
      if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1563; /* neon_vmlav8hi_unspec */

    case 4:
      if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1564; /* neon_vmlav2si_unspec */

    case 5:
      if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1565; /* neon_vmlav4si_unspec */

    case 6:
      if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1566; /* neon_vmlav2sf_unspec */

    case 7:
      if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1567; /* neon_vmlav4sf_unspec */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern70 (x1))
    {
    case 0:
      if (!
#line 1918 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4137; /* mve_vpselq_sv16qi */

    case 1:
      if (!
#line 1918 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4139; /* mve_vpselq_sv8hi */

    case 2:
      if (!
#line 1918 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4141; /* mve_vpselq_sv4si */

    case 3:
      if (!
#line 1918 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4143; /* mve_vpselq_sv2di */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !neon_struct_operand (operands[1], E_V8QImode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2522; /* neon_vld1v8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !neon_struct_operand (operands[1], E_V16QImode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2523; /* neon_vld1v16qi */

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !neon_struct_operand (operands[1], E_V4HImode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2524; /* neon_vld1v4hi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !neon_struct_operand (operands[1], E_V8HImode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2525; /* neon_vld1v8hi */

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !neon_struct_operand (operands[1], E_V2SImode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2526; /* neon_vld1v2si */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !neon_struct_operand (operands[1], E_V4SImode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2527; /* neon_vld1v4si */

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !neon_struct_operand (operands[1], E_V4HFmode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2528; /* neon_vld1v4hf */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !neon_struct_operand (operands[1], E_V8HFmode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2529; /* neon_vld1v8hf */

    case E_V4BFmode:
      if (!s_register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !neon_struct_operand (operands[1], E_V4BFmode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2530; /* neon_vld1v4bf */

    case E_V8BFmode:
      if (!s_register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !neon_struct_operand (operands[1], E_V8BFmode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2531; /* neon_vld1v8bf */

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !neon_struct_operand (operands[1], E_V2SFmode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2532; /* neon_vld1v2sf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !neon_struct_operand (operands[1], E_V4SFmode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2533; /* neon_vld1v4sf */

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !neon_struct_operand (operands[1], E_DImode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2534; /* neon_vld1di */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !neon_struct_operand (operands[1], E_V2DImode)
          || !
#line 4993 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2535; /* neon_vld1v2di */

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 3184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2026; /* neon_vrecpev8hf */

    case 1:
      if (!
#line 3184 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2027; /* neon_vrecpev4hf */

    case 2:
      if (!
#line 3193 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2028; /* neon_vrecpev2si */

    case 3:
      if (!
#line 3193 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2029; /* neon_vrecpev2sf */

    case 4:
      if (!
#line 3193 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2030; /* neon_vrecpev4si */

    case 5:
      if (!
#line 3193 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2031; /* neon_vrecpev4sf */

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!neon_struct_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[1], E_V8QImode)
              || !
#line 5364 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2758; /* neon_vst1_lanev8qi */

        case E_V16QImode:
          if (!s_register_operand (operands[1], E_V16QImode)
              || !
#line 5385 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2765; /* neon_vst1_lanev16qi */

        default:
          return -1;
        }

    case E_HImode:
      if (!neon_struct_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!s_register_operand (operands[1], E_V4HImode)
              || !
#line 5364 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2759; /* neon_vst1_lanev4hi */

        case E_V8HImode:
          if (!s_register_operand (operands[1], E_V8HImode)
              || !
#line 5385 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2766; /* neon_vst1_lanev8hi */

        default:
          return -1;
        }

    case E_HFmode:
      if (!neon_struct_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!s_register_operand (operands[1], E_V4HFmode)
              || !
#line 5364 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2760; /* neon_vst1_lanev4hf */

        case E_V8HFmode:
          if (!s_register_operand (operands[1], E_V8HFmode)
              || !
#line 5385 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2767; /* neon_vst1_lanev8hf */

        default:
          return -1;
        }

    case E_BFmode:
      if (!neon_struct_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          if (!s_register_operand (operands[1], E_V4BFmode)
              || !
#line 5364 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2761; /* neon_vst1_lanev4bf */

        case E_V8BFmode:
          if (!s_register_operand (operands[1], E_V8BFmode)
              || !
#line 5385 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2768; /* neon_vst1_lanev8bf */

        default:
          return -1;
        }

    case E_SImode:
      if (!neon_struct_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!s_register_operand (operands[1], E_V2SImode)
              || !
#line 5364 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2762; /* neon_vst1_lanev2si */

        case E_V4SImode:
          if (!s_register_operand (operands[1], E_V4SImode)
              || !
#line 5385 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2769; /* neon_vst1_lanev4si */

        default:
          return -1;
        }

    case E_SFmode:
      if (!neon_struct_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SFmode:
          if (!s_register_operand (operands[1], E_V2SFmode)
              || !
#line 5364 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2763; /* neon_vst1_lanev2sf */

        case E_V4SFmode:
          if (!s_register_operand (operands[1], E_V4SFmode)
              || !
#line 5385 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2770; /* neon_vst1_lanev4sf */

        default:
          return -1;
        }

    case E_DImode:
      if (!neon_struct_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!s_register_operand (operands[1], E_DImode)
              || !
#line 5364 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2764; /* neon_vst1_lanedi */

        case E_V2DImode:
          if (!s_register_operand (operands[1], E_V2DImode)
              || !
#line 5385 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2771; /* neon_vst1_lanev2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 4100 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x16QImode))))
        return -1;
      return 4997; /* mve_vld2qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V8HImode, 
E_V2x8HImode) != 0
          || !
#line 4100 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HImode))))
        return -1;
      return 4998; /* mve_vld2qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V4SImode, 
E_V2x4SImode) != 0
          || !
#line 4100 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SImode))))
        return -1;
      return 4999; /* mve_vld2qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V8HFmode, 
E_V2x8HFmode) != 0
          || !
#line 4100 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HFmode))))
        return -1;
      return 5000; /* mve_vld2qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V4SFmode, 
E_V2x4SFmode) != 0
          || !
#line 4100 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SFmode))))
        return -1;
      return 5001; /* mve_vld2qv4sf */

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern145 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1827; /* neon_vmaxsv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1831; /* neon_vmaxsv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1835; /* neon_vmaxsv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1839; /* neon_vmaxsv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1843; /* neon_vmaxsv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1847; /* neon_vmaxsv4si */

    case 6:
      if (!
#line 2691 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1851; /* neon_vmaxfv2sf */

    case 7:
      if (!
#line 2691 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1853; /* neon_vmaxfv4sf */

    case 8:
      if (!
#line 2702 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1855; /* neon_vmaxfv8hf */

    case 9:
      if (!
#line 2702 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1857; /* neon_vmaxfv4hf */

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2339; /* neon_vshrs_nv8qi */

    case 1:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2343; /* neon_vshrs_nv16qi */

    case 2:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2347; /* neon_vshrs_nv4hi */

    case 3:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2351; /* neon_vshrs_nv8hi */

    case 4:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2355; /* neon_vshrs_nv2si */

    case 5:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2359; /* neon_vshrs_nv4si */

    case 6:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2363; /* neon_vshrs_ndi */

    case 7:
      if (!
#line 4520 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2367; /* neon_vshrs_nv2di */

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern150 (x1))
    {
    case 0:
      if (!
#line 3777 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2126; /* neon_vcvts_nv2sf */

    case 1:
      if (!
#line 3777 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2128; /* neon_vcvts_nv4sf */

    case 2:
      if (!
#line 3791 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2130; /* neon_vcvts_nv8hf */

    case 3:
      if (!
#line 3791 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2132; /* neon_vcvts_nv4hf */

    case 4:
      if (!
#line 3804 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2134; /* neon_vcvts_nv2si */

    case 5:
      if (!
#line 3804 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2136; /* neon_vcvts_nv4si */

    case 6:
      if (!
#line 3818 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2138; /* neon_vcvts_nv4hi */

    case 7:
      if (!
#line 3818 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2140; /* neon_vcvts_nv8hi */

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern163 (x1, 
E_EImode))
    {
    case 0:
      if (!
#line 5826 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2866; /* neon_vst3v8qi */

    case 1:
      if (!
#line 5826 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2867; /* neon_vst3v4hi */

    case 2:
      if (!
#line 5826 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2868; /* neon_vst3v4hf */

    case 3:
      if (!(
#line 5826 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2869; /* neon_vst3v4bf */

    case 4:
      if (!
#line 5826 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2870; /* neon_vst3v2si */

    case 5:
      if (!
#line 5826 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2871; /* neon_vst3v2sf */

    case 6:
      if (!
#line 5826 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2872; /* neon_vst3di */

    default:
      return -1;
    }
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (pattern115 (x3))
    {
    case 0:
      if (!mve_imm_7 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3721; /* mve_vqshluq_n_sv16qi */

    case 1:
      if (!mve_imm_15 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3722; /* mve_vqshluq_n_sv8hi */

    case 2:
      if (!mve_imm_31 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3723; /* mve_vqshluq_n_sv4si */

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern147 (x1))
    {
    case 0:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1882; /* neon_vpadaluv8qi */

    case 1:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1884; /* neon_vpadaluv16qi */

    case 2:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1886; /* neon_vpadaluv4hi */

    case 3:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1888; /* neon_vpadaluv8hi */

    case 4:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1890; /* neon_vpadaluv2si */

    case 5:
      if (!
#line 2766 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1892; /* neon_vpadaluv4si */

    default:
      return -1;
    }
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1487; /* neon_vhadduv8qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1491; /* neon_vhadduv16qi */

    case 2:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1495; /* neon_vhadduv4hi */

    case 3:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1499; /* neon_vhadduv8hi */

    case 4:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1503; /* neon_vhadduv2si */

    case 5:
      if (!
#line 1590 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1507; /* neon_vhadduv4si */

    default:
      return -1;
    }
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8BFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8BFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8BFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4SFmode)
      || !
#line 6690 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
    return -1;
  return 3031; /* neon_vbfcvtv4sf_highv8bf */
}

 int
recog_232 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1710; /* neon_vcltv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1715; /* neon_vcltv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1730; /* neon_vcltv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1735; /* neon_vcltv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!ssat16_imm (operands[2], E_SImode)
      || !
#line 6166 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
    return -1;
  return 250; /* arm_ssat16_insn */
}

 int
recog_252 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern90 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 2);
  switch (pattern509 (x4))
    {
    case 0:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode)
          || !
#line 3395 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 4873; /* mve_vstrq_truncate_scatter_offset_p_v8qi */

    case 1:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V4QImode:
          if (!
#line 3395 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4874; /* mve_vstrq_truncate_scatter_offset_p_v4qi */

        case E_V4HImode:
          if (!
#line 3395 "../../gcc-15.1.0/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4875; /* mve_vstrq_truncate_scatter_offset_p_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern198 (x1))
    {
    case 0:
      if (!
#line 4016 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2206; /* neon_vmla_lanev4hi */

    case 1:
      if (!
#line 4016 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2207; /* neon_vmla_lanev2si */

    case 2:
      if (!
#line 4016 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2208; /* neon_vmla_lanev2sf */

    case 3:
      if (!
#line 4034 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2209; /* neon_vmla_lanev8hi */

    case 4:
      if (!
#line 4034 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2210; /* neon_vmla_lanev4si */

    case 5:
      if (!
#line 4034 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2211; /* neon_vmla_lanev4sf */

    default:
      return -1;
    }
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 79:
      if (pattern29 (x1) != 0
          || !
#line 2792 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 86; /* arm_smlawb_insn */

    case 80:
      if (pattern29 (x1) != 0
          || !
#line 2792 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 88; /* arm_smlawt_insn */

    case 103:
      return recog_102 (x1, insn, pnum_clobbers);

    case 102:
      return recog_95 (x1, insn, pnum_clobbers);

    case 74:
      if (pattern29 (x1) != 0
          || !
#line 6077 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 221; /* arm_usada8 */

    case 75:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 222; /* arm_smlald */

    case 76:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 223; /* arm_smlaldx */

    case 77:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 224; /* arm_smlsld */

    case 78:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 225; /* arm_smlsldx */

    case 94:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 238; /* arm_smlad_insn */

    case 95:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 240; /* arm_smladx_insn */

    case 96:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 242; /* arm_smlsd_insn */

    case 97:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 244; /* arm_smlsdx_insn */

    case 81:
      return recog_90 (x1, insn, pnum_clobbers);

    case 2:
      return recog_93 (x1, insn, pnum_clobbers);

    case 17:
      return recog_94 (x1, insn, pnum_clobbers);

    case 11:
      if (pattern31 (x1) != 0
          || !
#line 518 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 573; /* iwmmxt_wmacs */

    case 12:
      if (pattern31 (x1) != 0
          || !
#line 539 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 575; /* iwmmxt_wmacu */

    case 9:
      return recog_77 (x1, insn, pnum_clobbers);

    case 105:
      return recog_76 (x1, insn, pnum_clobbers);

    case 104:
      return recog_75 (x1, insn, pnum_clobbers);

    case 223:
      return recog_86 (x1, insn, pnum_clobbers);

    case 225:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2126 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1568; /* neon_vmlalsv8qi */

        case 1:
          if (!
#line 2126 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1570; /* neon_vmlalsv4hi */

        case 2:
          if (!
#line 2126 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1572; /* neon_vmlalsv2si */

        default:
          return -1;
        }

    case 226:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2126 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1569; /* neon_vmlaluv8qi */

        case 1:
          if (!
#line 2126 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1571; /* neon_vmlaluv4hi */

        case 2:
          if (!
#line 2126 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1573; /* neon_vmlaluv2si */

        default:
          return -1;
        }

    case 229:
      return recog_85 (x1, insn, pnum_clobbers);

    case 231:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2169 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1582; /* neon_vmlslsv8qi */

        case 1:
          if (!
#line 2169 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1584; /* neon_vmlslsv4hi */

        case 2:
          if (!
#line 2169 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1586; /* neon_vmlslsv2si */

        default:
          return -1;
        }

    case 232:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2169 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1583; /* neon_vmlsluv8qi */

        case 1:
          if (!
#line 2169 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1585; /* neon_vmlsluv4hi */

        case 2:
          if (!
#line 2169 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1587; /* neon_vmlsluv2si */

        default:
          return -1;
        }

    case 361:
      return recog_101 (x1, insn, pnum_clobbers);

    case 362:
      return recog_100 (x1, insn, pnum_clobbers);

    case 264:
      switch (pattern37 (x1))
        {
        case 0:
          if (!
#line 2203 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1604; /* neon_vqdmlalv4hi */

        case 1:
          if (!
#line 2203 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1605; /* neon_vqdmlalv2si */

        default:
          return -1;
        }

    case 266:
      switch (pattern37 (x1))
        {
        case 0:
          if (!
#line 2214 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1606; /* neon_vqdmlslv4hi */

        case 1:
          if (!
#line 2214 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1607; /* neon_vqdmlslv2si */

        default:
          return -1;
        }

    case 245:
      return recog_68 (x1, insn, pnum_clobbers);

    case 246:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2184; /* neon_vmulls_lanev4hi */

        case 1:
          if (!
#line 3926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2186; /* neon_vmulls_lanev2si */

        default:
          return -1;
        }

    case 247:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2185; /* neon_vmullu_lanev4hi */

        case 1:
          if (!
#line 3926 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2187; /* neon_vmullu_lanev2si */

        default:
          return -1;
        }

    case 273:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3940 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2188; /* neon_vqdmull_lanev4hi */

        case 1:
          if (!
#line 3940 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2189; /* neon_vqdmull_lanev2si */

        default:
          return -1;
        }

    case 269:
      return recog_98 (x1, insn, pnum_clobbers);

    case 271:
      return recog_99 (x1, insn, pnum_clobbers);

    case 191:
      return recog_61 (x1, insn, pnum_clobbers);

    case 160:
      return recog_62 (x1, insn, pnum_clobbers);

    case 314:
      return recog_84 (x1, insn, pnum_clobbers);

    case 315:
      return recog_83 (x1, insn, pnum_clobbers);

    case 316:
      return recog_82 (x1, insn, pnum_clobbers);

    case 317:
      return recog_81 (x1, insn, pnum_clobbers);

    case 318:
      return recog_79 (x1, insn, pnum_clobbers);

    case 313:
      return recog_80 (x1, insn, pnum_clobbers);

    case 344:
      return recog_70 (x1, insn, pnum_clobbers);

    case 200:
      return recog_89 (x1, insn, pnum_clobbers);

    case 202:
      return recog_88 (x1, insn, pnum_clobbers);

    case 203:
      return recog_60 (x1, insn, pnum_clobbers);

    case 326:
      return recog_67 (x1, insn, pnum_clobbers);

    case 209:
      return recog_92 (x1, insn, pnum_clobbers);

    case 330:
      return recog_64 (x1, insn, pnum_clobbers);

    case 214:
      return recog_91 (x1, insn, pnum_clobbers);

    case 334:
      return recog_66 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3058; /* crypto_sha1su0 */

    case 140:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3059; /* crypto_sha256h */

    case 141:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3060; /* crypto_sha256h2 */

    case 143:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3061; /* crypto_sha256su1 */

    case 134:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3064; /* crypto_sha1c_lb */

    case 135:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3065; /* crypto_sha1m_lb */

    case 136:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc-15.1.0/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3066; /* crypto_sha1p_lb */

    case 611:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3871; /* mve_vcmpeqq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3877; /* mve_vcmpeqq_m_fv4sf */

        default:
          return -1;
        }

    case 712:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3872; /* mve_vcmpgeq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3878; /* mve_vcmpgeq_m_fv4sf */

        default:
          return -1;
        }

    case 724:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3873; /* mve_vcmpgtq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3879; /* mve_vcmpgtq_m_fv4sf */

        default:
          return -1;
        }

    case 741:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3874; /* mve_vcmpleq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3880; /* mve_vcmpleq_m_fv4sf */

        default:
          return -1;
        }

    case 725:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3875; /* mve_vcmpltq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3881; /* mve_vcmpltq_m_fv4sf */

        default:
          return -1;
        }

    case 736:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3876; /* mve_vcmpneq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3882; /* mve_vcmpneq_m_fv4sf */

        default:
          return -1;
        }

    case 612:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3883; /* mve_vcvtaq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3891; /* mve_vcvtaq_m_sv4si */

        default:
          return -1;
        }

    case 613:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3884; /* mve_vcvtaq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3892; /* mve_vcvtaq_m_uv4si */

        default:
          return -1;
        }

    case 804:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3885; /* mve_vcvtmq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3893; /* mve_vcvtmq_m_sv4si */

        default:
          return -1;
        }

    case 805:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3886; /* mve_vcvtmq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3894; /* mve_vcvtmq_m_uv4si */

        default:
          return -1;
        }

    case 806:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3887; /* mve_vcvtnq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3895; /* mve_vcvtnq_m_sv4si */

        default:
          return -1;
        }

    case 810:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3888; /* mve_vcvtnq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3896; /* mve_vcvtnq_m_uv4si */

        default:
          return -1;
        }

    case 807:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3889; /* mve_vcvtpq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3897; /* mve_vcvtpq_m_sv4si */

        default:
          return -1;
        }

    case 808:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3890; /* mve_vcvtpq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3898; /* mve_vcvtpq_m_uv4si */

        default:
          return -1;
        }

    case 614:
      switch (pattern53 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1592 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3899; /* mve_vcvtq_m_to_f_sv8hf */

        case 1:
          if (!
#line 1592 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3901; /* mve_vcvtq_m_to_f_sv4sf */

        default:
          return -1;
        }

    case 615:
      switch (pattern53 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1592 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3900; /* mve_vcvtq_m_to_f_uv8hf */

        case 1:
          if (!
#line 1592 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3902; /* mve_vcvtq_m_to_f_uv4sf */

        default:
          return -1;
        }

    case 617:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3903; /* mve_vqrshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3923; /* mve_vqrshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 616:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3904; /* mve_vqrshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3924; /* mve_vqrshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 777:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3905; /* mve_vqrshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3925; /* mve_vqrshrntq_n_sv4si */

        default:
          return -1;
        }

    case 776:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3906; /* mve_vqrshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3926; /* mve_vqrshrntq_n_uv4si */

        default:
          return -1;
        }

    case 618:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3907; /* mve_vqrshrunbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3927; /* mve_vqrshrunbq_n_sv4si */

        default:
          return -1;
        }

    case 720:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3908; /* mve_vqrshruntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3928; /* mve_vqrshruntq_n_sv4si */

        default:
          return -1;
        }

    case 785:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3909; /* mve_vqshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3929; /* mve_vqshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 784:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3910; /* mve_vqshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3930; /* mve_vqshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 796:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3911; /* mve_vqshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3931; /* mve_vqshrntq_n_sv4si */

        default:
          return -1;
        }

    case 795:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3912; /* mve_vqshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3932; /* mve_vqshrntq_n_uv4si */

        default:
          return -1;
        }

    case 719:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3913; /* mve_vqshrunbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3933; /* mve_vqshrunbq_n_sv4si */

        default:
          return -1;
        }

    case 727:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3914; /* mve_vqshruntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3934; /* mve_vqshruntq_n_sv4si */

        default:
          return -1;
        }

    case 788:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3915; /* mve_vrshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3935; /* mve_vrshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 789:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3916; /* mve_vrshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3936; /* mve_vrshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 771:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3917; /* mve_vrshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3937; /* mve_vrshrntq_n_sv4si */

        default:
          return -1;
        }

    case 770:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3918; /* mve_vrshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3938; /* mve_vrshrntq_n_uv4si */

        default:
          return -1;
        }

    case 787:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3919; /* mve_vshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3939; /* mve_vshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 786:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3920; /* mve_vshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3940; /* mve_vshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 798:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3921; /* mve_vshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3941; /* mve_vshrntq_n_sv4si */

        default:
          return -1;
        }

    case 799:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3922; /* mve_vshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3942; /* mve_vshrntq_n_uv4si */

        default:
          return -1;
        }

    case 619:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3943; /* mve_vrmlaldavhaq_sv4si */

    case 624:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3944; /* mve_vrmlaldavhaq_uv4si */

    case 715:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3945; /* mve_vrmlaldavhaxq_sv4si */

    case 733:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3946; /* mve_vrmlsldavhaq_sv4si */

    case 734:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3947; /* mve_vrmlsldavhaxq_sv4si */

    case 620:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1658 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3948; /* mve_vabavq_sv16qi */

        case 1:
          if (!
#line 1658 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3950; /* mve_vabavq_sv8hi */

        case 2:
          if (!
#line 1658 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3952; /* mve_vabavq_sv4si */

        default:
          return -1;
        }

    case 621:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1658 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3949; /* mve_vabavq_uv16qi */

        case 1:
          if (!
#line 1658 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3951; /* mve_vabavq_uv8hi */

        case 2:
          if (!
#line 1658 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3953; /* mve_vabavq_uv4si */

        default:
          return -1;
        }

    case 625:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3960; /* mve_vabsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3967; /* mve_vabsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3974; /* mve_vabsq_m_sv4si */

        default:
          return -1;
        }

    case 628:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3961; /* mve_vclsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3968; /* mve_vclsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3975; /* mve_vclsq_m_sv4si */

        default:
          return -1;
        }

    case 629:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3962; /* mve_vclzq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3969; /* mve_vclzq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3976; /* mve_vclzq_m_sv4si */

        default:
          return -1;
        }

    case 630:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3963; /* mve_vclzq_m_uv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3970; /* mve_vclzq_m_uv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3977; /* mve_vclzq_m_uv4si */

        default:
          return -1;
        }

    case 678:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3964; /* mve_vnegq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3971; /* mve_vnegq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3978; /* mve_vnegq_m_sv4si */

        default:
          return -1;
        }

    case 681:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3965; /* mve_vqabsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3972; /* mve_vqabsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3979; /* mve_vqabsq_m_sv4si */

        default:
          return -1;
        }

    case 684:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3966; /* mve_vqnegq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3973; /* mve_vqnegq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3980; /* mve_vqnegq_m_sv4si */

        default:
          return -1;
        }

    case 626:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 1718 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3981; /* mve_vaddvaq_p_sv16qi */

        case 1:
          if (!
#line 1718 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3983; /* mve_vaddvaq_p_sv8hi */

        case 2:
          if (!
#line 1718 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3985; /* mve_vaddvaq_p_sv4si */

        default:
          return -1;
        }

    case 627:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 1718 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3982; /* mve_vaddvaq_p_uv16qi */

        case 1:
          if (!
#line 1718 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3984; /* mve_vaddvaq_p_uv8hi */

        case 2:
          if (!
#line 1718 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3986; /* mve_vaddvaq_p_uv4si */

        default:
          return -1;
        }

    case 631:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3987; /* mve_vcmpcsq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3997; /* mve_vcmpcsq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4007; /* mve_vcmpcsq_m_n_uv4si */

        default:
          return -1;
        }

    case 633:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3988; /* mve_vcmpeqq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3998; /* mve_vcmpeqq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4008; /* mve_vcmpeqq_m_n_sv4si */

        default:
          return -1;
        }

    case 634:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3989; /* mve_vcmpeqq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3999; /* mve_vcmpeqq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4009; /* mve_vcmpeqq_m_n_uv4si */

        default:
          return -1;
        }

    case 637:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3990; /* mve_vcmpgeq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4000; /* mve_vcmpgeq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4010; /* mve_vcmpgeq_m_n_sv4si */

        default:
          return -1;
        }

    case 639:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3991; /* mve_vcmpgtq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4001; /* mve_vcmpgtq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4011; /* mve_vcmpgtq_m_n_sv4si */

        default:
          return -1;
        }

    case 641:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3992; /* mve_vcmphiq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4002; /* mve_vcmphiq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4012; /* mve_vcmphiq_m_n_uv4si */

        default:
          return -1;
        }

    case 643:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3993; /* mve_vcmpleq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4003; /* mve_vcmpleq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4013; /* mve_vcmpleq_m_n_sv4si */

        default:
          return -1;
        }

    case 645:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3994; /* mve_vcmpltq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4004; /* mve_vcmpltq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4014; /* mve_vcmpltq_m_n_sv4si */

        default:
          return -1;
        }

    case 647:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3995; /* mve_vcmpneq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4005; /* mve_vcmpneq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4015; /* mve_vcmpneq_m_n_sv4si */

        default:
          return -1;
        }

    case 648:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3996; /* mve_vcmpneq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4006; /* mve_vcmpneq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4016; /* mve_vcmpneq_m_n_uv4si */

        default:
          return -1;
        }

    case 632:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4017; /* mve_vcmpcsq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4027; /* mve_vcmpcsq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4037; /* mve_vcmpcsq_m_uv4si */

        default:
          return -1;
        }

    case 635:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4018; /* mve_vcmpeqq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4028; /* mve_vcmpeqq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4038; /* mve_vcmpeqq_m_sv4si */

        default:
          return -1;
        }

    case 636:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4019; /* mve_vcmpeqq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4029; /* mve_vcmpeqq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4039; /* mve_vcmpeqq_m_uv4si */

        default:
          return -1;
        }

    case 638:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4020; /* mve_vcmpgeq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4030; /* mve_vcmpgeq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4040; /* mve_vcmpgeq_m_sv4si */

        default:
          return -1;
        }

    case 640:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4021; /* mve_vcmpgtq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4031; /* mve_vcmpgtq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4041; /* mve_vcmpgtq_m_sv4si */

        default:
          return -1;
        }

    case 642:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4022; /* mve_vcmphiq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4032; /* mve_vcmphiq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4042; /* mve_vcmphiq_m_uv4si */

        default:
          return -1;
        }

    case 644:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4023; /* mve_vcmpleq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4033; /* mve_vcmpleq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4043; /* mve_vcmpleq_m_sv4si */

        default:
          return -1;
        }

    case 646:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4024; /* mve_vcmpltq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4034; /* mve_vcmpltq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4044; /* mve_vcmpltq_m_sv4si */

        default:
          return -1;
        }

    case 649:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4025; /* mve_vcmpneq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4035; /* mve_vcmpneq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4045; /* mve_vcmpneq_m_sv4si */

        default:
          return -1;
        }

    case 650:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4026; /* mve_vcmpneq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4036; /* mve_vcmpneq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4046; /* mve_vcmpneq_m_uv4si */

        default:
          return -1;
        }

    case 651:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1783 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4047; /* mve_vdupq_m_n_sv16qi */

        case 1:
          if (!
#line 1783 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4049; /* mve_vdupq_m_n_sv8hi */

        case 2:
          if (!
#line 1783 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4051; /* mve_vdupq_m_n_sv4si */

        default:
          return -1;
        }

    case 652:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1783 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4048; /* mve_vdupq_m_n_uv16qi */

        case 1:
          if (!
#line 1783 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4050; /* mve_vdupq_m_n_uv8hi */

        case 2:
          if (!
#line 1783 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4052; /* mve_vdupq_m_n_uv4si */

        default:
          return -1;
        }

    case 657:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1801 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4053; /* mve_vmaxaq_m_sv16qi */

        case 1:
          if (!
#line 1801 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4055; /* mve_vmaxaq_m_sv8hi */

        case 2:
          if (!
#line 1801 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4057; /* mve_vmaxaq_m_sv4si */

        default:
          return -1;
        }

    case 661:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1801 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4054; /* mve_vminaq_m_sv16qi */

        case 1:
          if (!
#line 1801 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4056; /* mve_vminaq_m_sv8hi */

        case 2:
          if (!
#line 1801 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4058; /* mve_vminaq_m_sv4si */

        default:
          return -1;
        }

    case 658:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4059; /* mve_vmaxavq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4065; /* mve_vmaxavq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4071; /* mve_vmaxavq_p_sv4si */

        default:
          return -1;
        }

    case 659:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4060; /* mve_vmaxvq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4066; /* mve_vmaxvq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4072; /* mve_vmaxvq_p_sv4si */

        default:
          return -1;
        }

    case 660:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4061; /* mve_vmaxvq_p_uv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4067; /* mve_vmaxvq_p_uv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4073; /* mve_vmaxvq_p_uv4si */

        default:
          return -1;
        }

    case 662:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4062; /* mve_vminavq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4068; /* mve_vminavq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4074; /* mve_vminavq_p_sv4si */

        default:
          return -1;
        }

    case 663:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4063; /* mve_vminvq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4069; /* mve_vminvq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4075; /* mve_vminvq_p_sv4si */

        default:
          return -1;
        }

    case 664:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4064; /* mve_vminvq_p_uv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4070; /* mve_vminvq_p_uv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4076; /* mve_vminvq_p_uv4si */

        default:
          return -1;
        }

    case 665:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4077; /* mve_vmladavaq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4082; /* mve_vmladavaq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4087; /* mve_vmladavaq_sv4si */

        default:
          return -1;
        }

    case 666:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4078; /* mve_vmladavaq_uv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4083; /* mve_vmladavaq_uv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4088; /* mve_vmladavaq_uv4si */

        default:
          return -1;
        }

    case 709:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4079; /* mve_vmlsdavaxq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4084; /* mve_vmlsdavaxq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4089; /* mve_vmlsdavaxq_sv4si */

        default:
          return -1;
        }

    case 710:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4080; /* mve_vmlsdavaq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4085; /* mve_vmlsdavaq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4090; /* mve_vmlsdavaq_sv4si */

        default:
          return -1;
        }

    case 711:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4081; /* mve_vmladavaxq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4086; /* mve_vmladavaxq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4091; /* mve_vmladavaxq_sv4si */

        default:
          return -1;
        }

    case 667:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4092; /* mve_vmladavq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4097; /* mve_vmladavq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4102; /* mve_vmladavq_p_sv4si */

        default:
          return -1;
        }

    case 668:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4093; /* mve_vmladavq_p_uv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4098; /* mve_vmladavq_p_uv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4103; /* mve_vmladavq_p_uv4si */

        default:
          return -1;
        }

    case 669:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4094; /* mve_vmladavxq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4099; /* mve_vmladavxq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4104; /* mve_vmladavxq_p_sv4si */

        default:
          return -1;
        }

    case 674:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4095; /* mve_vmlsdavq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4100; /* mve_vmlsdavq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4105; /* mve_vmlsdavq_p_sv4si */

        default:
          return -1;
        }

    case 675:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4096; /* mve_vmlsdavxq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4101; /* mve_vmlsdavxq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4106; /* mve_vmlsdavxq_p_sv4si */

        default:
          return -1;
        }

    case 670:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4107; /* mve_vmlaq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4115; /* mve_vmlaq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4123; /* mve_vmlaq_n_sv4si */

        default:
          return -1;
        }

    case 671:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4108; /* mve_vmlaq_n_uv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4116; /* mve_vmlaq_n_uv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4124; /* mve_vmlaq_n_uv4si */

        default:
          return -1;
        }

    case 672:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4109; /* mve_vmlasq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4117; /* mve_vmlasq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4125; /* mve_vmlasq_n_sv4si */

        default:
          return -1;
        }

    case 673:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4110; /* mve_vmlasq_n_uv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4118; /* mve_vmlasq_n_uv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4126; /* mve_vmlasq_n_uv4si */

        default:
          return -1;
        }

    case 682:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4111; /* mve_vqdmlahq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4119; /* mve_vqdmlahq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4127; /* mve_vqdmlahq_n_sv4si */

        default:
          return -1;
        }

    case 683:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4112; /* mve_vqdmlashq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4120; /* mve_vqdmlashq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4128; /* mve_vqdmlashq_n_sv4si */

        default:
          return -1;
        }

    case 687:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4113; /* mve_vqrdmlahq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4121; /* mve_vqrdmlahq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4129; /* mve_vqrdmlahq_n_sv4si */

        default:
          return -1;
        }

    case 688:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4114; /* mve_vqrdmlashq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4122; /* mve_vqrdmlashq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4130; /* mve_vqrdmlashq_n_sv4si */

        default:
          return -1;
        }

    case 676:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1901 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4131; /* mve_vmvnq_m_sv16qi */

        case 1:
          if (!
#line 1901 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4133; /* mve_vmvnq_m_sv8hi */

        case 2:
          if (!
#line 1901 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4135; /* mve_vmvnq_m_sv4si */

        default:
          return -1;
        }

    case 677:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1901 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4132; /* mve_vmvnq_m_uv16qi */

        case 1:
          if (!
#line 1901 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4134; /* mve_vmvnq_m_uv8hi */

        case 2:
          if (!
#line 1901 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4136; /* mve_vmvnq_m_uv4si */

        default:
          return -1;
        }

    case 679:
      return recog_97 (x1, insn, pnum_clobbers);

    case 680:
      return recog_96 (x1, insn, pnum_clobbers);

    case 708:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4145; /* mve_vqdmladhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4153; /* mve_vqdmladhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4161; /* mve_vqdmladhq_sv4si */

        default:
          return -1;
        }

    case 707:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4146; /* mve_vqdmladhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4154; /* mve_vqdmladhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4162; /* mve_vqdmladhxq_sv4si */

        default:
          return -1;
        }

    case 706:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4147; /* mve_vqdmlsdhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4155; /* mve_vqdmlsdhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4163; /* mve_vqdmlsdhq_sv4si */

        default:
          return -1;
        }

    case 705:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4148; /* mve_vqdmlsdhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4156; /* mve_vqdmlsdhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4164; /* mve_vqdmlsdhxq_sv4si */

        default:
          return -1;
        }

    case 685:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4149; /* mve_vqrdmladhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4157; /* mve_vqrdmladhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4165; /* mve_vqrdmladhq_sv4si */

        default:
          return -1;
        }

    case 686:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4150; /* mve_vqrdmladhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4158; /* mve_vqrdmladhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4166; /* mve_vqrdmladhxq_sv4si */

        default:
          return -1;
        }

    case 689:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4151; /* mve_vqrdmlsdhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4159; /* mve_vqrdmlsdhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4167; /* mve_vqrdmlsdhq_sv4si */

        default:
          return -1;
        }

    case 690:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4152; /* mve_vqrdmlsdhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4160; /* mve_vqrdmlsdhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4168; /* mve_vqrdmlsdhxq_sv4si */

        default:
          return -1;
        }

    case 691:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4169; /* mve_vqrshlq_m_n_sv16qi */

        case 1:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4173; /* mve_vqrshlq_m_n_sv8hi */

        case 2:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4177; /* mve_vqrshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 692:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4170; /* mve_vqrshlq_m_n_uv16qi */

        case 1:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4174; /* mve_vqrshlq_m_n_uv8hi */

        case 2:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4178; /* mve_vqrshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 697:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4171; /* mve_vrshlq_m_n_sv16qi */

        case 1:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4175; /* mve_vrshlq_m_n_sv8hi */

        case 2:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4179; /* mve_vrshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 698:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4172; /* mve_vrshlq_m_n_uv16qi */

        case 1:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4176; /* mve_vrshlq_m_n_uv8hi */

        case 2:
          if (!
#line 1960 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4180; /* mve_vrshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 693:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4181; /* mve_vqshlq_m_r_sv16qi */

        case 1:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4185; /* mve_vqshlq_m_r_sv8hi */

        case 2:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4189; /* mve_vqshlq_m_r_sv4si */

        default:
          return -1;
        }

    case 694:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4182; /* mve_vqshlq_m_r_uv16qi */

        case 1:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4186; /* mve_vqshlq_m_r_uv8hi */

        case 2:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4190; /* mve_vqshlq_m_r_uv4si */

        default:
          return -1;
        }

    case 699:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4183; /* mve_vshlq_m_r_sv16qi */

        case 1:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4187; /* mve_vshlq_m_r_sv8hi */

        case 2:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4191; /* mve_vshlq_m_r_sv4si */

        default:
          return -1;
        }

    case 700:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4184; /* mve_vshlq_m_r_uv16qi */

        case 1:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4188; /* mve_vshlq_m_r_uv8hi */

        case 2:
          if (!
#line 1978 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4192; /* mve_vshlq_m_r_uv4si */

        default:
          return -1;
        }

    case 695:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1995 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4193; /* mve_vrev64q_m_sv16qi */

        case 1:
          if (!
#line 1995 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4195; /* mve_vrev64q_m_sv8hi */

        case 2:
          if (!
#line 1995 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4197; /* mve_vrev64q_m_sv4si */

        default:
          return -1;
        }

    case 696:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1995 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4194; /* mve_vrev64q_m_uv16qi */

        case 1:
          if (!
#line 1995 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4196; /* mve_vrev64q_m_uv8hi */

        case 2:
          if (!
#line 1995 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4198; /* mve_vrev64q_m_uv4si */

        default:
          return -1;
        }

    case 701:
      switch (pattern74 (x1))
        {
        case 0:
          if (!
#line 2012 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4199; /* mve_vsliq_n_sv16qi */

        case 1:
          if (!
#line 2012 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4201; /* mve_vsliq_n_sv8hi */

        case 2:
          if (!
#line 2012 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4203; /* mve_vsliq_n_sv4si */

        default:
          return -1;
        }

    case 702:
      switch (pattern74 (x1))
        {
        case 0:
          if (!
#line 2012 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4200; /* mve_vsliq_n_uv16qi */

        case 1:
          if (!
#line 2012 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4202; /* mve_vsliq_n_uv8hi */

        case 2:
          if (!
#line 2012 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4204; /* mve_vsliq_n_uv4si */

        default:
          return -1;
        }

    case 703:
      switch (pattern75 (x1))
        {
        case 0:
          if (!
#line 2029 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4205; /* mve_vsriq_n_sv16qi */

        case 1:
          if (!
#line 2029 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4207; /* mve_vsriq_n_sv8hi */

        case 2:
          if (!
#line 2029 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4209; /* mve_vsriq_n_sv4si */

        default:
          return -1;
        }

    case 704:
      switch (pattern75 (x1))
        {
        case 0:
          if (!
#line 2029 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4206; /* mve_vsriq_n_uv16qi */

        case 1:
          if (!
#line 2029 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4208; /* mve_vsriq_n_uv8hi */

        case 2:
          if (!
#line 2029 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4210; /* mve_vsriq_n_uv4si */

        default:
          return -1;
        }

    case 728:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4211; /* mve_vabsq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4219; /* mve_vabsq_m_fv4sf */

        default:
          return -1;
        }

    case 750:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4212; /* mve_vnegq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4220; /* mve_vnegq_m_fv4sf */

        default:
          return -1;
        }

    case 737:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4213; /* mve_vrndaq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4221; /* mve_vrndaq_m_fv4sf */

        default:
          return -1;
        }

    case 751:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4214; /* mve_vrndmq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4222; /* mve_vrndmq_m_fv4sf */

        default:
          return -1;
        }

    case 754:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4215; /* mve_vrndnq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4223; /* mve_vrndnq_m_fv4sf */

        default:
          return -1;
        }

    case 738:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4216; /* mve_vrndpq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4224; /* mve_vrndpq_m_fv4sf */

        default:
          return -1;
        }

    case 761:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4217; /* mve_vrndq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4225; /* mve_vrndq_m_fv4sf */

        default:
          return -1;
        }

    case 743:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4218; /* mve_vrndxq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4226; /* mve_vrndxq_m_fv4sf */

        default:
          return -1;
        }

    case 817:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 2070 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4227; /* mve_vaddlvaq_p_uv4si */

    case 739:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 2070 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4228; /* mve_vaddlvaq_p_sv4si */

    case 759:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4237; /* mve_vcmpeqq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4243; /* mve_vcmpeqq_m_n_fv4sf */

        default:
          return -1;
        }

    case 753:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4238; /* mve_vcmpgeq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4244; /* mve_vcmpgeq_m_n_fv4sf */

        default:
          return -1;
        }

    case 713:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4239; /* mve_vcmpgtq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4245; /* mve_vcmpgtq_m_n_fv4sf */

        default:
          return -1;
        }

    case 752:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4240; /* mve_vcmpleq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4246; /* mve_vcmpleq_m_n_fv4sf */

        default:
          return -1;
        }

    case 735:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4241; /* mve_vcmpltq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4247; /* mve_vcmpltq_m_n_fv4sf */

        default:
          return -1;
        }

    case 756:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4242; /* mve_vcmpneq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4248; /* mve_vcmpneq_m_n_fv4sf */

        default:
          return -1;
        }

    case 800:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 2130 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4249; /* mve_vcvtbq_m_f16_f32v8hf */

    case 802:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 2130 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4250; /* mve_vcvttq_m_f16_f32v8hf */

    case 801:
      if (pattern77 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4SFmode) != 0
          || !
#line 2148 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4251; /* mve_vcvtbq_m_f32_f16v4sf */

    case 803:
      if (pattern77 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4SFmode) != 0
          || !
#line 2148 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4252; /* mve_vcvttq_m_f32_f16v4sf */

    case 723:
      switch (pattern53 (x1, 
E_HFmode, 
E_SFmode))
        {
        case 0:
          if (!
#line 2165 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4253; /* mve_vdupq_m_n_fv8hf */

        case 1:
          if (!
#line 2165 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4254; /* mve_vdupq_m_n_fv4sf */

        default:
          return -1;
        }

    case 717:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2183 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4255; /* mve_vfmaq_fv8hf */

        case 1:
          if (!
#line 2183 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4257; /* mve_vfmaq_fv4sf */

        default:
          return -1;
        }

    case 744:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2183 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4256; /* mve_vfmsq_fv8hf */

        case 1:
          if (!
#line 2183 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4258; /* mve_vfmsq_fv4sf */

        default:
          return -1;
        }

    case 730:
      switch (pattern80 (x1))
        {
        case 0:
          if (!
#line 2201 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4259; /* mve_vfmaq_n_fv8hf */

        case 1:
          if (!
#line 2201 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4261; /* mve_vfmaq_n_fv4sf */

        default:
          return -1;
        }

    case 722:
      switch (pattern80 (x1))
        {
        case 0:
          if (!
#line 2201 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4260; /* mve_vfmasq_n_fv8hf */

        case 1:
          if (!
#line 2201 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4262; /* mve_vfmasq_n_fv4sf */

        default:
          return -1;
        }

    case 760:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2219 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4263; /* mve_vmaxnmaq_m_fv8hf */

        case 1:
          if (!
#line 2219 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4265; /* mve_vmaxnmaq_m_fv4sf */

        default:
          return -1;
        }

    case 721:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2219 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4264; /* mve_vminnmaq_m_fv8hf */

        case 1:
          if (!
#line 2219 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4266; /* mve_vminnmaq_m_fv4sf */

        default:
          return -1;
        }

    case 729:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4267; /* mve_vmaxnmavq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4271; /* mve_vmaxnmavq_p_fv4sf */

        default:
          return -1;
        }

    case 746:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4268; /* mve_vmaxnmvq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4272; /* mve_vmaxnmvq_p_fv4sf */

        default:
          return -1;
        }

    case 755:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4269; /* mve_vminnmavq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4273; /* mve_vminnmavq_p_fv4sf */

        default:
          return -1;
        }

    case 745:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4270; /* mve_vminnmvq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4274; /* mve_vminnmvq_p_fv4sf */

        default:
          return -1;
        }

    case 782:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4275; /* mve_vmlaldavaq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4280; /* mve_vmlaldavaq_sv4si */

        default:
          return -1;
        }

    case 783:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4276; /* mve_vmlaldavaq_uv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4281; /* mve_vmlaldavaq_uv4si */

        default:
          return -1;
        }

    case 797:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4277; /* mve_vmlaldavaxq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4282; /* mve_vmlaldavaxq_sv4si */

        default:
          return -1;
        }

    case 718:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4278; /* mve_vmlsldavaq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4283; /* mve_vmlsldavaq_sv4si */

        default:
          return -1;
        }

    case 742:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4279; /* mve_vmlsldavaxq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4284; /* mve_vmlsldavaxq_sv4si */

        default:
          return -1;
        }

    case 763:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4285; /* mve_vmlaldavq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4290; /* mve_vmlaldavq_p_sv4si */

        default:
          return -1;
        }

    case 762:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4286; /* mve_vmlaldavq_p_uv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4291; /* mve_vmlaldavq_p_uv4si */

        default:
          return -1;
        }

    case 790:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4287; /* mve_vmlaldavxq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4292; /* mve_vmlaldavxq_p_sv4si */

        default:
          return -1;
        }

    case 714:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4288; /* mve_vmlsldavq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4293; /* mve_vmlsldavq_p_sv4si */

        default:
          return -1;
        }

    case 716:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4289; /* mve_vmlsldavxq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4294; /* mve_vmlsldavxq_p_sv4si */

        default:
          return -1;
        }

    case 780:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4295; /* mve_vmovlbq_m_uv16qi */

        case 1:
          if (!
#line 2298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4299; /* mve_vmovlbq_m_uv8hi */

        default:
          return -1;
        }

    case 781:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4296; /* mve_vmovlbq_m_sv16qi */

        case 1:
          if (!
#line 2298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4300; /* mve_vmovlbq_m_sv8hi */

        default:
          return -1;
        }

    case 766:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4297; /* mve_vmovltq_m_uv16qi */

        case 1:
          if (!
#line 2298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4301; /* mve_vmovltq_m_uv8hi */

        default:
          return -1;
        }

    case 767:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4298; /* mve_vmovltq_m_sv16qi */

        case 1:
          if (!
#line 2298 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4302; /* mve_vmovltq_m_sv8hi */

        default:
          return -1;
        }

    case 769:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4303; /* mve_vmovnbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4313; /* mve_vmovnbq_m_sv4si */

        default:
          return -1;
        }

    case 768:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4304; /* mve_vmovnbq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4314; /* mve_vmovnbq_m_uv4si */

        default:
          return -1;
        }

    case 779:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4305; /* mve_vmovntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4315; /* mve_vmovntq_m_sv4si */

        default:
          return -1;
        }

    case 778:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4306; /* mve_vmovntq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4316; /* mve_vmovntq_m_uv4si */

        default:
          return -1;
        }

    case 764:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4307; /* mve_vqmovnbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4317; /* mve_vqmovnbq_m_sv4si */

        default:
          return -1;
        }

    case 765:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4308; /* mve_vqmovnbq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4318; /* mve_vqmovnbq_m_uv4si */

        default:
          return -1;
        }

    case 792:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4309; /* mve_vqmovntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4319; /* mve_vqmovntq_m_sv4si */

        default:
          return -1;
        }

    case 791:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4310; /* mve_vqmovntq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4320; /* mve_vqmovntq_m_uv4si */

        default:
          return -1;
        }

    case 740:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4311; /* mve_vqmovunbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4321; /* mve_vqmovunbq_m_sv4si */

        default:
          return -1;
        }

    case 748:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4312; /* mve_vqmovuntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4322; /* mve_vqmovuntq_m_sv4si */

        default:
          return -1;
        }

    case 793:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2337 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4323; /* mve_vmvnq_m_n_uv8hi */

        case 1:
          if (!
#line 2337 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4325; /* mve_vmvnq_m_n_uv4si */

        default:
          return -1;
        }

    case 794:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2337 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4324; /* mve_vmvnq_m_n_sv8hi */

        case 1:
          if (!
#line 2337 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4326; /* mve_vmvnq_m_n_sv4si */

        default:
          return -1;
        }

    case 609:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4327; /* mve_vbicq_m_n_sv8hi */

        case 1:
          if (!
#line 2355 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4331; /* mve_vbicq_m_n_sv4si */

        default:
          return -1;
        }

    case 610:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4328; /* mve_vbicq_m_n_uv8hi */

        case 1:
          if (!
#line 2355 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4332; /* mve_vbicq_m_n_uv4si */

        default:
          return -1;
        }

    case 772:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4329; /* mve_vorrq_m_n_sv8hi */

        case 1:
          if (!
#line 2355 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4333; /* mve_vorrq_m_n_sv4si */

        default:
          return -1;
        }

    case 773:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4330; /* mve_vorrq_m_n_uv8hi */

        case 1:
          if (!
#line 2355 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4334; /* mve_vorrq_m_n_uv4si */

        default:
          return -1;
        }

    case 747:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2372 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4335; /* mve_vpselq_fv8hf */

        case 1:
          if (!
#line 2372 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4336; /* mve_vpselq_fv4sf */

        default:
          return -1;
        }

    case 732:
      if (pattern86 (x1, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 2389 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4337; /* mve_vrev32q_m_fv8hf */

    case 774:
      switch (pattern87 (x1))
        {
        case 0:
          if (!
#line 2406 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4338; /* mve_vrev32q_m_sv16qi */

        case 1:
          if (!
#line 2406 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4340; /* mve_vrev32q_m_sv8hi */

        default:
          return -1;
        }

    case 775:
      switch (pattern87 (x1))
        {
        case 0:
          if (!
#line 2406 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4339; /* mve_vrev32q_m_uv16qi */

        case 1:
          if (!
#line 2406 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4341; /* mve_vrev32q_m_uv8hi */

        default:
          return -1;
        }

    case 749:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2423 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4342; /* mve_vrev64q_m_fv8hf */

        case 1:
          if (!
#line 2423 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4343; /* mve_vrev64q_m_fv4sf */

        default:
          return -1;
        }

    case 757:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4344; /* mve_vrmlaldavhq_p_sv4si */

    case 816:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4345; /* mve_vrmlaldavhq_p_uv4si */

    case 758:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4346; /* mve_vrmlaldavhxq_p_sv4si */

    case 726:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4347; /* mve_vrmlsldavhq_p_sv4si */

    case 731:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4348; /* mve_vrmlsldavhxq_p_sv4si */

    case 811:
      if (pattern86 (x1, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 2479 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4353; /* mve_vrev16q_m_sv16qi */

    case 812:
      if (pattern86 (x1, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 2479 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4354; /* mve_vrev16q_m_uv16qi */

    case 814:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 2496 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4355; /* mve_vcvtq_m_from_f_uv8hi */

        case 1:
          if (!
#line 2496 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4357; /* mve_vcvtq_m_from_f_uv4si */

        default:
          return -1;
        }

    case 815:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 2496 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4356; /* mve_vcvtq_m_from_f_sv8hi */

        case 1:
          if (!
#line 2496 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4358; /* mve_vcvtq_m_from_f_sv4si */

        default:
          return -1;
        }

    case 1020:
      return recog_71 (x1, insn, pnum_clobbers);

    case 1022:
      return recog_78 (x1, insn, pnum_clobbers);

    case 1001:
      return recog_69 (x1, insn, pnum_clobbers);

    case 1003:
      return recog_87 (x1, insn, pnum_clobbers);

    case 999:
      return recog_74 (x1, insn, pnum_clobbers);

    case 1009:
      return recog_63 (x1, insn, pnum_clobbers);

    case 1014:
      return recog_73 (x1, insn, pnum_clobbers);

    case 1015:
      return recog_65 (x1, insn, pnum_clobbers);

    case 1025:
      return recog_72 (x1, insn, pnum_clobbers);

    case 1027:
      if (pattern93 (x1) != 0
          || !
#line 3678 "../../gcc-15.1.0/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4931; /* mve_vstrq_truncate_scatter_shifted_offset_v4si */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 25
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      operands[1] = x8;
      if (!memory_operand (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5036 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(unaligned_access && TARGET_32BIT)))
        return -1;
      return 6475; /* *p unaligned_loadhis */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          if (nonimmediate_operand (operands[1], E_HImode))
            {
              if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5927 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
                return 6494; /* *p *arm_extendhisi2 */
              if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5940 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6)))
                return 6495; /* *p *arm_extendhisi2_v6 */
            }
          if (arm_reg_or_extendqisi_mem_op (operands[1], E_QImode))
            {
              if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6021 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
                return 6497; /* *p *arm_extendqisi */
              if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6034 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
                return 6498; /* *p *arm_extendqisi_v6 */
            }
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1094 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6983; /* *p *thumb2_extendqisi_v6 */

        case E_HImode:
          if (!s_register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !arm_extendqisi_mem_op (operands[1], E_QImode)
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5984 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4)))
            return -1;
          return 6496; /* *p *arm_extendqihi_insn */

        default:
          return -1;
        }

    case BSWAP:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12555 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(arm_arch6)))
        return -1;
      return 6604; /* *p *arm_revsh */

    case VEC_SELECT:
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (pattern543 (x5))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 736 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6727; /* *p iwmmxt_textrmsb */

        case 1:
          if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 758 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6729; /* *p iwmmxt_textrmsh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern312 (x1))
    {
    case 0:
      if ((
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4360 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
        return 6460; /* *p arm_qadd_insn */
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4360 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ)))
        return -1;
      return 6461; /* *p arm_qadd_setq_insn */

    case 1:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 351 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6693; /* *p ssaddv8qi3 */

    case 2:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 361 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6694; /* *p ssaddv4hi3 */

    case 3:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 371 "../../gcc-15.1.0/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6695; /* *p ssaddv2si3 */

    case 4:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7022; /* *p *arm_ssaddv4qq3 */

    case 5:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7023; /* *p *arm_ssaddv2hq3 */

    case 6:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7024; /* *p *arm_ssaddqq3 */

    case 7:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7025; /* *p *arm_ssaddhq3 */

    case 8:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7026; /* *p *arm_ssaddv2ha3 */

    case 9:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7027; /* *p *arm_ssaddha3 */

    case 10:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return -1;
      return 7028; /* *p *arm_ssaddsq3 */

    case 11:
      if (!(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.1.0/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return -1;
      return 7029; /* *p *arm_ssaddsa3 */

    default:
      return -1;
    }
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case MEM:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != MEM
          || pattern546 (x8) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 0);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x7, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x8, 0);
          x13 = XEXP (x12, 1);
          if (XWINT (x13, 0) != 4L)
            return -1;
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[3])
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 855 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6654; /* *p *ldm2_ */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x15 = XEXP (x11, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x16 = XEXP (x11, 0);
          operands[3] = x16;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x8, 0);
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[3]))
            return -1;
          switch (XWINT (x15, 0))
            {
            case 4L:
              x13 = XEXP (x12, 1);
              if (XWINT (x13, 0) != 8L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 942 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6658; /* *p *ldm2_ib */

            case -8L:
              x13 = XEXP (x12, 1);
              if (XWINT (x13, 0) != -4L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1044 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6666; /* *p *ldm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      operands[1] = x7;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x3, 0);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x4, 0);
      if (pattern573 (x10) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x17 = XEXP (x9, 0);
      switch (GET_CODE (x17))
        {
        case REG:
        case SUBREG:
          operands[3] = x17;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x18 = XEXP (x10, 0);
          x19 = XEXP (x18, 1);
          if (XWINT (x19, 0) != 4L)
            return -1;
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[3])
              || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 904 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6656; /* *p *stm2_ */

        case PLUS:
          if (GET_MODE (x17) != E_SImode)
            return -1;
          x21 = XEXP (x17, 1);
          if (GET_CODE (x21) != CONST_INT)
            return -1;
          x22 = XEXP (x17, 0);
          operands[3] = x22;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x18 = XEXP (x10, 0);
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[3]))
            return -1;
          switch (XWINT (x21, 0))
            {
            case 4L:
              x19 = XEXP (x18, 1);
              if (XWINT (x19, 0) != 8L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 968 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6660; /* *p *stm2_ib */

            case -8L:
              x19 = XEXP (x18, 1);
              if (XWINT (x19, 0) != -4L
                  || !(
#line 12240 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1070 "../../gcc-15.1.0/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6668; /* *p *stm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (arm_general_register_operand (operands[0], E_DImode)
              && arm_general_register_operand (operands[1], E_DImode)
              && 
#line 6424 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_54 (insn, operands);
          break;

        case E_DFmode:
          if (arm_general_register_operand (operands[0], E_DFmode)
              && arm_general_register_operand (operands[1], E_DFmode)
              && 
#line 6424 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_55 (insn, operands);
          break;

        case E_V8QImode:
          if (arm_general_register_operand (operands[0], E_V8QImode)
              && arm_general_register_operand (operands[1], E_V8QImode)
              && 
#line 6424 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_56 (insn, operands);
          break;

        case E_V4HImode:
          if (arm_general_register_operand (operands[0], E_V4HImode)
              && arm_general_register_operand (operands[1], E_V4HImode)
              && 
#line 6424 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_57 (insn, operands);
          break;

        case E_V4BFmode:
          if (arm_general_register_operand (operands[0], E_V4BFmode)
              && arm_general_register_operand (operands[1], E_V4BFmode)
              && 
#line 6424 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_58 (insn, operands);
          break;

        case E_V4HFmode:
          if (arm_general_register_operand (operands[0], E_V4HFmode)
              && arm_general_register_operand (operands[1], E_V4HFmode)
              && 
#line 6424 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_59 (insn, operands);
          break;

        case E_V2SImode:
          if (arm_general_register_operand (operands[0], E_V2SImode)
              && arm_general_register_operand (operands[1], E_V2SImode)
              && 
#line 6424 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_60 (insn, operands);
          break;

        case E_V2SFmode:
          if (arm_general_register_operand (operands[0], E_V2SFmode)
              && arm_general_register_operand (operands[1], E_V2SFmode)
              && 
#line 6424 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_61 (insn, operands);
          break;

        case E_EImode:
          if (s_register_operand (operands[0], E_EImode)
              && s_register_operand (operands[1], E_EImode)
              && 
#line 201 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
            return gen_split_152 (insn, operands);
          break;

        case E_OImode:
          if (s_register_operand (operands[0], E_OImode)
              && s_register_operand (operands[1], E_OImode)
              && 
#line 220 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed))
            return gen_split_153 (insn, operands);
          break;

        case E_V2x16QImode:
          if (s_register_operand (operands[0], E_V2x16QImode)
              && s_register_operand (operands[1], E_V2x16QImode)
              && (
#line 220 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 157 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_154 (insn, operands);
          break;

        case E_V2x8HImode:
          if (s_register_operand (operands[0], E_V2x8HImode)
              && s_register_operand (operands[1], E_V2x8HImode)
              && (
#line 220 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 158 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_155 (insn, operands);
          break;

        case E_V2x4SImode:
          if (s_register_operand (operands[0], E_V2x4SImode)
              && s_register_operand (operands[1], E_V2x4SImode)
              && (
#line 220 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 159 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_156 (insn, operands);
          break;

        case E_V2x8HFmode:
          if (s_register_operand (operands[0], E_V2x8HFmode)
              && s_register_operand (operands[1], E_V2x8HFmode)
              && (
#line 220 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 160 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_157 (insn, operands);
          break;

        case E_V2x4SFmode:
          if (s_register_operand (operands[0], E_V2x4SFmode)
              && s_register_operand (operands[1], E_V2x4SFmode)
              && (
#line 220 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 161 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_158 (insn, operands);
          break;

        case E_CImode:
          if (s_register_operand (operands[0], E_CImode)
              && s_register_operand (operands[1], E_CImode)
              && 
#line 239 "../../gcc-15.1.0/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
            return gen_split_159 (insn, operands);
          break;

        case E_XImode:
          if (s_register_operand (operands[0], E_XImode)
              && s_register_operand (operands[1], E_XImode)
              && 
#line 261 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed))
            return gen_split_160 (insn, operands);
          break;

        case E_V4x16QImode:
          if (s_register_operand (operands[0], E_V4x16QImode)
              && s_register_operand (operands[1], E_V4x16QImode)
              && (
#line 261 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 166 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_161 (insn, operands);
          break;

        case E_V4x8HImode:
          if (s_register_operand (operands[0], E_V4x8HImode)
              && s_register_operand (operands[1], E_V4x8HImode)
              && (
#line 261 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 167 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_162 (insn, operands);
          break;

        case E_V4x4SImode:
          if (s_register_operand (operands[0], E_V4x4SImode)
              && s_register_operand (operands[1], E_V4x4SImode)
              && (
#line 261 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 168 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_163 (insn, operands);
          break;

        case E_V4x8HFmode:
          if (s_register_operand (operands[0], E_V4x8HFmode)
              && s_register_operand (operands[1], E_V4x8HFmode)
              && (
#line 261 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 169 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_164 (insn, operands);
          break;

        case E_V4x4SFmode:
          if (s_register_operand (operands[0], E_V4x4SFmode)
              && s_register_operand (operands[1], E_V4x4SFmode)
              && (
#line 261 "../../gcc-15.1.0/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 170 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_165 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case MEM:
      if (GET_MODE (x2) == E_DImode)
        {
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) == PLUS
              && GET_MODE (x4) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (s_register_operand (operands[0], E_DImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x4, 1);
                      operands[2] = x6;
                      if (s_register_operand (operands[2], E_SImode)
                          && 
#line 6454 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_LDRD
  && reg_overlap_mentioned_p (operands[0], operands[1])
  && reg_overlap_mentioned_p (operands[0], operands[2])))
                        return gen_split_62 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (arm_general_register_operand (operands[0], E_SImode)
      && general_operand (operands[1], E_SImode)
      && 
#line 6638 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_USE_MOVT && GET_CODE (operands[1]) == SYMBOL_REF
   && !target_word_relocations
   && !arm_tls_referenced_p (operands[1])))
    return gen_split_65 (insn, operands);
  if (register_operand (operands[0], E_SImode)
      && const_int_operand (operands[1], E_SImode))
    {
      if (
#line 767 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_J (operands[1])))
        return gen_split_126 (insn, operands);
      if (
#line 780 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_K (operands[1])
   && !(TARGET_HAVE_MOVT && satisfies_constraint_j (operands[1]))))
        return gen_split_127 (insn, operands);
      if (
#line 808 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_Pe (operands[1])
   && !(TARGET_HAVE_MOVT && satisfies_constraint_j (operands[1]))))
        return gen_split_128 (insn, operands);
      if (
#line 823 "../../gcc-15.1.0/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && arm_disable_literal_pool
   && GET_CODE (operands[1]) == CONST_INT
   && !TARGET_HAVE_MOVT
   && !satisfies_constraint_K (operands[1])))
        return gen_split_129 (insn, operands);
    }
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return NULL;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x6 = XEXP (x4, 1);
  if (pattern317 (x6, 
1) != 0)
    return NULL;
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  if (!
#line 6674 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(flag_pic))
    return NULL;
  return gen_split_66 (insn, operands);
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_11 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_10 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != UNSPEC
              || XVECLEN (x3, 0) != 1
              || pattern285 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER
              || pattern451 (x1) != 0
              || !
#line 9306 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(reload_completed))
            return NULL;
          return gen_split_75 (insn, operands);

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case IF_THEN_ELSE:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != EQ)
                return NULL;
              x8 = XEXP (x7, 1);
              if (pattern297 (x8) != 0)
                return NULL;
              x9 = XEXP (x3, 1);
              if (GET_CODE (x9) != LABEL_REF)
                return NULL;
              x10 = XEXP (x3, 2);
              if (GET_CODE (x10) != PC)
                return NULL;
              x11 = XEXP (x2, 0);
              if (GET_CODE (x11) != PC)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER
                  || pattern577 (x1) != 0
                  || !
#line 9395 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(reload_completed))
                return NULL;
              return gen_split_76 (insn, operands);

            case UNSPEC_VOLATILE:
              switch (pattern265 (x1))
                {
                case 0:
                  if (!((
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 252 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_177 (insn, operands);

                case 1:
                  if (!((
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 252 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_179 (insn, operands);

                case 2:
                  if (!((
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 252 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_178 (insn, operands);

                case 3:
                  if (!((
#line 250 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 252 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_180 (insn, operands);

                case 4:
                  if (!((
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 283 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_181 (insn, operands);

                case 5:
                  if (!((
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 283 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_183 (insn, operands);

                case 6:
                  if (!((
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 283 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_182 (insn, operands);

                case 7:
                  if (!((
#line 281 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.1.0/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 283 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_184 (insn, operands);

                case 8:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_189 (insn, operands);

                case 9:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_194 (insn, operands);

                case 10:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_199 (insn, operands);

                case 11:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_204 (insn, operands);

                case 12:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_190 (insn, operands);

                case 13:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_195 (insn, operands);

                case 14:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_200 (insn, operands);

                case 15:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_205 (insn, operands);

                case 16:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_191 (insn, operands);

                case 17:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_196 (insn, operands);

                case 18:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_201 (insn, operands);

                case 19:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_206 (insn, operands);

                case 20:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_192 (insn, operands);

                case 21:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_197 (insn, operands);

                case 22:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_202 (insn, operands);

                case 23:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_207 (insn, operands);

                case 24:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_193 (insn, operands);

                case 25:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                case 26:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_203 (insn, operands);

                case 27:
                  if (!(
#line 342 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_208 (insn, operands);

                case 28:
                  if (!(
#line 366 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_209 (insn, operands);

                case 29:
                  if (!(
#line 366 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_210 (insn, operands);

                case 30:
                  if (!(
#line 366 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_211 (insn, operands);

                case 31:
                  if (!(
#line 366 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_212 (insn, operands);

                default:
                  return NULL;
                }

            case MEM:
              operands[1] = x3;
              if (pattern319 (x1, 
18, 
2) != 0)
                return NULL;
              x11 = XEXP (x2, 0);
              operands[0] = x11;
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              operands[2] = x13;
              x14 = XVECEXP (x12, 0, 1);
              operands[3] = x14;
              if (!const_int_operand (operands[3], E_SImode))
                return NULL;
              x15 = XEXP (x6, 0);
              operands[4] = x15;
              if (!scratch_operand (operands[4], E_SImode))
                return NULL;
              x16 = XEXP (x4, 0);
              if (!rtx_equal_p (x16, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern576 (x12, 
E_QImode) != 0
                      || !(
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_185 (insn, operands);

                case E_HImode:
                  if (pattern576 (x12, 
E_HImode) != 0
                      || !(
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_186 (insn, operands);

                case E_SImode:
                  if (pattern576 (x12, 
E_SImode) != 0
                      || !(
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_187 (insn, operands);

                case E_DImode:
                  if (pattern576 (x12, 
E_DImode) != 0
                      || !(
#line 301 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_188 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_237 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_242 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_247 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_252 (insn, operands);

                default:
                  return NULL;
                }

            case MINUS:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_238 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_243 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_248 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_253 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_239 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_244 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_249 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_254 (insn, operands);

                default:
                  return NULL;
                }

            case XOR:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_240 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_245 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_250 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_255 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_241 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_246 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_251 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_256 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != AND
                  || pattern319 (x1, 
19, 
3) != 0)
                return NULL;
              switch (pattern531 (x1))
                {
                case 0:
                  if (!(
#line 483 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_257 (insn, operands);

                case 1:
                  if (!(
#line 483 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_258 (insn, operands);

                case 2:
                  if (!(
#line 483 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_259 (insn, operands);

                case 3:
                  if (!(
#line 483 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_260 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET
              || pattern12 (x1) != 0)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          switch (pattern565 (x1))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_213 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_218 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_223 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_228 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_214 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_219 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_224 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_229 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_220 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_225 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_230 (insn, operands);

                default:
                  return NULL;
                }

            case 3:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_216 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_221 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_226 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_231 (insn, operands);

                default:
                  return NULL;
                }

            case 4:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_217 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_222 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_227 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_232 (insn, operands);

                default:
                  return NULL;
                }

            case 5:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              x17 = XEXP (x13, 0);
              if (GET_CODE (x17) != AND)
                return NULL;
              x18 = XEXP (x17, 1);
              operands[2] = x18;
              x19 = XEXP (x17, 0);
              if (!rtx_equal_p (x19, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern622 (x12, 
E_QImode) != 0
                      || !(
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_233 (insn, operands);

                case E_HImode:
                  if (pattern622 (x12, 
E_HImode) != 0
                      || !(
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_234 (insn, operands);

                case E_SImode:
                  if (pattern622 (x12, 
E_SImode) != 0
                      || !(
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_235 (insn, operands);

                case E_DImode:
                  if (pattern623 (x12) != 0
                      || !(
#line 432 "../../gcc-15.1.0/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.1.0/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_236 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COND_EXEC:
      x20 = XEXP (x1, 0);
      if (!arm_comparison_operator (x20, E_VOIDmode))
        return NULL;
      x21 = XEXP (x20, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x22 = XEXP (x20, 0);
      if (!cc_register (x22, E_VOIDmode))
        return NULL;
      x23 = XEXP (x1, 1);
      switch (GET_CODE (x23))
        {
        case SET:
          x24 = XEXP (x23, 1);
          switch (GET_CODE (x24))
            {
            case PLUS:
              if (pattern320 (x1) != 0
                  || !
#line 962 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_op (INTVAL (operands[2]), PLUS)
   && (reload_completed || !arm_eliminable_register (operands[1]))))
                return NULL;
              return gen_split_261 (insn, operands);

            case MINUS:
              if (GET_MODE (x24) != E_SImode)
                return NULL;
              operands[3] = x20;
              operands[4] = x22;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x26 = XEXP (x24, 0);
              operands[1] = x26;
              if (!reg_or_int_operand (operands[1], E_SImode))
                return NULL;
              x27 = XEXP (x24, 1);
              operands[2] = x27;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 2020 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 2031 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( (CONST_INT_P (operands[1])
       && !const_ok_for_arm (INTVAL (operands[1]))))))
                return NULL;
              return gen_split_262 (insn, operands);

            case AND:
              if (GET_MODE (x24) != E_SImode)
                return NULL;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x26 = XEXP (x24, 0);
              switch (GET_CODE (x26))
                {
                case REG:
                case SUBREG:
                  operands[1] = x26;
                  if (!s_register_operand (operands[1], E_SImode))
                    return NULL;
                  operands[3] = x20;
                  operands[4] = x22;
                  x27 = XEXP (x24, 1);
                  operands[2] = x27;
                  if (!reg_or_int_operand (operands[2], E_SImode)
                      || !
#line 3031 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
	|| const_ok_for_arm (~INTVAL (operands[2]))
	|| (arm_arch_thumb2
	    && satisfies_constraint_Dj (operands[2])
	    && (rtx_equal_p (operands[0], operands[1])
		|| !reload_completed)))))
                    return NULL;
                  return gen_split_263 (insn, operands);

                case IOR:
                  if (GET_MODE (x26) != E_SImode)
                    return NULL;
                  x27 = XEXP (x24, 1);
                  if (GET_CODE (x27) != NOT
                      || GET_MODE (x27) != E_SImode)
                    return NULL;
                  operands[4] = x20;
                  operands[5] = x22;
                  x28 = XEXP (x26, 0);
                  operands[1] = x28;
                  if (!s_register_operand (operands[1], E_SImode))
                    return NULL;
                  x29 = XEXP (x26, 1);
                  operands[2] = x29;
                  if (!arm_rhs_operand (operands[2], E_SImode))
                    return NULL;
                  x30 = XEXP (x27, 0);
                  operands[3] = x30;
                  if (!arm_rhs_operand (operands[3], E_SImode)
                      || !(
#line 3910 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 3912 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
                    return NULL;
                  return gen_split_267 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
              if (XWINT (x24, 0) != 0L)
                return NULL;
              x25 = XEXP (x23, 0);
              if (GET_CODE (x25) != ZERO_EXTRACT
                  || GET_MODE (x25) != E_SImode)
                return NULL;
              operands[3] = x20;
              operands[4] = x22;
              x31 = XEXP (x25, 0);
              operands[0] = x31;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x32 = XEXP (x25, 1);
              operands[1] = x32;
              if (!const_int_M_operand (operands[1], E_SImode))
                return NULL;
              x33 = XEXP (x25, 2);
              operands[2] = x33;
              if (!const_int_M_operand (operands[2], E_SImode))
                return NULL;
              return gen_split_264 (insn, operands);

            case IOR:
              if (pattern320 (x1) != 0
                  || !
#line 3744 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
        || (TARGET_THUMB2 && const_ok_for_arm (~INTVAL (operands[2]))))))
                return NULL;
              return gen_split_265 (insn, operands);

            case XOR:
              if (pattern320 (x1) != 0
                  || !
#line 3849 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_arm (INTVAL (operands[2]))))
                return NULL;
              return gen_split_266 (insn, operands);

            case NEG:
              if (GET_MODE (x24) != E_DFmode)
                return NULL;
              operands[2] = x20;
              operands[3] = x22;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_DFmode))
                return NULL;
              x26 = XEXP (x24, 0);
              operands[1] = x26;
              if (!s_register_operand (operands[1], E_DFmode)
                  || !
#line 906 "../../gcc-15.1.0/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE && reload_completed
   && arm_general_register_operand (operands[0], DFmode)))
                return NULL;
              return gen_split_270 (insn, operands);

            default:
              return NULL;
            }

        case PARALLEL:
          if (XVECLEN (x23, 0) != 2)
            return NULL;
          x34 = XVECEXP (x23, 0, 0);
          if (GET_CODE (x34) != SET
              || pattern363 (x1) != 0)
            return NULL;
          x35 = XEXP (x34, 0);
          operands[0] = x35;
          if (!s_register_operand (operands[0], E_SImode))
            return NULL;
          x36 = XEXP (x34, 1);
          if (GET_MODE (x36) != E_SImode)
            return NULL;
          switch (GET_CODE (x36))
            {
            case ABS:
              x37 = XEXP (x36, 0);
              operands[1] = x37;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 5255 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5257 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_268 (insn, operands);
              if (!(
#line 117 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 122 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_271 (insn, operands);

            case NEG:
              x37 = XEXP (x36, 0);
              if (GET_CODE (x37) != ABS
                  || GET_MODE (x37) != E_SImode)
                return NULL;
              x38 = XEXP (x37, 0);
              operands[1] = x38;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 5319 "../../gcc-15.1.0/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5321 "../../gcc-15.1.0/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_269 (insn, operands);
              if (!(
#line 170 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 175 "../../gcc-15.1.0/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_272 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
